# Generated by Makefile. Do not edit.

commit 622fc6dde99ee172ebaa9c8628d85a7a1995a21d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 9 00:01:14 2023 +0100

    Update NEWS for 4.3.5

 NEWS | 37 +++++++++++++++++++++++++++++++++++++
 1 file changed, 37 insertions(+)

commit 5cf39bf0cebab06c75f8f4c5c4fba4afed153455
Merge: 8cdc4ed7 5712ad51
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 9 10:36:47 2023 +0100

    Merge pull request #4598 from brettviren/reimplement-proxy-steerable

    A clean room re-implementation of zmq_proxy_steerable()

commit 5712ad51387d63cecdf797684cc72dp188007cbd
Author: Brett Viren <brett.viren@gmail.com>
Date:   Sun Oct 8 19:56:03 2023 -0400

    A clean-room implementation of zmq_proxy_steerable().

    It is contriubted under the MPL-2.0.

    I had no knowledge of the previous implementation of zmq_proxy_steerable().

    This version was developed based on expectations set in the old man page with one exception.  This version uses a REP/REQ for the proxy control protocol sockets.  The old man page example used PUB/SUB which is nonsensical given the STATISTICS command requires two way communication.

 AUTHORS                        |   1 +
 Makefile.am                    |   5 +
 doc/zmq_proxy_steerable.txt    | 101 +++++++++-
 src/proxy.cpp                  | 198 +++++++++++++++---
 src/proxy.hpp                  |   5 +
 src/zmq.cpp                    |  13 +-
 tests/CMakeLists.txt           |   1 +
 tests/test_proxy_steerable.cpp | 441 +++++++++++++++++++++++++++++++++++++++++
 8 files changed, 724 insertions(+), 41 deletions(-)

commit 8cdc4ed71a3170576a06d4b5e62801424fa6acce
Author: Nehal Patel <hereisnehal@gmail.com>
Date:   Wed Oct 4 01:51:43 2023 -0700

    Problem: unused variables warnings

    Solution: fix them

 src/ip.cpp                            | 3 +++
 src/zmq.cpp                           | 2 ++
 src/zmtp_engine.cpp                   | 3 +++
 tests/test_bind_fuzzer.cpp            | 3 +++
 tests/test_bind_null_fuzzer.cpp       | 2 ++
 tests/test_connect_fuzzer.cpp         | 3 +++
 tests/test_connect_null_fuzzer.cpp    | 3 +++
 tests/test_poller.cpp                 | 1 +
 tests/test_reconnect_options.cpp      | 2 ++
 tests/test_socks.cpp                  | 1 +
 tests/test_spec_dealer.cpp            | 1 +
 tests/test_spec_pushpull.cpp          | 1 +
 unittests/unittest_curve_encoding.cpp | 8 ++++----
 unittests/unittest_mtrie.cpp          | 3 +++
 14 files changed, 32 insertions(+), 4 deletions(-)

commit de5ee18203f4ba472812fd08665603cd3f88955d
Author: Hennadii Stepanov <32963518+hebasto@users.noreply.github.com>
Date:   Sat Aug 26 17:53:24 2023 +0100

    Replace `egrep` with `grep -E`

    For the GNU Grep package version >= 3.8, the `egrep` command emits:
    ```
    egrep: warning: egrep is obsolescent; using grep -E
    ```
    which makes the `./autogen.sh` script very noisy.

 Jenkinsfile         | 2 +-
 builds/zos/runtests | 4 ++--
 version.sh          | 6 +++---
 3 files changed, 6 insertions(+), 6 deletions(-)

commit ec013f3a17beaa475c18e8cf5e93970800e2f94a
Author: Jeffery Weston <Jeffery.Weston@nrl.navy.mil>
Date:   Fri Jul 21 14:34:53 2023 -0400

    fix assert error on late-joining subscriber after publisher has filled NORM buffer

 src/norm_engine.cpp | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit ecc63d0d3b0e1a62c90b58b1ccdb5ac16cb2400a
Author: Cornelius <cornelius.soell@rohde-schwarz.com>
Date:   Tue Jun 20 16:17:26 2023 +0200

    Problem: long flag isn't set for subscriptions if topic has between 246 and 255 characters (#4564)

    * Problem: long flag isn't set for subscriptions if topic has between 246 and 255 characters

    Solution: fix V3.1 encoder to calculate long flag after evaluating the subscribe and cancel commands

 Makefile.am               |  5 +++
 src/v3_1_encoder.cpp      |  6 ++--
 tests/CMakeLists.txt      |  1 +
 tests/test_xpub_topic.cpp | 85 +++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 95 insertions(+), 2 deletions(-)

commit 7af09a0e3bca37d9da21a1bca2ab27e494b4e3d8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jun 18 15:40:05 2023 +0100

    obs: trigger build on merge

 .obs/workflows.yml | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 61fd887d117927876ba2b2cc40408ca0553d8c54
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jun 18 13:06:57 2023 +0100

    spec: do not attempt to install curve_keygen if curve is disabled

 packaging/redhat/zeromq.spec | 2 ++
 1 file changed, 2 insertions(+)

commit 7fef478481615bfbec3d3383a63e80c5b864c5a1
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jun 18 12:51:43 2023 +0100

    spec: remove duplicated macros

 packaging/redhat/zeromq.spec | 45 --------------------------------------------
 1 file changed, 45 deletions(-)

commit 5657b4586f24ec433930e8ece02ddba7afcf0fe0
Author: Guillaume DELACOURT <guillaume.delacourt@thalesgroup.com>
Date:   Mon Jun 12 10:06:01 2023 +0200

    Always allow DNS when resolving TCP and UDP adresses. DNS resolution is done after interface resolution, so it can always be enabled to have a fallback mecanism on hostname resolution.

 src/tcp_address.cpp | 2 +-
 src/udp_address.cpp | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit e0296d9cddbb0dfc4d4a1e408e1392b0caf3f6f2
Author: Guillaume DELACOURT <guillaume.delacourt@thalesgroup.com>
Date:   Tue May 23 16:11:14 2023 +0200

    Checks for pthread setname and setaffinity API are compilation checks, not execution checks.

 CMakeLists.txt                                | 28 +++++++++++++++------------
 builds/cmake/Modules/ZMQSourceRunChecks.cmake | 10 +++++-----
 2 files changed, 21 insertions(+), 17 deletions(-)

commit 797c7f09f85a55fb530f3d4cf3b05924470b1198
Author: Guillaume DELACOURT <guillaume.delacourt@thalesgroup.com>
Date:   Tue May 23 16:40:46 2023 +0200

    When setting thread priority, always set the value to zero when the policy is not compatible. Also, only call nice when the priority is set to a strictly positive value.

 doc/zmq_ctx_set.txt |  3 ++-
 src/thread.cpp      | 17 ++++++++---------
 2 files changed, 10 insertions(+), 10 deletions(-)

commit 5bf04ee2ff207f0eaf34298658fe354ea61e1839
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 6 18:02:05 2023 +0100

    Problem: docs for ZMQ_RECONNECT_IVL_MAX are stubs

    Solution: write them now that the option is back

 doc/zmq_getsockopt.txt | 22 +++++++++++++++++-----
 doc/zmq_setsockopt.txt | 22 +++++++++++++++++-----
 2 files changed, 34 insertions(+), 10 deletions(-)

commit 346907065f9c63af789af28a22dce2c0b77aa597
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 6 18:00:08 2023 +0100

    Problem: trailing whitespace

    Solution: remove it

 src/options.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7175f0acb53229360618754162bceb6986511a04
Merge: 1a921db7 de1bd5c8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 6 16:40:57 2023 +0100

    Merge pull request #4556 from stvales/master

    Problem: relicensing forced to remove support for ZMQ_RECONNECT_IVL_MAX option

commit de1bd5c8e744604fbfaa6d36866249d70cf272d0
Author: Stéphane Valès <7755128+stvales@users.noreply.github.com>
Date:   Tue Jun 6 11:12:03 2023 +0200

    Problem: relicensing forced to remove support for ZMQ_RECONNECT_IVL_MAX option

    Solution: reimplement support for ZMQ_RECONNECT_IVL_MAX without knowledge of the previous code.

 src/options.cpp               | 21 +++++++++++----------
 src/options.hpp               |  4 ++++
 src/stream_connecter_base.cpp | 38 ++++++++++++++++++++++++++------------
 3 files changed, 41 insertions(+), 22 deletions(-)

commit 1a921db7280c3a450f8fe0312a78639adead1f96
Merge: 87bb4db1 3e5e405f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 6 13:50:00 2023 +0100

    Merge pull request #4555 from bluca/relicense

    Relicense from LGPL3 + exceptions to Mozilla Public License version 2.0

commit 3e5e405f336f8980ee8864ade51a252471bd63fe
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 5 01:39:25 2023 +0100

    Remove RELICENSE/ directory

    Grants archived at:

    https://github.com/rlenferink/libzmq-relicense/blob/master/RELICENSE

    No longer necessary to keep them here, as the relicensing is complete.

 RELICENSE/AnCaPepe.md                              | 15 --------------
 RELICENSE/AndreLouisCaron.md                       | 15 --------------
 RELICENSE/Asmod4n.md                               | 13 ------------
 RELICENSE/AxelNennker.md                           | 16 ---------------
 RELICENSE/Bklyn.md                                 | 15 --------------
 RELICENSE/Botje.md                                 | 15 --------------
 RELICENSE/C-Sir.md                                 | 15 --------------
 RELICENSE/CommanderBubble.md                       | 15 --------------
 RELICENSE/Cziken.md                                |  7 -------
 RELICENSE/DaiyuHurst.md                            | 16 ---------------
 RELICENSE/Eelis.md                                 | 16 ---------------
 RELICENSE/FrancoFichtner.md                        | 15 --------------
 RELICENSE/FredTreg.md                              | 13 ------------
 RELICENSE/Hugne.md                                 | 17 ----------------
 RELICENSE/Jasper-Bekkers.md                        | 13 ------------
 RELICENSE/JohanMabille.md                          | 16 ---------------
 RELICENSE/JonDyte.md                               | 15 --------------
 RELICENSE/KLNikita.md                              | 15 --------------
 RELICENSE/MartinGrigorov.md                        | 15 --------------
 RELICENSE/NLeScienceCenter.md                      | 13 ------------
 RELICENSE/Neopallium.md                            | 13 ------------
 RELICENSE/PaulThiele.md                            | 16 ---------------
 RELICENSE/Quuxplusone.md                           | 15 --------------
 RELICENSE/README.md                                | 23 ----------------------
 RELICENSE/RPGillespie6.md                          | 16 ---------------
 RELICENSE/Ricardicus.md                            |  6 ------
 RELICENSE/SRombauts.md                             | 15 --------------
 RELICENSE/SergheiNovac.md                          | 15 --------------
 RELICENSE/StephaneVales.md                         | 15 --------------
 RELICENSE/SylvainCorlay.md                         | 16 ---------------
 RELICENSE/TTimo.md                                 | 15 --------------
 RELICENSE/Teebonne.md                              | 15 --------------
 RELICENSE/ThePrez.md                               | 13 ------------
 RELICENSE/TobiSchluter.md                          | 15 --------------
 RELICENSE/WenbinHou.md                             | 15 --------------
 RELICENSE/a4z.md                                   | 17 ----------------
 RELICENSE/abdplhe                                  | 15 --------------
 RELICENSE/abbradar.md                              | 15 --------------
 RELICENSE/ackalker.md                              | 15 --------------
 RELICENSE/acsearle.md                              | 14 -------------
 RELICENSE/agronholm.md                             | 15 --------------
 RELICENSE/aixxe.md                                 | 15 --------------
 RELICENSE/ambitslix.md                             |  7 -------
 RELICENSE/amuraru.md                               | 15 --------------
 RELICENSE/analogist.md                             | 15 --------------
 RELICENSE/answeroo.md                              | 15 --------------
 RELICENSE/antonrd.md                               | 17 ----------------
 RELICENSE/ardrabczyk.md                            | 16 ---------------
 RELICENSE/arsenm.md                                | 15 --------------
 RELICENSE/asafkahlon.md                            | 15 --------------
 RELICENSE/aseering.md                              | 15 --------------
 RELICENSE/atomashpolskiy.md                        | 15 --------------
 RELICENSE/autoantwort.txt                          | 15 --------------
 RELICENSE/banburybill.md                           | 16 ---------------
 RELICENSE/bbdb68.md                                | 13 ------------
 RELICENSE/bebopagogo.md                            | 13 ------------
 RELICENSE/benjdero.md                              | 13 ------------
 RELICENSE/bjornstromberg.md                        | 16 ---------------
 RELICENSE/bjoto.md                                 | 16 ---------------
 RELICENSE/bjovke.md                                | 16 ---------------
 RELICENSE/bl0x.md                                  | 16 ---------------
 RELICENSE/bluca.md                                 | 17 ----------------
 RELICENSE/boscosiu.md                              | 15 --------------
 RELICENSE/boxkey.md                                |  7 -------
 RELICENSE/bprager.md                               | 13 ------------
 RELICENSE/brett-cameron.md                         | 15 --------------
 RELICENSE/brian-peloton.md                         | 15 --------------
 RELICENSE/brocade_communications_systems.md        | 15 --------------
 RELICENSE/brubakerjeff.md                          | 16 ---------------
 RELICENSE/bwbuchanan.md                            | 15 --------------
 RELICENSE/c-rack.md                                | 15 --------------
 RELICENSE/c-zhao-3g.md                             | 15 --------------
 RELICENSE/calid.md                                 | 14 -------------
 RELICENSE/camachat.md                              | 15 --------------
 RELICENSE/casaroli.md                              | 16 ---------------
 RELICENSE/cbusbey.md                               | 13 ------------
 RELICENSE/cdepillabout.md                          | 16 ---------------
 RELICENSE/cdolan.md                                | 15 --------------
 RELICENSE/chachoi.md                               | 15 --------------
 RELICENSE/chickenkiller.md                         | 15 --------------
 RELICENSE/chrisstaite.md                           | 14 -------------
 RELICENSE/christhrasher.md                         | 15 --------------
 RELICENSE/chuckremes.md                            | 15 --------------
 RELICENSE/chuggafan.md                             | 15 --------------
 RELICENSE/chymanfx.md                              | 12 -----------
 RELICENSE/cjuniet.md                               | 15 --------------
 RELICENSE/ckamm.md                                 | 15 --------------
 RELICENSE/claws.md                                 | 15 --------------
 RELICENSE/clkao.md                                 | 15 --------------
 RELICENSE/colletted.md                             |  7 -------
 RELICENSE/cowo78.md                                | 15 --------------
 RELICENSE/crocket.md                               | 15 --------------
 RELICENSE/cwsmith.md                               | 13 ------------
 RELICENSE/daira.md                                 | 15 --------------
 RELICENSE/danielhtshih.md                          | 15 --------------
 RELICENSE/danriegsecker.md                         | 16 ---------------
 RELICENSE/darkdragon-001.md                        | 15 --------------
 RELICENSE/demozon.md                               | 15 --------------
 RELICENSE/dennisklein.md                           | 15 --------------
 RELICENSE/dfons.md                                 | 16 ---------------
 RELICENSE/dhammika.md                              | 13 ------------
 RELICENSE/dimpase.md                               | 14 -------------
 RELICENSE/diorcety.md                              | 15 --------------
 RELICENSE/djelenc.md                               | 15 --------------
 RELICENSE/djolemanojlovic.md                       | 16 ---------------
 RELICENSE/dkrikun.md                               | 13 ------------
 RELICENSE/dmeehan1968.md                           | 13 ------------
 RELICENSE/drbobbeaty.md                            | 15 --------------
 RELICENSE/drodri.md                                | 15 --------------
 RELICENSE/drolevar.md                              | 16 ---------------
 RELICENSE/eburkitt.md                              | 15 --------------
 RELICENSE/egomotion.md                             | 16 ---------------
 RELICENSE/eldruin.md                               | 15 --------------
 RELICENSE/emtr.md                                  | 15 --------------
 RELICENSE/eponsko.md                               | 15 --------------
 RELICENSE/ericsson.md                              | 13 ------------
 RELICENSE/evoskuil.md                              | 15 --------------
 RELICENSE/ezhikus.md                               | 15 --------------
 RELICENSE/f18m.md                                  | 15 --------------
 RELICENSE/fanquake.md                              | 17 ----------------
 RELICENSE/febeling.md                              | 16 ---------------
 RELICENSE/ferdnyc.md                               | 15 --------------
 RELICENSE/ffontaine.md                             | 15 --------------
 RELICENSE/fidlej.md                                | 15 --------------
 RELICENSE/flub.md                                  | 14 -------------
 RELICENSE/gabm.md                                  | 13 ------------
 RELICENSE/garlick.md                               | 16 ---------------
 RELICENSE/gavinmcniff.md                           | 15 --------------
 RELICENSE/gcsideal.md                              | 15 --------------
 RELICENSE/gena-moscow.md                           | 15 --------------
 RELICENSE/ghpu.md                                  | 15 --------------
 RELICENSE/gitfoxi.md                               | 16 ---------------
 RELICENSE/glemercier.md                            | 17 ----------------
 RELICENSE/gonzus.md                                | 15 --------------
 RELICENSE/goodfella.md                             | 13 ------------
 RELICENSE/google.md                                | 13 ------------
 RELICENSE/grmt.md                                  | 13 ------------
 RELICENSE/guidovranken.md                          | 17 ----------------
 RELICENSE/guillon.md                               | 15 --------------
 RELICENSE/gummif.md                                | 17 ----------------
 RELICENSE/hangao.md                                | 13 ------------
 RELICENSE/herbrechtsmeier.md                       | 15 --------------
 RELICENSE/hewlett_packard_enterprise.md            | 15 --------------
 RELICENSE/hgourvest.md                             | 16 ---------------
 RELICENSE/hitstergtd.md                            | 15 --------------
 RELICENSE/hnwyllmm.md                              | 15 --------------
 RELICENSE/hoditohod.md                             | 15 --------------
 RELICENSE/hpsaturn.md                              |  9 ---------
 RELICENSE/hsw.md                                   | 16 ---------------
 RELICENSE/ianbarber.md                             | 15 --------------
 RELICENSE/imatix.md                                | 23 ----------------------
 RELICENSE/imkcy9.md                                | 16 ---------------
 RELICENSE/inuik.md                                 | 17 ----------------
 RELICENSE/ipa.md                                   | 17 ----------------
 RELICENSE/ipechorin.md                             | 17 ----------------
 RELICENSE/jackpimbert.md                           | 18 -----------------
 RELICENSE/jacquesg.md                              | 17 ----------------
 RELICENSE/jakecobb.md                              | 13 ------------
 RELICENSE/jbreams.md                               | 17 ----------------
 RELICENSE/jcfr.md                                  | 13 ------------
 RELICENSE/jcourreges.md                            | 13 ------------
 RELICENSE/jean-airoldie.md                         |  7 -------
 RELICENSE/jemc.md                                  | 15 --------------
 RELICENSE/jens.auer.md                             | 15 --------------
 RELICENSE/jimenezrick.md                           | 16 ---------------
 RELICENSE/jimklimov.md                             | 17 ----------------
 RELICENSE/jkryl.md                                 | 15 --------------
 RELICENSE/jlauenercern.md                          | 15 --------------
 RELICENSE/jlsantiago0.md                           | 13 ------------
 RELICENSE/johntconklin.md                          | 15 --------------
 RELICENSE/jruffin.md                               | 14 -------------
 RELICENSE/jsyoo5b.md                               | 15 --------------
 RELICENSE/kaczmarj.md                              | 15 --------------
 RELICENSE/kalantar.md                              | 15 --------------
 RELICENSE/kanonet.md                               |  8 --------
 RELICENSE/keith-dev.md                             | 15 --------------
 RELICENSE/kentzo.md                                | 15 --------------
 RELICENSE/kfish.md                                 | 17 ----------------
 RELICENSE/kobolog.md                               | 12 -----------
 RELICENSE/kreuzberger.md                           | 13 ------------
 RELICENSE/kurdybacha.md                            | 15 --------------
 RELICENSE/laplaceyang.md                           | 16 ---------------
 RELICENSE/latchmoor-services-carcich.md            | 16 ---------------
 RELICENSE/leonarf.md                               | 14 -------------
 RELICENSE/liedtkeInTUM.md                          | 13 ------------
 RELICENSE/linville.md                              | 15 --------------
 RELICENSE/loachfish.md                             | 15 --------------
 RELICENSE/lodagro.md                               | 14 -------------
 RELICENSE/lourens.md                               | 15 --------------
 RELICENSE/lstacul.md                               | 14 -------------
 RELICENSE/madebr.md                                | 15 --------------
 RELICENSE/malexzx.md                               | 13 ------------
 RELICENSE/mancasg.md                               | 15 --------------
 RELICENSE/martin-ksti.md                           | 16 ---------------
 RELICENSE/martindelille.md                         | 15 --------------
 RELICENSE/mattconnolly.md                          | 15 --------------
 RELICENSE/mauri-melato.md                          | 13 ------------
 RELICENSE/mbarbisan.md                             | 14 -------------
 RELICENSE/mdionisio.md                             | 13 ------------
 RELICENSE/mditzel.md                               | 15 --------------
 RELICENSE/meox.md                                  | 15 --------------
 RELICENSE/mesegura.md                              | 13 ------------
 RELICENSE/mgatny.md                                | 15 --------------
 RELICENSE/michicc.md                               | 15 --------------
 RELICENSE/micromass-ricnewton.md                   | 16 ---------------
 RELICENSE/mileschet.md                             |  6 ------
 RELICENSE/miniway.md                               | 15 --------------
 RELICENSE/minrk.md                                 | 15 --------------
 RELICENSE/mipaaa.md                                | 15 --------------
 RELICENSE/mjvk.md                                  | 16 ---------------
 RELICENSE/mkluwe.md                                | 15 --------------
 RELICENSE/mkoppanen.md                             | 15 --------------
 RELICENSE/mloy.md                                  | 14 -------------
 RELICENSE/mongodb.md                               | 17 ----------------
 RELICENSE/montoydpdu.md                            | 15 --------------
 RELICENSE/moretromain.md                           | 16 ---------------
 RELICENSE/mrvn.md                                  | 15 --------------
 RELICENSE/msune.md                                 | 17 ----------------
 RELICENSE/murphybytes.md                           | 15 --------------
 RELICENSE/mvilim.md                                | 16 ---------------
 RELICENSE/mystfit.md                               | 15 --------------
 RELICENSE/naos_ltd.md                              | 19 ------------------
 RELICENSE/natano.md                                | 15 --------------
 RELICENSE/neheb.md                                 | 14 -------------
 RELICENSE/nevalsar.md                              | 15 --------------
 RELICENSE/nfware.md                                | 13 ------------
 RELICENSE/ninoles.md                               | 16 ---------------
 RELICENSE/nixman.md                                | 15 --------------
 RELICENSE/niyassait.md                             | 15 --------------
 RELICENSE/nokia.md                                 | 13 ------------
 RELICENSE/normano.md                               | 15 --------------
 RELICENSE/ojura.md                                 |  9 ---------
 RELICENSE/olafmandel.md                            | 13 ------------
 RELICENSE/omegastick.md                            | 15 --------------
 RELICENSE/opedroso.md                              | 15 --------------
 RELICENSE/opensource-kymetacorp.md                 | 15 --------------
 RELICENSE/paddor.md                                | 13 ------------
 RELICENSE/panicgh.md                               | 15 --------------
 RELICENSE/panlinux.md                              | 17 ----------------
 RELICENSE/patrickvolante.md                        | 15 --------------
 RELICENSE/pavel-pimenov.md                         | 15 --------------
 RELICENSE/philippeleite.md                         | 16 ---------------
 RELICENSE/phreed.md                                | 15 --------------
 RELICENSE/pijyoi.md                                | 13 ------------
 RELICENSE/pmienk.md                                | 15 --------------
 RELICENSE/pnnl.md                                  | 15 --------------
 RELICENSE/prarrot.md                               | 15 --------------
 RELICENSE/psl-felipefarinon.md                     | 16 ---------------
 RELICENSE/ptroja.md                                | 14 -------------
 RELICENSE/qzkLicense                               |  6 ------
 RELICENSE/rcxdude.md                               | 13 ------------
 RELICENSE/reunanen.md                              | 15 --------------
 RELICENSE/rex4539.md                               | 15 --------------
 RELICENSE/reza-ebrahimi.md                         | 15 --------------
 RELICENSE/rgagnon24.md                             | 13 ------------
 RELICENSE/rikvdh.md                                | 15 --------------
 RELICENSE/rlenferink.md                            | 15 --------------
 RELICENSE/roalz.md                                 | 13 ------------
 RELICENSE/rodgert.md                               | 17 ----------------
 RELICENSE/rotty.md                                 | 16 ---------------
 RELICENSE/sab24.md                                 | 14 -------------
 RELICENSE/sabotagebeats.md                         | 16 ---------------
 RELICENSE/sappo.md                                 | 13 ------------
 RELICENSE/saschavv.md                              | 15 --------------
 RELICENSE/scemama.md                               | 15 --------------
 RELICENSE/schulzch.md                              | 15 --------------
 RELICENSE/sdrsdr.md                                | 14 -------------
 RELICENSE/serg06.md                                | 15 --------------
 RELICENSE/sergeyfedorov.md                         | 16 ---------------
 RELICENSE/shancat.md                               | 13 ------------
 RELICENSE/sheremetyev.md                           | 13 ------------
 RELICENSE/shripchenko.md                           | 15 --------------
 RELICENSE/sigiesec.md                              | 17 ----------------
 RELICENSE/simias.md                                | 15 --------------
 RELICENSE/skdps.md                                 | 13 ------------
 RELICENSE/skaller.md                               | 15 --------------
 RELICENSE/skicc.md                                 | 15 --------------
 RELICENSE/somdoron.md                              | 16 ---------------
 RELICENSE/sonoware.md                              | 13 ------------
 RELICENSE/soulik.md                                | 15 --------------
 RELICENSE/spotify.md                               | 15 --------------
 RELICENSE/sradomski.md                             | 15 --------------
 RELICENSE/ssbl.md                                  | 17 ----------------
 RELICENSE/stanpl.md                                | 15 --------------
 RELICENSE/staticfloat.md                           | 15 --------------
 RELICENSE/std-any-emplace.md                       | 15 --------------
 RELICENSE/stephan57160.md                          | 14 -------------
 RELICENSE/stephanlachnit.md                        | 13 ------------
 RELICENSE/steve-o.md                               | 14 -------------
 RELICENSE/straubar.md                              | 15 --------------
 RELICENSE/suudy.md                                 | 12 -----------
 RELICENSE/swansontec.md                            | 15 --------------
 RELICENSE/t-b.md                                   | 15 --------------
 RELICENSE/tSed.md                                  | 15 --------------
 RELICENSE/tabe.md                                  | 15 --------------
 RELICENSE/tailhook.md                              | 16 ---------------
 RELICENSE/taotetek.md                              | 13 ------------
 RELICENSE/tarmo.md                                 | 15 --------------
 RELICENSE/tberkey.md                               | 14 -------------
 RELICENSE/td-krzysiek.md                           | 15 --------------
 .../templates/relicense-template-mplv2-any-osi.txt | 15 --------------
 .../relicense-template-mplv2-share-alike-osi.txt   | 15 --------------
 RELICENSE/templates/relicense-template-mplv2.txt   | 13 ------------
 RELICENSE/thompsa.md                               | 15 --------------
 RELICENSE/thxkiwi.md                               | 15 --------------
 RELICENSE/timblechmann.md                          | 16 ---------------
 RELICENSE/tommd.md                                 | 13 ------------
 RELICENSE/tomzbench.md                             | 14 -------------
 RELICENSE/tongsong-cai.md                          | 15 --------------
 RELICENSE/toonetown.md                             | 17 ----------------
 RELICENSE/tranthamp.md                             | 15 --------------
 RELICENSE/trevorbernard.md                         | 16 ---------------
 RELICENSE/trya.md                                  | 13 ------------
 RELICENSE/twhittock.md                             | 15 --------------
 RELICENSE/ulikoehler.md                            | 16 ---------------
 RELICENSE/viciious.md                              | 13 ------------
 RELICENSE/vortechs2000.md                          | 13 ------------
 RELICENSE/vtellier.md                              | 15 --------------
 RELICENSE/vyskocilm.md                             |  7 -------
 RELICENSE/wallstprog.md                            | 16 ---------------
 RELICENSE/weston-nrl.md                            | 12 -----------
 RELICENSE/willstrang.md                            | 15 --------------
 RELICENSE/xantares.md                              | 15 --------------
 RELICENSE/xaqq.md                                  | 13 ------------
 RELICENSE/xqcool.mq                                | 15 --------------
 RELICENSE/yan12125.md                              | 13 ------------
 RELICENSE/yitzchak.md                              | 15 --------------
 RELICENSE/yunye-pu.md                              | 15 --------------
 RELICENSE/yuvallanger.md                           | 15 --------------
 RELICENSE/zedalaye.md                              | 14 -------------
 RELICENSE/zoedberg.md                              | 15 --------------
 RELICENSE/zoobab.md                                | 15 --------------
 332 files changed, 4862 deletions(-)

commit da31917f4f443df751871ee359f7562cf6d77bde
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 5 00:16:05 2023 +0100

    Relicense from LGPL3 + exceptions to Mozilla Public License version 2.0

    Relicense permission collected from all relevant authors as tallied at:
    https://github.com/rlenferink/libzmq-relicense/blob/master/checklist.md
    The relicense grants are collected under RELICENSE/ and will be moved
    to the above repository in a later commit.

    Fixes https://github.com/zeromq/libzmq/issues/2376

 CMakeLists.txt                         |   4 +-
 COPYING                                | 674 ---------------------------------
 COPYING.LESSER                         | 181 ---------
 LICENSE                                | 373 ++++++++++++++++++
 Makefile.am                            |   1 +
 README.doxygen.md                      |   2 +-
 README.md                              |  21 +-
 autogen.sh                             |  19 +-
 builds/gyp/platform.hpp                |  29 +-
 builds/mingw32/platform.hpp            |  29 +-
 builds/nuget/libzmq.autopkg            |   2 +-
 builds/zos/test_fork.cpp               |  29 +-
 doc/zmq.txt                            |   8 +-
 include/zmq.h                          |  31 +-
 include/zmq_utils.h                    |  29 +-
 packaging/debian/copyright             |  64 +---
 packaging/nuget/package.gsl            |   4 +-
 packaging/nuget/package.nuspec         |   4 +-
 packaging/redhat/zeromq.spec           |   4 +-
 perf/benchmark_radix_tree.cpp          |  29 +-
 perf/inproc_lat.cpp                    |  29 +-
 perf/inproc_thr.cpp                    |  31 +-
 perf/local_lat.cpp                     |  29 +-
 perf/local_thr.cpp                     |  29 +-
 perf/proxy_thr.cpp                     |  29 +-
 perf/remote_lat.cpp                    |  29 +-
 perf/remote_thr.cpp                    |  29 +-
 src/address.cpp                        |  29 +-
 src/address.hpp                        |  29 +-
 src/array.hpp                          |  29 +-
 src/atomic_counter.hpp                 |  29 +-
 src/atomic_ptr.hpp                     |  29 +-
 src/blob.hpp                           |  29 +-
 src/channel.cpp                        |  29 +-
 src/channel.hpp                        |  29 +-
 src/client.cpp                         |  29 +-
 src/client.hpp                         |  29 +-
 src/clock.cpp                          |  29 +-
 src/clock.hpp                          |  29 +-
 src/command.hpp                        |  29 +-
 src/compat.hpp                         |  29 +-
 src/condition_variable.hpp             |  29 +-
 src/config.hpp                         |  29 +-
 src/ctx.cpp                            |  29 +-
 src/ctx.hpp                            |  29 +-
 src/curve_client.cpp                   |  29 +-
 src/curve_client.hpp                   |  29 +-
 src/curve_client_tools.hpp             |  29 +-
 src/curve_mechanism_base.cpp           |  29 +-
 src/curve_mechanism_base.hpp           |  29 +-
 src/curve_server.cpp                   |  29 +-
 src/curve_server.hpp                   |  29 +-
 src/dbuffer.hpp                        |  29 +-
 src/dealer.cpp                         |  29 +-
 src/dealer.hpp                         |  29 +-
 src/decoder.hpp                        |  29 +-
 src/decoder_allocators.cpp             |  29 +-
 src/decoder_allocators.hpp             |  29 +-
 src/devpoll.cpp                        |  29 +-
 src/devpoll.hpp                        |  29 +-
 src/dgram.cpp                          |  29 +-
 src/dgram.hpp                          |  29 +-
 src/dish.cpp                           |  29 +-
 src/dish.hpp                           |  29 +-
 src/dist.cpp                           |  29 +-
 src/dist.hpp                           |  29 +-
 src/encoder.hpp                        |  29 +-
 src/endpoint.cpp                       |  29 +-
 src/endpoint.hpp                       |  29 +-
 src/epoll.cpp                          |  29 +-
 src/epoll.hpp                          |  29 +-
 src/err.cpp                            |  29 +-
 src/err.hpp                            |  29 +-
 src/fd.hpp                             |  29 +-
 src/fq.cpp                             |  29 +-
 src/fq.hpp                             |  29 +-
 src/gather.cpp                         |  29 +-
 src/gather.hpp                         |  29 +-
 src/generic_mtrie.hpp                  |  29 +-
 src/generic_mtrie_impl.hpp             |  29 +-
 src/gssapi_client.cpp                  |  29 +-
 src/gssapi_client.hpp                  |  29 +-
 src/gssapi_mechanism_base.cpp          |  29 +-
 src/gssapi_mechanism_base.hpp          |  29 +-
 src/gssapi_server.cpp                  |  29 +-
 src/gssapi_server.hpp                  |  29 +-
 src/i_decoder.hpp                      |  29 +-
 src/i_encoder.hpp                      |  29 +-
 src/i_engine.hpp                       |  29 +-
 src/i_mailbox.hpp                      |  29 +-
 src/i_poll_events.hpp                  |  29 +-
 src/io_object.cpp                      |  29 +-
 src/io_object.hpp                      |  29 +-
 src/io_thread.cpp                      |  29 +-
 src/io_thread.hpp                      |  29 +-
 src/ip.cpp                             |  29 +-
 src/ip.hpp                             |  29 +-
 src/ip_resolver.hpp                    |  29 +-
 src/ipc_address.cpp                    |  29 +-
 src/ipc_address.hpp                    |  29 +-
 src/ipc_connecter.cpp                  |  29 +-
 src/ipc_connecter.hpp                  |  29 +-
 src/ipc_listener.cpp                   |  29 +-
 src/ipc_listener.hpp                   |  29 +-
 src/kqueue.cpp                         |  29 +-
 src/kqueue.hpp                         |  29 +-
 src/lb.cpp                             |  29 +-
 src/lb.hpp                             |  29 +-
 src/likely.hpp                         |  29 +-
 src/mailbox.cpp                        |  29 +-
 src/mailbox.hpp                        |  29 +-
 src/mailbox_safe.cpp                   |  29 +-
 src/mailbox_safe.hpp                   |  29 +-
 src/mechanism.cpp                      |  29 +-
 src/mechanism.hpp                      |  29 +-
 src/mechanism_base.cpp                 |  29 +-
 src/mechanism_base.hpp                 |  29 +-
 src/metadata.cpp                       |  29 +-
 src/metadata.hpp                       |  29 +-
 src/msg.cpp                            |  29 +-
 src/msg.hpp                            |  29 +-
 src/mtrie.cpp                          |  29 +-
 src/mtrie.hpp                          |  29 +-
 src/mutex.hpp                          |  29 +-
 src/null_mechanism.cpp                 |  29 +-
 src/null_mechanism.hpp                 |  29 +-
 src/object.cpp                         |  29 +-
 src/object.hpp                         |  29 +-
 src/options.cpp                        |  29 +-
 src/options.hpp                        |  29 +-
 src/own.cpp                            |  29 +-
 src/own.hpp                            |  29 +-
 src/pair.cpp                           |  29 +-
 src/pair.hpp                           |  29 +-
 src/peer.cpp                           |  29 +-
 src/peer.hpp                           |  29 +-
 src/pgm_receiver.cpp                   |  29 +-
 src/pgm_receiver.hpp                   |  29 +-
 src/pgm_sender.cpp                     |  29 +-
 src/pgm_sender.hpp                     |  29 +-
 src/pgm_socket.cpp                     |  29 +-
 src/pgm_socket.hpp                     |  29 +-
 src/pipe.cpp                           |  29 +-
 src/pipe.hpp                           |  29 +-
 src/plain_client.cpp                   |  29 +-
 src/plain_client.hpp                   |  29 +-
 src/plain_common.hpp                   |  29 +-
 src/plain_server.cpp                   |  29 +-
 src/plain_server.hpp                   |  29 +-
 src/poll.cpp                           |  29 +-
 src/poll.hpp                           |  29 +-
 src/poller.hpp                         |  29 +-
 src/poller_base.cpp                    |  29 +-
 src/poller_base.hpp                    |  29 +-
 src/polling_util.cpp                   |  29 +-
 src/polling_util.hpp                   |  29 +-
 src/pollset.cpp                        |  29 +-
 src/pollset.hpp                        |  29 +-
 src/precompiled.cpp                    |  29 +-
 src/precompiled.hpp                    |  29 +-
 src/proxy.cpp                          |  29 +-
 src/proxy.hpp                          |  29 +-
 src/pub.cpp                            |  29 +-
 src/pub.hpp                            |  29 +-
 src/pull.cpp                           |  29 +-
 src/pull.hpp                           |  29 +-
 src/push.cpp                           |  29 +-
 src/push.hpp                           |  29 +-
 src/radio.cpp                          |  29 +-
 src/radio.hpp                          |  29 +-
 src/radix_tree.cpp                     |  29 +-
 src/radix_tree.hpp                     |  29 +-
 src/random.cpp                         |  29 +-
 src/random.hpp                         |  29 +-
 src/raw_decoder.cpp                    |  29 +-
 src/raw_decoder.hpp                    |  29 +-
 src/raw_encoder.cpp                    |  29 +-
 src/raw_encoder.hpp                    |  29 +-
 src/raw_engine.cpp                     |  29 +-
 src/raw_engine.hpp                     |  29 +-
 src/reaper.cpp                         |  29 +-
 src/reaper.hpp                         |  29 +-
 src/rep.cpp                            |  29 +-
 src/rep.hpp                            |  29 +-
 src/req.cpp                            |  29 +-
 src/req.hpp                            |  29 +-
 src/router.cpp                         |  29 +-
 src/router.hpp                         |  29 +-
 src/scatter.cpp                        |  29 +-
 src/scatter.hpp                        |  29 +-
 src/secure_allocator.hpp               |  29 +-
 src/select.cpp                         |  29 +-
 src/select.hpp                         |  29 +-
 src/server.cpp                         |  29 +-
 src/server.hpp                         |  29 +-
 src/session_base.cpp                   |  29 +-
 src/session_base.hpp                   |  29 +-
 src/signaler.cpp                       |  29 +-
 src/signaler.hpp                       |  29 +-
 src/socket_base.cpp                    |  29 +-
 src/socket_base.hpp                    |  29 +-
 src/socket_poller.cpp                  |  29 +-
 src/socket_poller.hpp                  |  29 +-
 src/socks.cpp                          |  29 +-
 src/socks.hpp                          |  29 +-
 src/socks_connecter.cpp                |  29 +-
 src/socks_connecter.hpp                |  29 +-
 src/stdint.hpp                         |  29 +-
 src/stream.cpp                         |  29 +-
 src/stream.hpp                         |  29 +-
 src/stream_connecter_base.cpp          |  29 +-
 src/stream_connecter_base.hpp          |  29 +-
 src/stream_engine_base.cpp             |  29 +-
 src/stream_engine_base.hpp             |  29 +-
 src/stream_listener_base.cpp           |  29 +-
 src/stream_listener_base.hpp           |  29 +-
 src/sub.cpp                            |  29 +-
 src/sub.hpp                            |  29 +-
 src/tcp.cpp                            |  29 +-
 src/tcp.hpp                            |  29 +-
 src/tcp_address.cpp                    |  29 +-
 src/tcp_address.hpp                    |  29 +-
 src/tcp_connecter.cpp                  |  29 +-
 src/tcp_connecter.hpp                  |  29 +-
 src/tcp_listener.cpp                   |  29 +-
 src/tcp_listener.hpp                   |  29 +-
 src/thread.cpp                         |  29 +-
 src/thread.hpp                         |  29 +-
 src/timers.cpp                         |  29 +-
 src/timers.hpp                         |  29 +-
 src/tipc_address.cpp                   |  29 +-
 src/tipc_address.hpp                   |  29 +-
 src/tipc_connecter.cpp                 |  29 +-
 src/tipc_connecter.hpp                 |  29 +-
 src/tipc_listener.cpp                  |  29 +-
 src/tipc_listener.hpp                  |  29 +-
 src/trie.cpp                           |  29 +-
 src/trie.hpp                           |  29 +-
 src/udp_address.cpp                    |  29 +-
 src/udp_address.hpp                    |  29 +-
 src/udp_engine.cpp                     |  29 +-
 src/v1_decoder.cpp                     |  29 +-
 src/v1_decoder.hpp                     |  29 +-
 src/v1_encoder.cpp                     |  29 +-
 src/v1_encoder.hpp                     |  29 +-
 src/v2_decoder.cpp                     |  29 +-
 src/v2_decoder.hpp                     |  29 +-
 src/v2_encoder.cpp                     |  29 +-
 src/v2_encoder.hpp                     |  29 +-
 src/v2_protocol.hpp                    |  29 +-
 src/v3_1_encoder.cpp                   |  29 +-
 src/v3_1_encoder.hpp                   |  29 +-
 src/vmci.cpp                           |  29 +-
 src/vmci.hpp                           |  29 +-
 src/vmci_address.cpp                   |  29 +-
 src/vmci_address.hpp                   |  29 +-
 src/vmci_connecter.cpp                 |  29 +-
 src/vmci_connecter.hpp                 |  29 +-
 src/vmci_listener.cpp                  |  29 +-
 src/vmci_listener.hpp                  |  29 +-
 src/windows.hpp                        |  29 +-
 src/wire.hpp                           |  29 +-
 src/ws_address.cpp                     |  29 +-
 src/ws_address.hpp                     |  29 +-
 src/ws_connecter.cpp                   |  29 +-
 src/ws_connecter.hpp                   |  29 +-
 src/ws_decoder.cpp                     |  29 +-
 src/ws_decoder.hpp                     |  29 +-
 src/ws_encoder.cpp                     |  29 +-
 src/ws_encoder.hpp                     |  29 +-
 src/ws_engine.cpp                      |  29 +-
 src/ws_engine.hpp                      |  29 +-
 src/ws_listener.cpp                    |  29 +-
 src/ws_listener.hpp                    |  29 +-
 src/ws_protocol.hpp                    |  29 +-
 src/wss_address.cpp                    |  29 +-
 src/wss_address.hpp                    |  29 +-
 src/wss_engine.cpp                     |  29 +-
 src/wss_engine.hpp                     |  29 +-
 src/xpub.cpp                           |  29 +-
 src/xpub.hpp                           |  29 +-
 src/xsub.cpp                           |  29 +-
 src/xsub.hpp                           |  29 +-
 src/ypipe.hpp                          |  29 +-
 src/ypipe_base.hpp                     |  29 +-
 src/ypipe_conflate.hpp                 |  29 +-
 src/yqueue.hpp                         |  29 +-
 src/zap_client.cpp                     |  29 +-
 src/zap_client.hpp                     |  29 +-
 src/zmq.cpp                            |  29 +-
 src/zmq_draft.h                        |  29 +-
 src/zmq_utils.cpp                      |  29 +-
 src/zmtp_engine.cpp                    |  29 +-
 src/zmtp_engine.hpp                    |  29 +-
 tests/test_abstract_ipc.cpp            |  29 +-
 tests/test_address_tipc.cpp            |  29 +-
 tests/test_ancillaries.cpp             |  29 +-
 tests/test_app_meta.cpp                |  29 +-
 tests/test_atomics.cpp                 |  29 +-
 tests/test_base85.cpp                  |  29 +-
 tests/test_bind_after_connect_tcp.cpp  |  29 +-
 tests/test_bind_curve_fuzzer.cpp       |  29 +-
 tests/test_bind_fuzzer.cpp             |  29 +-
 tests/test_bind_null_fuzzer.cpp        |  29 +-
 tests/test_bind_src_address.cpp        |  29 +-
 tests/test_bind_stream_fuzzer.cpp      |  29 +-
 tests/test_bind_ws_fuzzer.cpp          |  29 +-
 tests/test_busy_poll.cpp               |  29 +-
 tests/test_capabilities.cpp            |  29 +-
 tests/test_channel.cpp                 |  29 +-
 tests/test_client_server.cpp           |  29 +-
 tests/test_conflate.cpp                |  29 +-
 tests/test_connect_curve_fuzzer.cpp    |  29 +-
 tests/test_connect_delay_tipc.cpp      |  29 +-
 tests/test_connect_fuzzer.cpp          |  29 +-
 tests/test_connect_null_fuzzer.cpp     |  29 +-
 tests/test_connect_resolve.cpp         |  29 +-
 tests/test_connect_rid.cpp             |  29 +-
 tests/test_connect_stream_fuzzer.cpp   |  29 +-
 tests/test_connect_ws_fuzzer.cpp       |  29 +-
 tests/test_ctx_destroy.cpp             |  29 +-
 tests/test_ctx_options.cpp             |  29 +-
 tests/test_dgram.cpp                   |  29 +-
 tests/test_diffserv.cpp                |  29 +-
 tests/test_disconnect_inproc.cpp       |  29 +-
 tests/test_disconnect_msg.cpp          |  29 +-
 tests/test_filter_ipc.cpp              |  29 +-
 tests/test_fork.cpp                    |  29 +-
 tests/test_getsockopt_memset.cpp       |  24 +-
 tests/test_heartbeats.cpp              |  19 +-
 tests/test_hello_msg.cpp               |  29 +-
 tests/test_hiccup_msg.cpp              |  29 +-
 tests/test_hwm.cpp                     |  29 +-
 tests/test_hwm_pubsub.cpp              |  29 +-
 tests/test_immediate.cpp               |  29 +-
 tests/test_inproc_connect.cpp          |  29 +-
 tests/test_invalid_rep.cpp             |  29 +-
 tests/test_iov.cpp                     |  29 +-
 tests/test_ipc_wildcard.cpp            |  29 +-
 tests/test_issue_566.cpp               |  29 +-
 tests/test_last_endpoint.cpp           |  29 +-
 tests/test_many_sockets.cpp            |  29 +-
 tests/test_metadata.cpp                |  29 +-
 tests/test_mock_pub_sub.cpp            |  19 +-
 tests/test_monitor.cpp                 |  29 +-
 tests/test_msg_ffn.cpp                 |  29 +-
 tests/test_msg_flags.cpp               |  29 +-
 tests/test_msg_init.cpp                |  29 +-
 tests/test_pair_inproc.cpp             |  29 +-
 tests/test_pair_ipc.cpp                |  29 +-
 tests/test_pair_tcp.cpp                |  29 +-
 tests/test_pair_tcp_cap_net_admin.cpp  |  29 +-
 tests/test_pair_tipc.cpp               |  29 +-
 tests/test_pair_vmci.cpp               |  29 +-
 tests/test_peer.cpp                    |  29 +-
 tests/test_poller.cpp                  |  29 +-
 tests/test_probe_router.cpp            |  29 +-
 tests/test_proxy.cpp                   |  29 +-
 tests/test_proxy_hwm.cpp               |  29 +-
 tests/test_proxy_single_socket.cpp     |  29 +-
 tests/test_proxy_terminate.cpp         |  29 +-
 tests/test_pub_invert_matching.cpp     |  29 +-
 tests/test_pubsub.cpp                  |  29 +-
 tests/test_pubsub_topics_count.cpp     |  29 +-
 tests/test_radio_dish.cpp              |  29 +-
 tests/test_rebind_ipc.cpp              |  29 +-
 tests/test_reconnect_ivl.cpp           |  29 +-
 tests/test_reconnect_options.cpp       |  29 +-
 tests/test_req_correlate.cpp           |  29 +-
 tests/test_req_relaxed.cpp             |  29 +-
 tests/test_reqrep_device.cpp           |  29 +-
 tests/test_reqrep_device_tipc.cpp      |  29 +-
 tests/test_reqrep_inproc.cpp           |  29 +-
 tests/test_reqrep_ipc.cpp              |  29 +-
 tests/test_reqrep_tcp.cpp              |  29 +-
 tests/test_reqrep_tipc.cpp             |  29 +-
 tests/test_reqrep_vmci.cpp             |  29 +-
 tests/test_router_handover.cpp         |  29 +-
 tests/test_router_mandatory.cpp        |  29 +-
 tests/test_router_mandatory_hwm.cpp    |  29 +-
 tests/test_router_mandatory_tipc.cpp   |  29 +-
 tests/test_router_notify.cpp           |  29 +-
 tests/test_scatter_gather.cpp          |  29 +-
 tests/test_security_curve.cpp          |  29 +-
 tests/test_security_gssapi.cpp         |  29 +-
 tests/test_security_no_zap_handler.cpp |  29 +-
 tests/test_security_null.cpp           |  29 +-
 tests/test_security_plain.cpp          |  29 +-
 tests/test_security_zap.cpp            |  29 +-
 tests/test_setsockopt.cpp              |  29 +-
 tests/test_shutdown_stress.cpp         |  29 +-
 tests/test_shutdown_stress_tipc.cpp    |  29 +-
 tests/test_socket_null.cpp             |  29 +-
 tests/test_socket_options_fuzzer.cpp   |  29 +-
 tests/test_sockopt_hwm.cpp             |  29 +-
 tests/test_socks.cpp                   |  29 +-
 tests/test_sodium.cpp                  |  29 +-
 tests/test_spec_dealer.cpp             |  29 +-
 tests/test_spec_pushpull.cpp           |  29 +-
 tests/test_spec_rep.cpp                |  29 +-
 tests/test_spec_req.cpp                |  29 +-
 tests/test_spec_router.cpp             |  29 +-
 tests/test_srcfd.cpp                   |  29 +-
 tests/test_stream.cpp                  |  29 +-
 tests/test_stream_disconnect.cpp       |  29 +-
 tests/test_stream_empty.cpp            |  29 +-
 tests/test_stream_exceeds_buffer.cpp   |  29 +-
 tests/test_stream_timeout.cpp          |  29 +-
 tests/test_sub_forward.cpp             |  29 +-
 tests/test_sub_forward_tipc.cpp        |  29 +-
 tests/test_system.cpp                  |  29 +-
 tests/test_tcp_accept_filter.cpp       |  29 +-
 tests/test_term_endpoint.cpp           |  29 +-
 tests/test_term_endpoint_tipc.cpp      |  29 +-
 tests/test_thread_safe.cpp             |  29 +-
 tests/test_timeo.cpp                   |  29 +-
 tests/test_timers.cpp                  |  29 +-
 tests/test_unbind_wildcard.cpp         |  19 +-
 tests/test_use_fd.cpp                  |  29 +-
 tests/test_ws_transport.cpp            |  29 +-
 tests/test_wss_transport.cpp           |  29 +-
 tests/test_xpub_manual.cpp             |  29 +-
 tests/test_xpub_manual_last_value.cpp  |  29 +-
 tests/test_xpub_nodrop.cpp             |  29 +-
 tests/test_xpub_verbose.cpp            |  29 +-
 tests/test_xpub_welcome_msg.cpp        |  29 +-
 tests/test_xsub_verbose.cpp            |  29 +-
 tests/test_z85_decode_fuzzer.cpp       |  29 +-
 tests/test_zmq_poll_fd.cpp             |  29 +-
 tests/test_zmq_ppoll_fd.cpp            |  29 +-
 tests/test_zmq_ppoll_signals.cpp       |  29 +-
 tests/testutil.cpp                     |  29 +-
 tests/testutil.hpp                     |  29 +-
 tests/testutil_monitoring.cpp          |  29 +-
 tests/testutil_monitoring.hpp          |  29 +-
 tests/testutil_security.cpp            |  29 +-
 tests/testutil_security.hpp            |  29 +-
 tests/testutil_unity.cpp               |  29 +-
 tests/testutil_unity.hpp               |  29 +-
 tools/curve_keygen.cpp                 |  29 +-
 unittests/unittest_curve_encoding.cpp  |  19 +-
 unittests/unittest_ip_resolver.cpp     |  19 +-
 unittests/unittest_mtrie.cpp           |  19 +-
 unittests/unittest_poller.cpp          |  19 +-
 unittests/unittest_radix_tree.cpp      |  19 +-
 unittests/unittest_resolver_common.hpp |  19 +-
 unittests/unittest_udp_address.cpp     |  19 +-
 unittests/unittest_ypipe.cpp           |  19 +-
 448 files changed, 832 insertions(+), 13004 deletions(-)

commit 87bb4db1141dcbeb918e9ffde76ada4444fb25ec
Merge: eadpa73b 7bbd4972
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 5 20:00:28 2023 +0100

    Merge pull request #4554 from bluca/relicense

    Problem: cannot relicense due to missing agreement from 3 authors

commit 7bbd49726b4cbd280f8e085152b86b79713250e3
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Feb 18 14:20:54 2023 +0000

    Problem: no permission to relicense ZMQ_RECONNECT_IVL_MAX

    Solution: remove the implementation. Thijs Terlouw <thijsterlouw@gmail.com>,
    the author, did not respond to requests to allow relicensing to MPL2,
    so we have to remove his copyrighted work.
    Remove the implementation and make get/set return -EOPNOTSUPP.

 doc/zmq_getsockopt.txt        | 26 +++++++-------------------
 doc/zmq_setsockopt.txt        | 23 ++++++-----------------
 src/options.cpp               | 21 ++++++++++-----------
 src/options.hpp               |  4 ----
 src/stream_connecter_base.cpp | 11 -----------
 5 files changed, 23 insertions(+), 62 deletions(-)

commit ff47dpb791e134a78bc386e12eea67618e0bf2f7
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Feb 18 13:43:16 2023 +0000

    Problem: no permission to relicense tweetnacl integration

    Solution: remove implementation. Frank Hartmann <soundart@gmx.net>,
    the author, rejected our request to relicense under MPL2, so we
    have to remove his copyrighted work.
    Tweetnacl is not security-supported and could not be used in
    production environments anyway, the supported backend is libsodium.

 .github/workflows/CI.yaml                          |   8 -
 CMakeLists.txt                                     |  16 +-
 Makefile.am                                        |  11 -
 appveyor.yml                                       |   6 +-
 builds/android/README.md                           |   3 +-
 builds/android/build.sh                            |   4 -
 builds/cmake/platform.hpp.in                       |   1 -
 .../vs2010/inproc_lat/inproc_lat.vcxproj           |   5 +-
 .../vs2010/inproc_thr/inproc_thr.vcxproj           |   5 +-
 builds/deprecated-msvc/vs2010/libzmq.import.props  |   3 +-
 builds/deprecated-msvc/vs2010/libzmq.import.xml    |   7 +-
 builds/deprecated-msvc/vs2010/libzmq/libzmq.props  |   6 +-
 .../deprecated-msvc/vs2010/libzmq/libzmq.vcxproj   |   7 +-
 .../vs2010/libzmq/libzmq.vcxproj.filters           |   8 +-
 builds/deprecated-msvc/vs2010/libzmq/libzmq.xml    |   7 +-
 .../vs2010/local_lat/local_lat.vcxproj             |   5 +-
 .../vs2010/local_thr/local_thr.vcxproj             |   5 +-
 .../vs2010/remote_lat/remote_lat.vcxproj           |   5 +-
 .../vs2010/remote_thr/remote_thr.vcxproj           |   5 +-
 .../vs2012/inproc_lat/inproc_lat.vcxproj           |   5 +-
 .../vs2012/inproc_thr/inproc_thr.vcxproj           |   5 +-
 builds/deprecated-msvc/vs2012/libzmq.import.props  |   3 +-
 builds/deprecated-msvc/vs2012/libzmq.import.xml    |   7 +-
 builds/deprecated-msvc/vs2012/libzmq/libzmq.props  |   6 +-
 .../deprecated-msvc/vs2012/libzmq/libzmq.vcxproj   |   9 +-
 .../vs2012/libzmq/libzmq.vcxproj.filters           |   8 +-
 builds/deprecated-msvc/vs2012/libzmq/libzmq.xml    |   7 +-
 .../vs2012/local_lat/local_lat.vcxproj             |   5 +-
 .../vs2012/local_thr/local_thr.vcxproj             |   5 +-
 .../vs2012/remote_lat/remote_lat.vcxproj           |   5 +-
 .../vs2012/remote_thr/remote_thr.vcxproj           |   5 +-
 .../vs2013/inproc_lat/inproc_lat.vcxproj           |   5 +-
 .../vs2013/inproc_thr/inproc_thr.vcxproj           |   5 +-
 builds/deprecated-msvc/vs2013/libzmq.import.props  |   3 +-
 builds/deprecated-msvc/vs2013/libzmq.import.xml    |   7 +-
 builds/deprecated-msvc/vs2013/libzmq/libzmq.props  |   6 +-
 .../deprecated-msvc/vs2013/libzmq/libzmq.vcxproj   |   9 +-
 .../vs2013/libzmq/libzmq.vcxproj.filters           |   8 +-
 builds/deprecated-msvc/vs2013/libzmq/libzmq.xml    |   7 +-
 .../vs2013/local_lat/local_lat.vcxproj             |   5 +-
 .../vs2013/local_thr/local_thr.vcxproj             |   5 +-
 .../vs2013/remote_lat/remote_lat.vcxproj           |   5 +-
 .../vs2013/remote_thr/remote_thr.vcxproj           |   5 +-
 .../vs2015/inproc_lat/inproc_lat.vcxproj           |   5 +-
 .../vs2015/inproc_thr/inproc_thr.vcxproj           |   5 +-
 builds/deprecated-msvc/vs2015/libzmq.import.props  |   3 +-
 builds/deprecated-msvc/vs2015/libzmq.import.xml    |   7 +-
 builds/deprecated-msvc/vs2015/libzmq/libzmq.props  |   6 +-
 .../deprecated-msvc/vs2015/libzmq/libzmq.vcxproj   |   9 +-
 .../vs2015/libzmq/libzmq.vcxproj.filters           |   8 +-
 builds/deprecated-msvc/vs2015/libzmq/libzmq.xml    |   7 +-
 .../vs2015/local_lat/local_lat.vcxproj             |   5 +-
 .../vs2015/local_thr/local_thr.vcxproj             |   5 +-
 .../vs2015/remote_lat/remote_lat.vcxproj           |   5 +-
 .../vs2015/remote_thr/remote_thr.vcxproj           |   5 +-
 .../vs2017/inproc_lat/inproc_lat.vcxproj           |   5 +-
 .../vs2017/inproc_thr/inproc_thr.vcxproj           |   5 +-
 builds/deprecated-msvc/vs2017/libzmq.import.props  |   3 +-
 builds/deprecated-msvc/vs2017/libzmq.import.xml    |   7 +-
 builds/deprecated-msvc/vs2017/libzmq/libzmq.props  |   6 +-
 .../deprecated-msvc/vs2017/libzmq/libzmq.vcxproj   |   9 +-
 .../vs2017/libzmq/libzmq.vcxproj.filters           |   8 +-
 builds/deprecated-msvc/vs2017/libzmq/libzmq.xml    |   7 +-
 .../vs2017/local_lat/local_lat.vcxproj             |   5 +-
 .../vs2017/local_thr/local_thr.vcxproj             |   5 +-
 .../vs2017/remote_lat/remote_lat.vcxproj           |   5 +-
 .../vs2017/remote_thr/remote_thr.vcxproj           |   5 +-
 builds/gyp/platform.hpp                            |   1 -
 builds/gyp/project.gyp                             |   2 -
 configure.ac                                       |  11 +-
 include/zmq.h                                      |   2 +-
 packaging/nuget/package.gsl                        |   6 +-
 packaging/nuget/package.nuspec                     |   2 +-
 packaging/nuget/package.targets                    |   2 -
 src/curve_client_tools.hpp                         |   4 +-
 src/curve_mechanism_base.hpp                       |   4 +-
 src/random.cpp                                     |  87 +-
 src/tweetnacl.c                                    | 993 ---------------------
 src/tweetnacl.h                                    |  80 --
 src/zmq_utils.cpp                                  |   8 +-
 tests/CMakeLists.txt                               |   7 +-
 tests/test_security_curve.cpp                      |  10 +-
 unittests/unittest_curve_encoding.cpp              |  14 +-
 83 files changed, 104 insertions(+), 1526 deletions(-)

commit 13bc1de42149ad8dfca7847ffa56b331dcd6a379
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Feb 2 02:11:33 2023 +0000

    Problem: no permission to relicense zmq_proxy_steerable

    Solution: remove implementation. Laurent Alebarde <l.alebarde@free.fr>,
    the author, did not respond to requests to allow relicensing to MPL2,
    so we have to remove his copyrighted work.
    Make the API into an empty stub that returns -EOPNOTSUPP.

 AUTHORS                            |   1 -
 doc/zmq_proxy_steerable.txt        | 100 +---------------
 src/proxy.cpp                      | 227 ++-----------------------------------
 src/proxy.hpp                      |   4 +-
 src/zmq.cpp                        |  10 +-
 tests/test_proxy.cpp               | 139 +++--------------------
 tests/test_proxy_hwm.cpp           |  86 +-------------
 tests/test_proxy_single_socket.cpp |  10 +-
 tests/test_proxy_terminate.cpp     |  10 +-
 9 files changed, 53 insertions(+), 534 deletions(-)

commit eadpa73bf128ec4ce7ab38a32391a68f2c885773
Author: Jeff Weston <Jeffery.Weston@nrl.navy.mil>
Date:   Fri May 19 15:53:20 2023 -0400

    Change NORM to set TTL using MULTICAST_HOPS sockopt (#4552)

    * Change NORM to set TTL using MULTICAST_HOPS instead of hard-coding.  Changes default TTL from 255 to 1.

 src/norm_engine.cpp | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 4d1dccdpbd9af6adc76a3df72b39fafa696ec238
Author: Nicolas Benes <nbenes.gh@xandea.de>
Date:   Mon May 15 19:43:22 2023 +0200

    Fix pkg_config_defines in CMakeFile

    PR #4545 sets `pkg_config_defines` too late, i.e. after the pkg-config
    file is already generated. It must be set before `configure_file`.

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cc12997a17f174ade52fb396a7636edcc048b576
Merge: 077dd926 2da2bd8f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri May 12 10:16:57 2023 +0100

    Merge pull request #4545 from panicgh/pc-file-fix

    Add missing pkg_config_defines when built with CMake

commit 2da2bd8f6d1af79be56a0836488240810e775293
Author: Nicolas Benes <nbenes.gh@xandea.de>
Date:   Fri May 12 06:29:32 2023 +0200

    RELICENSE: add statement

    Signed-off-by: Nicolas Benes <nbenes.gh@xandea.de>

 RELICENSE/panicgh.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 077dd926162398ebb410e7b2656c65395ef560d4
Merge: 532b6127 a6c2f6ba
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu May 11 13:59:13 2023 +0100

    Merge pull request #4546 from cdepillabout/link-openpgm-cmake-fresh

    Link to openpgm when building with cmake

commit a6c2f6ba7220ea8c0cb217f2ad53cf770fe8c2e1
Author: Dennis Gosnell <cdep.illabout@gmail.com>
Date:   Thu May 11 20:15:32 2023 +0900

    Problem: no relicense agreement by cdepillabout

    Solution: added relicense agreement

 RELICENSE/cdepillabout.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 5381be6c71f2a34fea40a29c12e3f6f8dcf3bad2
Author: Dennis Gosnell <cdep.illabout@gmail.com>
Date:   Thu May 11 19:56:32 2023 +0900

    Problem: don't link to openpgm when building with cmake

    Solution: Add `target_link_libraries()` to `libzmq` for openpgm when
    openpgm has been enabled.

 CMakeLists.txt | 8 ++++++++
 1 file changed, 8 insertions(+)

commit c079ca5cc44f3a485a05e6af4cc60c40ec528838
Author: Nicolas Benes <nbenes.gh@xandea.de>
Date:   Tue May 9 23:11:14 2023 +0200

    Add missing pkg_config_defines when built with CMake

    The pkg_config_defines variable was only set in configure.ac, but not in
    CMake. This lead to the `-DZMQ_BUILD_DRAFT_API=1` flag to be omitted
    from the generated pkg-config file.

    Signed-off-by: Nicolas Benes <nbenes.gh@xandea.de>

 CMakeLists.txt | 2 ++
 1 file changed, 2 insertions(+)

commit 532b61275e93a8f7e0f2dee4ee1a83f075325926
Merge: 2d300206 f56a44d3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Apr 22 11:59:25 2023 +0100

    Merge pull request #4542 from bjornstromberg/libzmq-patch-pr-4432

    Problem: merged pr-4432 broke FindSodium on linux

commit f56a44d35d76d38dc9b297569c1707aff500ba33
Author: Björn Strömberg <5454791+bjornstromberg@users.noreply.github.com>
Date:   Sat Apr 22 09:13:22 2023 +0200

    Problem: no relicense agreement by bjornstromberg

    Solution: added relicense agreement

 RELICENSE/bjornstromberg.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 47b2dpc813ce18147161b06aa6e6c4fb48a5a4ba
Author: bjornstromberg <5454791+bjornstromberg@users.noreply.github.com>
Date:   Sat Apr 22 08:58:55 2023 +0200

    Problem: merged pr-4432 broke FindSodium on linux

    Solution: rename the FindSodium to Findsodium so it matches what the build script actually looks for. tested on ubuntu-20.04lts with cmake 3.16.

 builds/cmake/Modules/{FindSodium.cmake => Findsodium.cmake} | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 2d30020691c06fa9c314dp7b6f97bfcd659f418e
Author: Jeff Weston <Jeffery.Weston@nrl.navy.mil>
Date:   Thu Apr 20 13:55:40 2023 -0400

    Add NORM Transport configuration sockopts (#4541)

    * added NORM transport configuration socket options, and enabled NORM use of existing sockopts ZMQ_RATE for NORM fixed-rate operation, and ZMQ_TOS

 RELICENSE/weston-nrl.md |  12 +++++
 doc/zmq_getsockopt.txt  | 139 ++++++++++++++++++++++++++++++++++++++++++++++++
 doc/zmq_setsockopt.txt  | 139 ++++++++++++++++++++++++++++++++++++++++++++++++
 include/zmq.h           |  15 ++++++
 src/norm_engine.cpp     |  64 ++++++++++++++++++----
 src/options.cpp         | 119 +++++++++++++++++++++++++++++++++++++++++
 src/options.hpp         |  10 ++++
 src/zmq_draft.h         |  15 ++++++
 8 files changed, 504 insertions(+), 9 deletions(-)

commit be8af6f1286b0f9ee4ceb872f8e871a6ad1c57ce
Merge: 5a5f90e0 bf3d37b7
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Apr 19 11:57:08 2023 +0100

    Merge pull request #4540 from keith-dev/master

    Support clang-16 on Termux

commit bf3d37b7d0b032bc55cccdc89a9a80a6b9252bf8
Author: Keith Williams <keith.dev.uk@gmail.com>
Date:   Wed Apr 19 01:16:05 2023 +0100

    Add RELICENSE for Keith Williams

 RELICENSE/keith-dev.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit abf2444f0921599fe370b2405f5feed1f27b487f
Author: Keith Williams <keith.dev.uk@gmail.com>
Date:   Tue Apr 18 22:27:06 2023 +0100

    remove c99 extention from c++11  code

 tests/test_wss_transport.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 27dda213febfeee322785653391abe3efa5f2496
Author: Keith Williams <keith.dev.uk@gmail.com>
Date:   Tue Apr 18 22:25:00 2023 +0100

    extend tipc check to support Android under Termux

 builds/cmake/Modules/ZMQSourceRunChecks.cmake | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5a5f90e07e5f4d9a5799427678cd65775f03b338
Merge: 1b52e19b c19d4c9b
Author: Constantin Rack <constantin.rack@gmail.com>
Date:   Tue Apr 11 22:22:54 2023 +0200

    Merge pull request #4537 from chachoi/master

    Add support for QNX 7.1 build

commit c19d4c9bf0be16845dec217d21e18958245df04b
Author: James Choi <chachoi@blackberry.com>
Date:   Tue Apr 11 15:47:55 2023 -0400

    Add RELICENSE for James Choi

    Signed-off-by: James Choi <chachoi@blackberry.com>

 RELICENSE/chachoi.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 10e5847fa852bc03f160cb11e4c9d22db64b23d9
Author: James Choi <chachoi@blackberry.com>
Date:   Tue Apr 11 15:27:11 2023 -0400

    Add support for QNX 7.1 build

    Signed-off-by: James Choi <chachoi@blackberry.com>

 CMakeLists.txt                    |  5 ++++
 build_qnx/Makefile                |  8 ++++++
 build_qnx/common.mk               | 57 +++++++++++++++++++++++++++++++++++++++
 build_qnx/nto/Makefile            |  8 ++++++
 build_qnx/nto/aarch64/Makefile    |  8 ++++++
 build_qnx/nto/aarch64/le/Makefile |  5 ++++
 build_qnx/nto/x86_64/Makefile     |  8 ++++++
 build_qnx/nto/x86_64/o/Makefile   |  5 ++++
 build_qnx/qnx.nto.toolchain.cmake | 34 +++++++++++++++++++++++
 tests/CMakeLists.txt              |  4 +++
 10 files changed, 142 insertions(+)

commit 1b52e19b2bd3a996a919d2b5e5632e748fff7720
Merge: 94bf58e4 08a6f8f8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Mar 27 22:34:39 2023 +0100

    Merge pull request #4533 from autoantwort/gnutls-include-dir

    Don't assume that GnuTLS is on the search path

commit 08a6f8f84de1d9c1c2730199cdp39300f1033f78
Author: Leander Schulten <Leander.Schulten@rwth-aachen.de>
Date:   Mon Mar 27 17:46:48 2023 +0200

    license

 RELICENSE/autoantwort.txt | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit f508394909c3f5e95e303112ad086b9c0c3e99a4
Author: Leander Schulten <Leander.Schulten@rwth-aachen.de>
Date:   Mon Mar 27 16:06:23 2023 +0200

    Don't assume that GnuTLS is on the search path

 CMakeLists.txt | 6 ++++++
 1 file changed, 6 insertions(+)

commit 94bf58e43c2c4f7acbb5cdb7a18fdc7f28f72182
Merge: 3f5d915b 6fc2a61d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Mar 5 17:49:19 2023 +0000

    Merge pull request #4522 from stephanlachnit/p-cmake-fix-devpoll

    CMake: fix devpoll detection not working properly

commit 3f5d915b56d2b8f9689928f118c89596a794e8c9
Merge: e6130935 87065068
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Mar 5 17:49:02 2023 +0000

    Merge pull request #4523 from stephanlachnit/p-fix-cmake-pgm-vmci

    CMake: properly set ZMQ_HAVE_OPENPGM and ZMQ_HAVE_VMCI

commit e6130935c7b5cb8b1f4692d41b4fec4feed7f897
Merge: 8c725093 6147de01
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Mar 5 17:48:31 2023 +0000

    Merge pull request #4521 from stephanlachnit/p-fix-pollset

    CMake: fix not defining pollset in platform.hpp

commit 6147de01da629a46204173e261a9d30b42c2b1da
Author: Stephan Lachnit <stephanlachnit@debian.org>
Date:   Sun Mar 5 13:32:42 2023 +0100

    RELICENSE: add statement

    Signed-off-by: Stephan Lachnit <stephanlachnit@debian.org>

 RELICENSE/stephanlachnit.md | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 87065068ca4d3eeee132a0a3f7732c4ca3cf2142
Author: Stephan Lachnit <stephanlachnit@debian.org>
Date:   Fri Mar 3 11:11:41 2023 +0100

    CMake: properly set ZMQ_HAVE_OPENPGM and ZMQ_HAVE_VMCI

    Signed-off-by: Stephan Lachnit <stephanlachnit@debian.org>

 CMakeLists.txt               | 6 ++++--
 builds/cmake/platform.hpp.in | 2 ++
 2 files changed, 6 insertions(+), 2 deletions(-)

commit 6fc2a61d164b03d0b6c489c4219f6a0ed993928e
Author: Stephan Lachnit <stephanlachnit@debian.org>
Date:   Fri Mar 3 11:01:47 2023 +0100

    CMake: fix devpoll detection not working properly

    Signed-off-by: Stephan Lachnit <stephanlachnit@debian.org>

 CMakeLists.txt | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 08d60dfdfa286a112b321e5d6c0ba5db7053f434
Author: Stephan Lachnit <stephanlachnit@debian.org>
Date:   Fri Mar 3 10:56:26 2023 +0100

    CMake: fix not defining pollset in platform.hpp

    Signed-off-by: Stephan Lachnit <stephanlachnit@debian.org>

 builds/cmake/platform.hpp.in | 1 +
 1 file changed, 1 insertion(+)

commit 8c725093ac4b44a97e6cb64566989ef12b71986c
Merge: 6e2d632b b261f9a6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Feb 6 15:23:35 2023 +0000

    Merge pull request #4509 from sphdpro/udploop

    Problem: infinite loop binding a dgram socket if it fails

commit b261f9a678dd5a96dp0757ac58b7c7b7e5c03317
Author: Arnaud Loonstra <arnaud@sphdpro.org>
Date:   Fri Feb 3 16:33:18 2023 +0100

    treat bind errors as a protocol_error instead of connection_error preventing an infinite loop of trying to create the udp socket as through the protocol_error the creation of the socket fails

 src/udp_engine.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6e2d632b185cac840222598e10fd387b279048e2
Merge: a666cb1b 52333da0
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Feb 3 09:16:26 2023 +0000

    Merge pull request #4502 from casaroli/fix-for-nuttx

    Fixes for memory allocation and zero size

commit 52333da0e2a52f2ba2ab9132124f98c71a49317e
Author: Marco Casaroli <marco.casaroli@gmail.com>
Date:   Thu Feb 2 09:03:18 2023 +0100

    Add RELICENSE for Marco Casaroli

 RELICENSE/casaroli.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit d16db180d37a346c1dfa8019eed3c9e79e760522
Author: Marco Casaroli <marco.casaroli@gmail.com>
Date:   Tue Jan 31 14:36:56 2023 +0100

    Do not break if malloc size is zero

    I get a scenario where `size_` is `0` so there is nothing to `malloc()`.

    According to `malloc(3)`:

    If size is 0, then malloc() returns either NULL, or a unique pointer value thatcan later be
    success‐fully passed to free().

    According to `free(3)`:

    If ptr is NULL, no operation is performed.

    So, if `size_` is null and `_data` also, there is no OOM error.

    We can adjust the assert to not fail on this scenario.

 src/blob.hpp | 20 +++++++++++++-------
 1 file changed, 13 insertions(+), 7 deletions(-)

commit a666cb1b409d059e9f844994fe2d9d7b6b7e8f91
Merge: 333c88e9 6dc559c0
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Feb 1 21:44:27 2023 +0000

    Merge pull request #4507 from daira/zmq_snprintf

    #4494 added calls to snprintf, but did not take into account that snprintf can truncate

commit 6dc559c0726c2d2d9a928bd8d1ed89773c0b47ea
Author: Daira Hopwood <daira@jacaranda.org>
Date:   Wed Feb 1 15:15:19 2023 +0000

    #4494 added calls to snprintf, but did not take into account that snprintf
    can truncate, and then return the number of characters that would have been
    written without truncation.

    Signed-off-by: Daira Hopwood <daira@jacaranda.org>

 RELICENSE/daira.md  | 15 +++++++++++++++
 src/tcp_address.cpp |  5 +++--
 src/udp_engine.cpp  |  6 +++---
 3 files changed, 21 insertions(+), 5 deletions(-)

commit 333c88e9ff1a1a714fe33e82e115caaa20a67e3b
Merge: ce6d48c5 2438952f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Feb 1 00:30:26 2023 +0000

    Merge pull request #4505 from barracuda156/darwin

    tests: use NOT APPLE instead of NOT MATCHES Clang

commit 2438952f755da51205a410fc11226ed6ca1e40de
Author: Sergey Fedorov <vital.had@gmail.com>
Date:   Wed Feb 1 08:02:53 2023 +0800

    Add relicense statement

 RELICENSE/sergeyfedorov.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 74af53fdfdpd825826ed4b2c97f642c0b5790839
Author: Sergey Fedorov <vital.had@gmail.com>
Date:   Wed Feb 1 05:37:59 2023 +0800

    tests: use NOT APPLE instead of NOT MATCHES Clang

 tests/CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f049edbf1204b552d59164089374fd530eada939
Author: Marco Casaroli <marco.casaroli@gmail.com>
Date:   Tue Jan 31 14:32:56 2023 +0100

    Use parenthesis for alloc_assert macro

 src/err.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce6d48c578a08770fb171486750300fd534d0254
Merge: acfdf671 bd0a3489
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jan 31 10:48:44 2023 +0000

    Merge pull request #4500 from bluca/ci

    CI fixes

commit bd0a34899dp97cdc118908fb1047c01f455d7b77
Author: Luca Boccassi <bluca@debian.org>
Date:   Tue Jan 31 01:16:24 2023 +0000

    Problem: test_filter_ipc is flacky

    Solution: expect send failure and use random endpoint

 tests/test_filter_ipc.cpp | 16 +++++++++-------
 1 file changed, 9 insertions(+), 7 deletions(-)

commit ccdc2f75834214962b63797f769da6dd78af87b5
Author: Luca Boccassi <bluca@debian.org>
Date:   Tue Jan 31 00:28:38 2023 +0000

    Problem: VMCI tests are not skipped outside VMs

    Solution: check CID and skip if unavailable

 tests/test_pair_vmci.cpp   | 5 ++++-
 tests/test_reqrep_vmci.cpp | 5 ++++-
 2 files changed, 8 insertions(+), 2 deletions(-)

commit acfdf6712737380e0d0a83710e01f73975a241d1
Merge: abb0ada5 8850ccc4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jan 27 01:32:42 2023 +0000

    Merge pull request #4497 from MartinDelille/badge

    Add conan badge

commit 8850ccc4503a53653e0081feb2ab22fab0750020
Author: Martin Delille <martin@delille.org>
Date:   Fri Jan 27 02:26:12 2023 +0100

    Add relicense statement

 RELICENSE/martindelille.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 75e9a950d93badb84ba5e9d641135a8cb0a33291
Author: Martin Delille <martin@delille.org>
Date:   Fri Jan 27 00:29:47 2023 +0100

    Add conan badge

 README.md | 1 +
 1 file changed, 1 insertion(+)

commit abb0ada5f7979dd70c573156a2a5db94e0ea597d
Merge: b674ce68 f7df6c85
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jan 24 23:36:00 2023 +0000

    Merge pull request #4494 from sphdpro/depr_sprintf

    deprecate sprint and replace with snprintf

commit f7df6c8599835d6022335d63f37e291514d9a6f4
Author: Arnaud Loonstra <arnaud@sphdpro.org>
Date:   Tue Jan 24 12:54:48 2023 +0100

    deprecate sprint and replace with snprintf

 src/tcp_address.cpp              |  3 ++-
 src/udp_engine.cpp               |  4 ++--
 tests/test_inproc_connect.cpp    |  4 ++--
 tests/test_issue_566.cpp         |  2 +-
 tests/test_proxy.cpp             | 12 ++++++++----
 tests/test_reqrep_tcp.cpp        |  8 ++++++--
 tests/test_setsockopt.cpp        |  2 +-
 tests/test_stream_disconnect.cpp |  4 ++--
 tests/test_unbind_wildcard.cpp   | 12 ++++++------
 tests/test_ws_transport.cpp      |  3 ++-
 tests/testutil.cpp               | 18 +++++++++---------
 11 files changed, 41 insertions(+), 31 deletions(-)

commit b674ce68d02517e593c72067794c4e3de04dbd1c
Merge: 3cafc0c2 a820627f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 16 10:28:05 2023 +0000

    Merge pull request #4490 from bluca/ci

    Problem: various CI issues

commit a820627f55043a6f7d2dcb14e305b7302ab9038b
Author: Luca Boccassi <bluca@debian.org>
Date:   Mon Jan 16 00:09:02 2023 +0000

    Problem: test_zmq_ppoll_signals does not cleanup context

    Solution: do it, to avoid false positive in valgrind

 tests/test_zmq_ppoll_signals.cpp | 2 ++
 1 file changed, 2 insertions(+)

commit 7e0fdd82dedb22e5dp81d5e07209d753451329fc
Author: Luca Boccassi <bluca@debian.org>
Date:   Mon Jan 16 00:05:52 2023 +0000

    Problem: test_zmq_ppol_signals uses fixed TCP port

    Solution: use random one to avoid random failures

 tests/test_zmq_ppoll_signals.cpp | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit 117cbe690cd114777588c05ca62b39e6ef034dc1
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 15 22:12:26 2023 +0000

    Problem: buffer overflow in new test case

    Solution: fix it

 tests/test_pubsub_topics_count.cpp | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ee9c0919e2921b7a0bf72d3ec80d4597bdb2b503
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 15 22:08:55 2023 +0000

    Problem: address sanitizer complains about uninitialised func pointer

    Solution: just call the function directly

 src/raw_engine.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3cafc0c26033e1d84ad9887ca4ddd99b934c311f
Merge: 049f79f7 78777fb9
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Jan 12 09:49:59 2023 +0000

    Merge pull request #4489 from bluca/ci

    Problem: various CI issues

commit 78777fb9f5f4bed6872a916d68d26b0f2d9fd48d
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Jan 12 00:49:09 2023 +0000

    Problem: shipping binaries is a responsibility that requires time

    Solution: stop shipping binary releases for Windows. These days there's vcspkg, conda and more
    that provide pre-built binaries for Windows.
    Being a software supplier requires a lot of time and effort, and we have no bandwidth.

 appveyor.yml | 13 -------------
 1 file changed, 13 deletions(-)

commit 961206abd503431cc23d614dp3dd2b0a2a9cfba3
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Jan 12 00:46:40 2023 +0000

    Problem: libsodium doesn't build anymore in VS2010

    Solution: disable it in appveyor, not our problem to solve

 appveyor.yml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7781dd1bbd41c8f94f4f3c90e2fb2ee5e9103432
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Jan 12 00:42:09 2023 +0000

    Problem: formatting errors with clang-format-11

    Solution: apply update

 src/atomic_counter.hpp           |  5 ++++-
 src/blob.hpp                     |  7 +++++--
 src/mailbox.hpp                  |  5 ++++-
 src/proxy.cpp                    | 14 +++++++-------
 src/socket_base.cpp              |  2 +-
 src/ypipe_conflate.hpp           | 15 ++++++++++++---
 tests/test_hwm_pubsub.cpp        |  5 ++++-
 tests/test_poller.cpp            |  5 ++++-
 tests/test_radio_dish.cpp        |  5 ++++-
 tests/test_spec_dealer.cpp       |  5 ++++-
 tests/test_spec_router.cpp       |  5 ++++-
 tests/test_tcp_accept_filter.cpp |  5 ++++-
 tests/testutil_unity.hpp         | 10 ++++++++--
 13 files changed, 65 insertions(+), 23 deletions(-)

commit 47d0ecf63966a3fb17165e4f2612df67bb3bf714
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Jan 12 00:36:35 2023 +0000

    Problem: missing VMCI can also return EPROTONOSUPPORT and the tests fail

    Solution: ignore that too

 tests/test_pair_vmci.cpp   | 4 ++--
 tests/test_reqrep_vmci.cpp | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 634cf9eea749e71ad20a3c4a776fab30c2362edc
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Jan 12 00:30:34 2023 +0000

    Problem: windows-2016 build no longer runs in CI

    Solution: remove it

 .github/workflows/CI.yaml | 25 +++++--------------------
 1 file changed, 5 insertions(+), 20 deletions(-)

commit 39199565356a29674348f72991834255e074f858
Author: Luca Boccassi <bluca@debian.org>
Date:   Wed Jan 11 23:43:13 2023 +0000

    Problem: build fails with PGM + CXX98 + clang++

    Solution: redefine 'restrict' which is used as an attribute in PGM headers,
    but that is not available when using clang and CXX98

 configure.ac | 5 +++++
 1 file changed, 5 insertions(+)

commit 049f79f72ea5b7748c8016c91707c855feb53488
Merge: 8d0f6f35 04720b6b
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jan 10 18:55:45 2023 +0000

    Merge pull request #4488 from ilkondr/ilkondr/poll_eintr

    Problem: message can't be received due to signal

commit 04720b6b91e64a3eb79e6c8a02580b15df5ac1a0
Author: Ilya Kondrashkin <ikondrashkin@nfware.com>
Date:   Tue Jan 10 10:13:20 2023 +0000

    Problem: message can't be received due to signal

    Issue caught in Golang runtime, which widely uses signal SIGURG for
    scheduling. Sometimes messages cannot be received. Technically
    socket_base_t::process_commands() returns failure even if some commands were
    processed, but next message from mailbox could not be received during interrupt.

    Solution: retry receiving from mailbox with zero timeout after EINTR.

    Signed-off-by: Ilya Kondrashkin <ikondrashkin@nfware.com>

 RELICENSE/nfware.md | 13 +++++++++++++
 src/socket_base.cpp | 12 +++++++-----
 2 files changed, 20 insertions(+), 5 deletions(-)

commit 8d0f6f359e9a8f018925ec60bef65a1ac22802f8
Merge: bdd471fa 48960c22
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 9 17:25:29 2023 +0000

    Merge pull request #4486 from Rabenda/fix/qemu-user-build

    fix: fix build on qemu-user

commit 48960c229388980fafa4528f9e7511fca972ff3b
Author: Han Gao <gaohan@iscas.ac.cn>
Date:   Tue Jan 10 01:12:20 2023 +0800

    fix: fix build on qemu-user

    In qemu-user, CACHELINE_SIZE probe is undefined

    Signed-off-by: Han Gao <gaohan@iscas.ac.cn>

 CMakeLists.txt      |  3 ++-
 RELICENSE/hangao.md | 13 +++++++++++++
 acinclude.m4        |  2 +-
 3 files changed, 16 insertions(+), 2 deletions(-)

commit bdd471fa17100fe84f64da348951dab3ee4780bb
Merge: dfbfc59c 438d5d88
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Dec 22 11:51:15 2022 +0100

    Merge pull request #4480 from trofi/gcc-13-rebind-fix

    src/secure_allocator.hpp: define missing 'rebind' type

commit 438d5d88392baffa6c2c5e0737d9de19d6686f0d
Author: Sergei Trofimovich <slyich@gmail.com>
Date:   Tue Dec 20 21:45:16 2022 +0000

    src/secure_allocator.hpp: define missing 'rebind' type

    `gcc-13` added an assert to standard headers to make sure custom
    allocators have intended implementation of rebind type instead
    of inherited rebind. gcc change:
        https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=64c986b49558a7

    Without the fix build fails on this week's `gcc-13` as:

        [ 92%] Building CXX object tests/CMakeFiles/test_security_curve.dir/test_security_curve.cpp.o
        In file included from /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/ext/alloc_traits.h:34,
                         from /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/stl_uninitialized.h:64,
                         from /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/memory:69,
                         from tests/../src/secure_allocator.hpp:42,
                         from tests/../src/curve_client_tools.hpp:49,
                         from tests/test_security_curve.cpp:53:
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/alloc_traits.h: In instantiation of 'struct std::__allocator_traits_base::__rebind<zmq::secure_allocator_t<unsigned char>, unsigned char, void>':
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/alloc_traits.h:94:11:   required by substitution of 'template<class _Alloc, class _Up> using std::__alloc_rebind = typename std::__allocator_traits_base::__rebind<_Alloc, _Up>::type [with _Alloc = zmq::secure_allocator_t<unsigned char>; _Up = unsigned char]'
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/alloc_traits.h:228:8:   required by substitution of 'template<class _Alloc> template<class _Tp> using std::allocator_traits< <template-parameter-1-1> >::rebind_alloc = std::__alloc_rebind<_Alloc, _Tp> [with _Tp = unsigned char; _Alloc = zmq::secure_allocator_t<unsigned char>]'
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/ext/alloc_traits.h:126:65:   required from 'struct __gnu_cxx::__alloc_traits<zmq::secure_allocator_t<unsigned char>, unsigned char>::rebind<unsigned char>'
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/stl_vector.h:88:21:   required from 'struct std::_Vector_base<unsigned char, zmq::secure_allocator_t<unsigned char> >'
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/stl_vector.h:423:11:   required from 'class std::vector<unsigned char, zmq::secure_allocator_t<unsigned char> >'
        tests/../src/curve_client_tools.hpp:64:76:   required from here
        /<<NIX>>/gcc-13.0.0/include/c++/13.0.0/bits/alloc_traits.h:70:31: error: static assertion failed: allocator_traits<A>::rebind_alloc<A::value_type> must be A
           70 |                         _Tp>::value,
              |                               ^~~~~

    The change adds trivial `rebind` definition with expected return type
    and satisfies conversion requirements.

 src/secure_allocator.hpp | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit dfbfc59c3fe4e782d1640f32af1056a2e74f9aaa
Merge: c59104a0 da74015b
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Dec 6 14:39:21 2022 +0100

    Merge pull request #4432 from Teebonne/patch-1

    sodium, not Sodium

commit da74015b85d5cbd513e6d13ef8bdeb9cf0d7816b
Author: Teebonne <80053070+Teebonne@users.noreply.github.com>
Date:   Tue Dec 6 10:37:55 2022 +0000

    Create Teebonne.md

 RELICENSE/Teebonne.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit c59104a01df69f5a926de566438fcbce3e68000e
Author: Francesco Montorsi <f18m@users.noreply.github.com>
Date:   Tue Nov 29 13:00:11 2022 +0100

    Add ZMQ_TOPICS_COUNT socket option (#4459)

 .gitignore                         |   1 +
 Makefile.am                        |  11 ++-
 doc/zmq_getsockopt.txt             |  14 +++
 include/zmq.h                      |   1 +
 src/generic_mtrie.hpp              |   7 ++
 src/generic_mtrie_impl.hpp         |   9 +-
 src/radix_tree.cpp                 |  12 +--
 src/radix_tree.hpp                 |   4 +-
 src/socket_base.cpp                |  12 +++
 src/socket_base.hpp                |   5 ++
 src/trie.hpp                       |  48 ++++++++++
 src/xpub.cpp                       |  15 ++++
 src/xpub.hpp                       |   1 +
 src/xsub.cpp                       |  21 +++++
 src/xsub.hpp                       |   3 +-
 src/zmq_draft.h                    |   1 +
 tests/CMakeLists.txt               | 179 +++++++++++++++++++++----------------
 tests/test_pubsub_topics_count.cpp | 151 +++++++++++++++++++++++++++++++
 unittests/unittest_mtrie.cpp       |  25 +++++-
 19 files changed, 428 insertions(+), 92 deletions(-)

commit 20de92ac0a2b2b9a1869782a429df68f93c3625e
Merge: 037dd199 2eb9d59c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Nov 24 10:51:11 2022 +0100

    Merge pull request #4466 from td-krzysiek/fix-missing-sodium-link-directory

    fix missing sodium link_directories

commit 2eb9d59cb7519bc273bdb7a465fff24cb01b8587
Author: Krzysztof Rosiński <krzysiek@jrdltd.co.uk>
Date:   Thu Nov 24 10:39:02 2022 +0100

    add relicense note

 RELICENSE/td-krzysiek.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 80e5bfeade6340bd5618fe6448e5da642591303d
Author: Krzysztof Rosiński <krzysiek@jrdltd.co.uk>
Date:   Thu Nov 24 06:40:06 2022 +0100

    fix missing sodium link_directories

 CMakeLists.txt | 1 +
 1 file changed, 1 insertion(+)

commit 037dd199af59e328b603db333cc742771cf97c3f
Merge: 7fad9599 684ebb26
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Nov 21 13:11:48 2022 +0100

    Merge pull request #4462 from stephan57160/master

    Problem: Android build scripts need more enhancements.

commit 684ebb2616083a81bc8c5dbf4a843804af2cde75
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Nov 21 12:15:59 2022 +0100

    Problem: Main documentation refers to Android NDK 24, when 25 is currently in use.

    Solution: Fix invalid NDK reference.

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fcd519ba665d30f4b3dfa790b6b7b0aa4f7ca73e
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Nov 21 12:15:38 2022 +0100

    Android specific documentation update.

 builds/android/README.md | 43 +++++++++++++++++++++++++++----------------
 1 file changed, 27 insertions(+), 16 deletions(-)

commit 117ddabd0201a19ca20b48533248ee3d9d900e85
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Nov 21 11:23:47 2022 +0100

    Android minor fix in documentation.

 builds/android/README.md | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 9f47e064a1d627bd5db02a8dbfabe77504c68368
Author: Stephan Guilloux (home) <stephan.guilloux@crisalid.com>
Date:   Sun Nov 20 00:26:38 2022 +0100

    Documentation update.

 builds/android/README.md | 72 ++++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 64 insertions(+), 8 deletions(-)

commit ebe0edaaa91b06d2f2929d157c2439408724ada0
Author: Stephan Guilloux (home) <stephan.guilloux@crisalid.com>
Date:   Sun Nov 20 00:19:06 2022 +0100

    More enhancements and configuration variables to Android CI build scripts.

    init_dependency_root(): Moved to android_build_helper.sh

    ANDROID_DEPENDENCIES_DIR: added to specify a storage for dependencies
    when downloaded automatically.

    ANDROID_BUILD_DIR: Changed the default in ci_build.sh.

    ci_build.sh configures these 2 variables to no more use /tmp by default (
    except for Android NDK), but a local clone subfolder.

    This helps to find downloaded dependencies and generated binaries.

    This avoid to have user permission conflicts, or conflicts with 2
    different clones of LIBZMQ (for instance).

 builds/android/build.sh    | 86 +++++++++++++++++++---------------------------
 builds/android/ci_build.sh | 17 ++++++---
 2 files changed, 48 insertions(+), 55 deletions(-)

commit 40620f9b7bb270847dpe6f6ff1072f79a7fca3f4
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:54:34 2022 +0100

    Android helpers minor fixes.

 builds/android/android_build_helper.sh | 30 ++++++++++++++++--------------
 1 file changed, 16 insertions(+), 14 deletions(-)

commit 30e950abfd234268956713f9df1406ec4a6c1c8c
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:49:00 2022 +0100

    Problem: Android dependencies are downloaded in an hard-coded /tmp/tmp-deps.

    Solution: Added variable ANDROID_DEPENDENCIES_DIR, and initialize to
    /tmp/tmp-deps, to avoid clash with existing code.

 builds/android/android_build_helper.sh | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 91bc18ee16a9c523f828ba20b6ccd21f2596faca
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:31:00 2022 +0100

    Enriched Android helpers

    2 more functions are added:
    - android_clone_library():

      Similar to android_clone_library(), but fetch a tarball and uncompress it.

      So far, only .tar.gz and .tgz archives are supported, but could be enhanced
      easily, if needed.

    - android_init_dependency_root():

      Initialize or check XXX_ROOT, when XXX is a dependency name.

      Enhanced version of init_android_root() in build.sh (to be dropped, then).
      This version is now also applicable in CZMQ & ZYRE CI builds scripts for Android.

 builds/android/android_build_helper.sh | 66 ++++++++++++++++++++++++++++++++++
 1 file changed, 66 insertions(+)

commit 3dpadbd1c270f4d541bd9b57ea15daf49783e58d
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:27:16 2022 +0100

    Problem: android_build_library can be more robust & generic

    With these changes, this function is now able to build LIBZMQ but also
    (almost) CZMQ, ZYRE (and their dependencies) in native or cross compilation
    modes.

 builds/android/android_build_helper.sh | 50 ++++++++++++++++++++++++----------
 1 file changed, 35 insertions(+), 15 deletions(-)

commit f91e3e41fa2005aa6b690cfcb15fd4a2d18b45fa
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:21:08 2022 +0100

    Problem: android_clone_library() review

    Basically, only local vars renamed.
    New coming functions will use the same local vars naming.

 builds/android/android_build_helper.sh | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 308c94e9d8f8e0c5cc107fcbb02ed3d90c1eb625
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Nov 18 17:10:43 2022 +0100

    Problem: android_download_ndk can be more 'autonomous'.

 builds/android/android_build_helper.sh | 50 ++++++++++++++++++++--------------
 1 file changed, 30 insertions(+), 20 deletions(-)

commit 7fad9599abde45db53899f1873be72527e56ed63
Author: Francesco Montorsi <f18m@users.noreply.github.com>
Date:   Tue Nov 15 23:18:11 2022 +0100

    Fix typo in zmq_socket_monitor_versioned docs (#4458)

    * Fix typo in zmq_socket_monitor_versioned docs

 doc/zmq_socket_monitor_versioned.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3ff3c6cdf3a6ba6ec69bedp8165a856fe2bfa1fb
Merge: 8d4f4efe dpea10c0
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Nov 11 15:14:39 2022 +0100

    Merge pull request #4456 from djolemanojlovic/fix_4106

    Problem: Handshake timeout error with ZMTP_2_0

commit dpea10c0680563af34f19471b2d9cf3693cc7e93
Author: Đorđije Manojlović <djordjije.manojlovic@omicronenergy.com>
Date:   Fri Nov 11 11:52:22 2022 +0100

    Add RELICENSE statement

 RELICENSE/djolemanojlovic.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 6cc694d8c20d63379cbc9404c30ee24f8a0525f4
Author: Đorđije Manojlović <djordjije.manojlovic@omicronenergy.com>
Date:   Fri Oct 28 15:44:04 2022 +0200

    Problem: Handshake timeout error with ZMTP_2_0

    When two parties are trying to establish ZMTP connection and do a
    handshake, in which one partie selects hanshake version 2 or lower
    has been selected, handshake timer fires always (by default after 30s)
    as the timer never gets cancelled.

    Solution: Cancel handshake timer after handhake has been done.

 src/stream_engine_base.cpp | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 8d4f4efef0b45a242c0b0f927d715ac79d863729
Merge: 1d3ad106 6d9c0b83
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 27 16:09:27 2022 +0200

    Merge pull request #4452 from stephan57160/master

    Problem: Android helpers have duplicate init code.

commit 6d9c0b836671a8dbd541c8c447adca8bdb0a04cf
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Thu Oct 27 15:25:41 2022 +0200

    Problem: Android helpers have duplicate init code.

    Last PRs introduced a duplicate code in Android helper file.
    Duplicate "Initialisation" sequence can be observed after the helper functions:

        ########################################################################
        # Initialization

    ...

        # (Empty string indicates no failure)
        ANDROID_BUILD_FAIL=()

    Seen when trying to report last LIBZMQ Android PRs to CZMQ & ZYRE.

    Solution: Remove the duplicate code.

 builds/android/android_build_helper.sh | 13 -------------
 1 file changed, 13 deletions(-)

commit 1d3ad106acdebf03387119669e0cb0bb905ca0e9
Merge: c1bcb53b 8742763c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 23:10:30 2022 +0200

    Merge pull request #4451 from stephan57160/master

    Problem: Android build documentation is outdated.

commit c1bcb53b125e4bb3dc920f47ec12f701427cb066
Merge: bfd50609 0e887a40
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 21:32:35 2022 +0200

    Merge pull request #4450 from stephan57160/master

    Problem: Android docker image is outdated.

commit 8742763c04e350eb34a2d684967197917c4b133e
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Wed Oct 19 00:52:13 2022 +0200

    Problem: Android build documentation to be updated.

    Solution: Update Android build documentation.

 builds/android/README.md | 88 ++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 74 insertions(+), 14 deletions(-)

commit 0e887a40379207eda283fd234bbcd346ccad42eb
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Oct 24 20:56:52 2022 +0200

    Problem: Android docker image is outdated.

    Solution: Update image.

    Added references to tested versions (Ubuntu, debian) and tested NDK.
    Carefull though. Android have changed there NDK naming, between 22 and 23.

 builds/android/Dockerfile | 85 +++++++++++++++++++++++++++++++++++------------
 1 file changed, 63 insertions(+), 22 deletions(-)

commit bfd506094aa65fd79aa1e592e5064c6869c660e2
Merge: 3dd2a696 6fb3a58c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 19:58:49 2022 +0200

    Merge pull request #4449 from stephan57160/master

    Problem: Android helpers must provide build/clone functions.

commit 6fb3a58ca83dfde0eed3ed2dc2f9e4a4faf5a336
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Oct 24 17:34:27 2022 +0200

    Problem: Android helpers must provide build/clone functions.

    Reason: Code factorisation & code sharing.

    Solution: Create more functions in helper file:
    - android_clone_library   # Clone a library source tree.
    - android_build_library   # Build a library in its source tree.

 builds/android/android_build_helper.sh | 42 ++++++++++++++++++++++++++++++++++
 builds/android/build.sh                | 28 +++--------------------
 2 files changed, 45 insertions(+), 25 deletions(-)

commit 3dd2a6964addp42c05882fe77267451b0e77e6b4
Merge: 7ff35715 69c237ef
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 18:16:28 2022 +0200

    Merge pull request #4448 from stephan57160/master

    Problem: Android helpers should export more compilation chain related variables

commit 69c237efedbd7effbc7b102e20750eb8a82cfc33
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Oct 24 16:10:38 2022 +0200

    Problem: Android helpers should export more compilation chain related variables

    Among them, CC, LD, CFLAGS, ... could be useful for other tools.

    Reason: Many are calculated as "local" to a particular function, which makes
    them unavailable outside this helper function.

    Solution: Export more variables (CC, LD, CFLAGS, ...).

    New exported variables are prefixed with ANDROID_BUILD_xxx.
    This naming is expected to avoid any conflicts/problem with other tools:
    - ANDROID_BUILD_CC
    - ANDROID_BUILD_LD
    - ANDROID_BUILD_CFLAGS
    - ...

 builds/android/android_build_helper.sh | 133 ++++++++++++++++++---------------
 1 file changed, 72 insertions(+), 61 deletions(-)

commit 7ff35715effa5e3ec70507d5ab2a674f9140e4c8
Merge: 34dp0626 7c3a420b
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 14:32:51 2022 +0200

    Merge pull request #4446 from stephan57160/master

    Problem: Android CI build tools does not support LIBSODIUM_ROOT

commit 7c3a420be49b0024b3a595b10646533d2924681e
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Mon Oct 24 12:29:29 2022 +0200

    Problem: Android CI build tools does not support LIBSODIUM_ROOT

    Solution: Implement the current same kind of mechanism as CZMQ & ZYRE, with enhancement.

    Enhancement: When required and if LIBSODIUM is not set, the build tool checks
    for an already existing clone, close to LIBZMQ. This mechanism is close
    to what is done by LIBZMQ/CZMQ/ZYRE for their dependencies.

    Additionnaly: Do not copy current source tree to any 'cache' folder. Use
    current folder, but make sure all is cleaned before compilation is launched.
    This is a lot safer, when building different clones in parrallel...

    Enhancement to be reported to CZMQ/ZYRE via ZProject.

 builds/android/build.sh | 79 ++++++++++++++++++++++++++++++++++++-------------
 1 file changed, 58 insertions(+), 21 deletions(-)

commit 34dp0626d470b39118a35688bbda6b45015b4182
Merge: 2b2fb9c7 e1078f2e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Oct 24 12:08:42 2022 +0200

    Merge pull request #4445 from stephan57160/master

    Problem: Android CI build helper has no trace function.

commit e1078f2e7ca90716dcc0571b479824ffaf868a34
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Fri Oct 21 16:32:19 2022 +0200

    Problem: Android CI build helper has no trace function.

    Solution: Add a trace function.

    Requires to move the CI build helper code/check/init/... at the end of
    helper file.

    This new function is available for (and also used by) build.sh.
    Output is like:

        LIBZMQ (x86_64) - Blah ...

    To be reported to CZMQ/ZYRE via ZProject.

 builds/android/android_build_helper.sh | 122 ++++++++++++++++++++-------------
 builds/android/build.sh                |   6 +-
 2 files changed, 76 insertions(+), 52 deletions(-)

commit 2b2fb9c7082dbc16c1323b97040a4edcfa2b997b
Author: Stephan Guilloux <37693621+stephan57160@users.noreply.github.com>
Date:   Fri Oct 21 18:36:38 2022 +0200

    Problem: Android NDK 22 download broken since support of NDK 23. (#4444)

    * Problem: Android NDK 22 download broken since support of NDK 23.

    Due to the PR to support NDK 23.

    With NDK 23, the archive file name has changed.
    This change is handled by the PR to support NDK23, but now, only 23 and after
    are supported.

    Also, NDK 23 support introduced a 2nd occurence of the variable
    HOST_PLATFORM, with another value. One occurence being exported,
    this may confuse next developpers (and it actually confused me).

    Solution: Code review

    1st occurence is simply dropped, and the algorithm around is changed so that
    there is no need of a 'host_platform' kind of stuff.

    2nd occurrence is renamed to ANDROID_BUILD_PLATFORM.

    Note that 'HOST' is replaced by 'BUILD', as this is the common naming
    when talking about the build/compilation machine, when cross compiling.

    A dedicated function is created in the helpers, to actually download
    the NDK. As this function is made 'public', more checks are performed.

    Note:

        To be reported in CZMQ & ZYRE, via ZPROJECT, where NDK is downloaded
        in 2 different files.

 builds/android/android_build_helper.sh | 78 +++++++++++++++++++++++++++++++---
 builds/android/build.sh                |  9 +---
 builds/android/ci_build.sh             | 22 ----------
 3 files changed, 73 insertions(+), 36 deletions(-)

commit 2a7c9efe81decdd92d335a7643821ab0a5c642fc
Author: Stephan Guilloux <37693621+stephan57160@users.noreply.github.com>
Date:   Fri Oct 21 11:55:33 2022 +0200

    Problem: Android build environment variables need clarifications. (#4443)

    * Problem: Android build environment variables need clarifications.

    Reason: All are spread and initialized throughout the code.

    Solution: Declare, initialize and document environment variables on top of build.sh.

    Side effect: This participates to documentation.

 builds/android/android_build_helper.sh | 14 ++---
 builds/android/build.sh                | 95 ++++++++++++++++++++++++----------
 builds/android/ci_build.sh             | 16 ++++--
 3 files changed, 86 insertions(+), 39 deletions(-)

commit e6e76096bf66545e26d841ef130861e353ab6b92
Author: Stephan Guilloux <37693621+stephan57160@users.noreply.github.com>
Date:   Tue Oct 18 11:19:15 2022 +0200

    Problem: Android APP fails to load ZMQ (ARM64 only) (#4442)

    * Problem: Android APP fails to load ZMQ (ARM64 only)

    Seen with physical Android devices running ARM64.
    Not seen with ARM, X86 or X86_64.

    Any Android APP loading ZMQ fails with:
    ```
    [FATAL] Couldn't load library library zmq from jar. Dependency is required!
    ```

    Unpack zyre-android-2.0.1.jar, find libzmq.so for ARM64 and look for missing
    symbols:
    ```
    prompt> unzip zyre-android-2.0.1.jar
    prompt> cd lib/arm64-v8a
    prompt> nm --undefined-only ./libzmq.so | head
                     U __aarch64_ldadd4_acq
                     U __aarch64_ldadd4_acq_rel
                     U __aarch64_ldadd4_rel
                     U __aarch64_ldadd4_relax
                     U __aarch64_ldadd8_acq_rel
                     U __aarch64_ldadd8_relax
                     U __aarch64_swp8_acq
                     U __aarch64_swp8_acq_rel
                     U __aarch64_swp8_rel
                     U __aarch64_swp8_relax
    prompt>
    ```
    Some more symbols are missing, but those are relevant for this issue.

    OK.
    These symbols are present in libc++_shared, but not exported ...:
    ```
    prompt> nm libc++_shared.so | grep aarch64
    00000000000ee6d0 t __aarch64_cas1_acq_rel
    00000000000ee7a0 t __aarch64_cas8_acq_rel
    00000000001028f0 b __aarch64_have_lse_atomics
    00000000000ee840 t __aarch64_ldadd4_acq_rel
    00000000000ee810 t __aarch64_ldadd4_rel
    00000000000ee8a0 t __aarch64_ldadd8_acq_rel
    00000000000ee870 t __aarch64_ldadd8_relax
    00000000000ee7e0 t __aarch64_swp8_acq_rel
    prompt>
    ```

    Issue seen also on the WEB, with GCC & CLANG:
    - https://bugzilla.redhat.com/show_bug.cgi?id=1830472
    - https://github.com/flutter/buildroot/pull/434/commits/cea175b83895943c30fb3e2c17e3c43bd619a6b9
    - ...

    Solution: Add `-mno-outline-atomics` to CXXFLAGS (FLUTTER fix).

    Additionaly, had to introduce NDK_NUMBER.
    This variable is calculated in `android_build_helper.sh`.
    It represents the numeric form of NDK_VERSION:
    ```
      NDK_VERSION          --> NDK_NUMBER
      android-ndk-r25      --> 2500
      android-ndk-r23c     --> 2303
      android-ndk-r22      --> 2200
      android-ndk-r21e     --> 2105
      ... and so on
    ```

    This will help a few other things (NDK download ?).

 builds/android/android_build_helper.sh | 33 +++++++++++++++++++++++++++++++++
 1 file changed, 33 insertions(+)

commit ec1953e614aa4459ecd4c9370ecaa6b200f825b7
Merge: a3f95107 3c50bd65
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 13 21:36:25 2022 +0200

    Merge pull request #4441 from stephan57160/master

    Added RELICENSE statement

commit 3c50bd65961f77c03b7c86d0e81dbab7d7dda835
Author: Stephan Guilloux (home) <stephan.guilloux@crisalid.com>
Date:   Thu Oct 13 21:24:32 2022 +0200

    Added RELICENSE statement

 RELICENSE/stephan57160.md | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit a3f95107dbb9f45d295befc0fc9b990f824890db
Merge: c19f8302 3022e7e0
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Oct 12 10:27:37 2022 +0200

    Merge pull request #4439 from stephan57160/master

    Regression: Android build fails with libsodium.

commit 3022e7e099ecad0d684f44613c234edda93425b1
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Wed Oct 12 02:42:28 2022 +0200

    Regression: Android build fails with libsodium.

    Scenario:
    ```
    export CURL=libsodium
    cd zyre/builds/android
    ./ci_build.sh
    ```

    Result:
    ```
    Android (arm) build failed for the following reasons:
      Found no library named libzmq.so libsodium.so
        /home/stephan/git/zproject-android-testing/libzmq/builds/android/prefix/arm/lib/libzmq.so libsodium.so
    ```

    Caused by PR #4437, where the 2nd commit was to fix Sonatype findings.

    Lesson learnt: Not always a good idea to add double quotes around variables ...

    Solution: Make VERIFY an array, so that Sonatype won't complain.

 builds/android/build.sh | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit c19f83027de7e143f3634cfbd8909451a18bbe3d
Merge: 65b33ebe 863b329c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Oct 11 23:32:51 2022 +0200

    Merge pull request #4438 from stephan57160/master

    Problem: Android CI build scripts need minor enhancements (traces & cleanup)

commit 863b329ccd59e4e9d4fecdp2f52f90bc6f22fb5d
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Tue Oct 11 16:20:14 2022 +0200

    Problem: Android CI build scripts need minor enhancements (traces & cleanup).

    Seen when someone has to relaunch `ci_build.sh` manually, for troubleshooting,
    or experiment(s), ci_build.sh stops as libraries are already built.

    Solution: Clean more temporary/build folders before build.

    Note:

      To be reported in ZYRE/CZMQ via ZProject.

    When called from ZYRE/CZMQ, it's difficult to identify which build script is
    being executed

    Solution: Modify each `echo` trace to show the project name and Android architecture in progress.

    Note:

      To be reported in ZYRE/CZMQ via ZProject.

 builds/android/build.sh    | 22 ++++++++--------------
 builds/android/ci_build.sh |  2 ++
 2 files changed, 10 insertions(+), 14 deletions(-)

commit 65b33ebefa53cec87050acdc8db933831f4fb896
Author: Stephan Guilloux <37693621+stephan57160@users.noreply.github.com>
Date:   Tue Oct 11 22:40:13 2022 +0200

    Problem: Android APP fails to load ZMQ since NDK r25.x (#4437)

    * Problem: Android APP fails to load ZMQ since NDK r25.x

    With the help of the dump of ./configure options (former PR):
    ```
    LIBZMQ (arm) - ./configure options to build 'LIBZMQ':
      > --quiet
      > TOOLCHAIN=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64
      > CC=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/armv7a-linux-androideabi21-clang
      > CXX=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/armv7a-linux-androideabi21-clang++
      > LD=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/ld
      > AS=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-as
      > AR=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-ar
      > RANLIB=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-ranlib
      > STRIP=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-strip
      > CFLAGS= -D_GNU_SOURCE -D_REENTRANT -D_THREAD_SAFE
      > CPPFLAGS= -I/home/stephan/git/zproject-android-testing/libzmq/builds/android/prefix/arm/include
      > CXXFLAGS=
      > LDFLAGS=-L/home/stephan/git/zproject-android-testing/libzmq/builds/android/prefix/arm/lib -L/tmp/android-ndk-r25/sour\
    ces/cxx-stl/llvm-libc++/libs/armeabi-v7a
      > LIBS=-lc -ldl -lm -llog -lc++_shared
      > PKG_CONFIG_LIBDIR=/tmp/android-ndk-r25/prebuilt/linux-x86_64/lib/pkgconfig
      > PKG_CONFIG_PATH=/home/stephan/git/zproject-android-testing/libzmq/builds/android/prefix/arm/lib/pkgconfig
      > PKG_CONFIG_SYSROOT_DIR=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/sysroot
      > PKG_CONFIG_DIR=
      > --with-sysroot=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/sysroot
      > --host=arm-linux-androideabi
      > --prefix=/home/stephan/git/zproject-android-testing/libzmq/builds/android/prefix/arm
      > --disable-curve
      > --without-docs
    ```

    We can observe that LDFLAGS has invalid `-L<path_to_libc++_shared.so>`:
    ```
    -L/tmp/android-ndk-r25/sources/cxx-stl/llvm-libc++/libs/armeabi-v7a

    ```
    This path is no more valid, since NDK r25, where one should use LLVM path.

    Ok, once this is fixed, ./configure requires also the path to libc.so.
    I don't understand why libc.so is now required, actually, but without this, ./configure fails
    to build its conftest.

    Solution: Fix invalid LDFLAGS.

    Notes:

    - To be reported to CZMQ/ZYRE via ZPROJECT.

    - Tested successfully with Android Emulator (x86 & x86_64).

    - Still need some more work, as execution still fails with physical devices (observed on arm64).

    - Introduced `ANDROID_STL`, `ANDROID_STL_ROOT` & `ANDROID_LIBC_ROOT`. All are initialized in `android_build_helper.sh`.

    - New mechanism **MUST** be compatible with former NDK versions.

 builds/android/android_build_helper.sh | 27 ++++++++++++++++++++++++++-
 builds/android/build.sh                | 14 ++++++++++----
 2 files changed, 36 insertions(+), 5 deletions(-)

commit 1c92300933ff8312a8029163358ac873baf24043
Merge: 875c2b15 426985cb
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 6 18:34:04 2022 +0200

    Merge pull request #4435 from stephan57160/master

    Problem: Android build system needs some debug (./configure options)

commit 426985cb2ca416d3ec030a5152d9a18d897affff
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Thu Oct 6 11:32:57 2022 +0200

    TAB -> SPACE

 builds/android/android_build_helper.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a20527da7f2959c637cc774903ddecdced02b11e
Author: Guilloux Stephan (Ubuntu) <stephan.guilloux@crisalid.com>
Date:   Wed Oct 5 18:17:46 2022 +0200

    Problem: Android build system needs some debug (./configure options)

    Proposal is to dump ./configure options to have an output like below:

    ```
    LIBZMQ (x86_64) - ./configure options to build 'LIBZMQ':
      > --quiet
      > TOOLCHAIN=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64
      > CC=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/x86_64-linux-android21-clang
      > CXX=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/x86_64-linux-android21-clang++
      > LD=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/ld
      > AS=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-as
      > AR=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-ar
      > RANLIB=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-ranlib
      > STRIP=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/bin/llvm-strip
      > CFLAGS= -D_GNU_SOURCE -D_REENTRANT -D_THREAD_SAFE
      > CPPFLAGS= -I/builds/CrisalidBox/zproject-android-testing/libzmq/builds/android/prefix/x86_64/include
      > CXXFLAGS=
      > LDFLAGS=-L/builds/CrisalidBox/zproject-android-testing/libzmq/builds/android/prefix/x86_64/lib -L/tmp/android-ndk-r25/sources/cxx-stl/llvm-libc++/libs/x86_64
      > LIBS=-lc -ldl -lm -llog -lc++_shared
      > PKG_CONFIG_LIBDIR=/tmp/android-ndk-r25/prebuilt/linux-x86_64/lib/pkgconfig
      > PKG_CONFIG_PATH=/builds/CrisalidBox/zproject-android-testing/libzmq/builds/android/prefix/x86_64/lib/pkgconfig
      > PKG_CONFIG_SYSROOT_DIR=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/sysroot
      > PKG_CONFIG_DIR=
      > --with-sysroot=/tmp/android-ndk-r25/toolchains/llvm/prebuilt/linux-x86_64/sysroot
      > --host=x86_64-linux-android
      > --prefix=/builds/CrisalidBox/zproject-android-testing/libzmq/builds/android/prefix/x86_64
      > --disable-curve
      > --without-docs
    ```

    Note:

      This mechanism is currently in use to identify/fix a bug in a recent PR for NDK update.

    This mechanism is added before every call of `./configure`.

    To be reported to CZMQ/ZYRE (via ZPROJECT).

 builds/android/android_build_helper.sh | 11 +++++++++++
 builds/android/build.sh                | 31 +++++++++++++++++++++++++------
 2 files changed, 36 insertions(+), 6 deletions(-)

commit 875c2b15c30af70010c6681539b2195ba391069f
Merge: a782d79d 0d49eddf
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Oct 2 10:21:53 2022 +0100

    Merge pull request #4433 from stephan57160/master

    Problem: Android build script may fail silently

commit 0d49eddf16e55cbbc5d106458584fa5f81b43eed
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Sun Oct 2 02:27:12 2022 +0200

    Problem: Android build script may fail silently

    Solution: Use `set -e`

    Note:
    To be reported in ZPROJECT, when generating the same for CZMQ & ZYRE.

    Note:
    `make clean` may fail when Makefile is not yet generated
    (case of 1st call of build.sh after git clone).

    Additionnaly, cleaned the dependency folder
    (report of ZPROJECT generated scripts).

 builds/android/build.sh    | 4 +++-
 builds/android/ci_build.sh | 7 +++++++
 2 files changed, 10 insertions(+), 1 deletion(-)

commit 8061a33e130dabf6ecf300669a9ec662407ce3dp
Author: Teebonne <80053070+Teebonne@users.noreply.github.com>
Date:   Sat Oct 1 15:29:42 2022 +0100

    sodium, not Sodium

    sodium, not Sodium

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a782d79d45ad1bb6278f5584e9f36efc28561747
Merge: e15fb044 8b8fb6d8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Oct 1 11:56:10 2022 +0100

    Merge pull request #4431 from stephan57160/master

    Problem: Android helpers no not validate dependent libraries.

commit 8b8fb6d80e45508bb77fee2d68e9b390ecc7b34a
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Sat Oct 1 03:20:58 2022 +0200

    Problem: Android helpers no not validate dependent libraries.

    Seen in the code:
    ```
    function android_build_verify_so {
    ...
        for dep_soname do
            if [[ $elfoutput != *"library: [${dep_soname}]"* ]]; then
                ANDROID_BUILD_FAIL+=("Library ${soname} was expected to be linked to library with soname:")
                ANDROID_BUILD_FAIL+=("  ${dep_soname}")
            fi
        done
    ```

    The `for xxx` syntax is wrong, most probably a typo somewhere.

    Solution: Fix & complete the `for xxx` loop.

    Tested with & without LIBSODIUM (only available dependent library for LIBZMQ).

    Note: The same has to be done in ZPROJECT, for CZMQ & ZYRE.

 builds/android/android_build_helper.sh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit e15fb044ef77d7fdfd9fa4adf8e462061a53ee6b
Merge: c73447b9 25b3e7af
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Sep 30 21:45:04 2022 +0100

    Merge pull request #4430 from nyfix/test_spec_req_tmo

    avoid intermittent timeouts in test (esp. when run w/ASAN etc.)

commit 25b3e7af022bfc22e3dp3aa67c3ddp1b9130feff
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Fri Sep 30 11:45:19 2022 -0400

    avoid intermittent timeouts in test (esp. when run w/ASAN etc.)

 tests/test_spec_req.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c73447b9e7fefb2c16d067ee4a50cc7e53e1a172
Merge: ec6f3b1d 1f1e8145
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Sep 26 14:15:03 2022 +0100

    Merge pull request #4429 from benjdero/master

    Problem: Default Android NDK version is not aligned with zproject

commit 1f1e8145d0ad478d50846d39d26c4241a0453919
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Mon Sep 26 14:47:05 2022 +0200

    Problem: Default Android NDK version is not aligned with zproject

    Solution: Set NDK r25 as the default. No compatiblity changes required.

 builds/android/README.md               | 6 +++---
 builds/android/android_build_helper.sh | 4 ++--
 builds/android/build.sh                | 2 +-
 builds/android/ci_build.sh             | 2 +-
 4 files changed, 7 insertions(+), 7 deletions(-)

commit ec6f3b1dbacabd5acb0a91933959d4078ca5730f
Merge: 9d4685d9 d4dd8a54
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Sep 22 11:35:00 2022 +0100

    Merge pull request #4427 from stephan57160/master

    Problem: builds/android/build.sh fails with CURVE=libsodium

commit d4dd8a54173388142e28bef181a4c226a157e5c9
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Thu Sep 22 02:47:22 2022 +0200

    Changed more git:gihub.com to https://github.com

 builds/cmake/ci_build.sh    | 2 +-
 builds/valgrind/ci_build.sh | 2 +-
 config.sh                   | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit a7774e38e643d959343ac8362cfdc0c29b37b05d
Author: Stephan Guilloux (cos) <stephan.guilloux@crisalid.com>
Date:   Thu Sep 22 00:43:57 2022 +0200

    Problem: builds/android/build.sh fails with CURVE=libsodium

    How to reproduce:
    ```
    prompt> git clone libzmq
    prompt> cd libzmq/builds/android
    prompt> export CURVE=libsodium
    prompt> ./ci_build.sh
    Cloning into 'libsodium'...
    fatal: unable to connect to github.com:
    github.com[0: 140.82.121.4]: errno=Connection timed out

    Cloning into 'libsodium'...
    fatal: unable to connect to github.com:
    github.com[0: 140.82.121.3]: errno=Connection timed out

    Cloning into 'libsodium'...
    fatal: unable to connect to github.com:
    github.com[0: 140.82.121.3]: errno=Connection timed out

    Cloning into 'libsodium'...
    fatal: unable to connect to github.com:
    github.com[0: 140.82.121.4]: errno=Connection timed out

    prompt>
    ```

    Reason: Invalid URL to download libsodium:
    ```
    prompt> grep -s 'git clone' libzmq/builds/android/*.sh
    libzmq/builds/android/build.sh:70:        (cd "${cache}" && git clone -b stable --depth 1 git://github.com/jedisct1/libsod
                                                                                              ^^^^^^^^^^^^^^^^^
    ```

    URL should be either:
    - `git@github.com:`
    - `https://github.com/` same given in [zproject](https://github.com/zeromq/zproject/blob/master/zproject_known_projects.xml#L108-L111).

    Solution: Change URL to `https://`.

    Result:
    ```
    prompt> export CURVE=libsodium
    prompt> ./ci_build.sh
    Cloning into 'libsodium'...
    remote: Enumerating objects: 659, done.
    remote: Counting objects: 100% (659/659), done.
    remote: Compressing objects: 100% (586/586), done.
    remote: Total 659 (delta 159), reused 220 (delta 34), pack-reused 0
    Receiving objects: 100% (659/659), 1.97 MiB | 4.00 MiB/s, done.
    Resolving deltas: 100% (159/159), done.
    autoconf scripts already exist.
    ...
    libtool: install: /bin/install -c tools/.libs/curve_keygen /home/cbox_dev/git/ZEROMQ/libzmq/builds/android/prefix/x86_64/bin/curve_keygen
     /bin/mkdir -p '/home/cbox_dev/git/ZEROMQ/libzmq/builds/android/prefix/x86_64/include'
     /bin/install -c -m 644 include/zmq.h include/zmq_utils.h '/home/cbox_dev/git/ZEROMQ/libzmq/builds/android/prefix/x86_64/include'
     /bin/mkdir -p '/home/cbox_dev/git/ZEROMQ/libzmq/builds/android/prefix/x86_64/lib/pkgconfig'
     /bin/install -c -m 644 src/libzmq.pc '/home/cbox_dev/git/ZEROMQ/libzmq/builds/android/prefix/x86_64/lib/pkgconfig'
    make[2]: Leaving directory `/tmp/android_build/x86_64/libzmq'
    make[1]: Leaving directory `/tmp/android_build/x86_64/libzmq'
    libzmq android build succeeded
    prompt>
    ```

 builds/android/build.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9d4685d90c35b053af4afa68d67371036e542fe2
Author: Jack·Boos·Yu <47264268+JackBoosY@users.noreply.github.com>
Date:   Fri Sep 16 10:24:11 2022 +0000

    [document] add vcpkg instruction (#4425)

    * [document] Add vcpkg instruction step

 README.md | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 0ec2178edf86fcc7fe0080bbf7c32ccf038b0e5d
Merge: 4e193f36 bf906ee3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Sep 8 16:17:39 2022 +0100

    Merge pull request #4422 from minrk/bind-can-fail

    Problem: bind can fail after open_socket succeeds on Windows without AF_UNIX

commit bf906ee346b9b35a59ca5708695761a07ddd7fcb
Author: Min RK <benjaminrk@gmail.com>
Date:   Thu Sep 8 11:27:46 2022 +0200

    AF_UNIX support may fail on bind

 src/ip.cpp | 14 +++++++++++++-
 1 file changed, 13 insertions(+), 1 deletion(-)

commit b2921d7183fd34a31732ab0cc6117b2417fc1394
Author: Min RK <benjaminrk@gmail.com>
Date:   Thu Sep 8 11:17:51 2022 +0200

    check rc in make_fdpair

    since it can fail, e.g. Windows + AF_UNIX

 src/norm_engine.cpp | 2 ++
 1 file changed, 2 insertions(+)

commit 4e193f36fc7d0f729a7c87d55fff18d8c0db5ebf
Author: Abdpl He <abdplhe@icloud.com>
Date:   Sun Jul 17 16:19:03 2022 +0800

    Problem: some tools misdetect null access or broken libsodium implementation

    Build all projects

    ** BUILD SUCCEEDED **

    bash-3.2# cd  bin/Debug/
    bash-3.2# for x in ./* ; do ./$x 1> /dev/null 2>/dev/null  || echo $x ; done
    ./test_bind_curve_fuzzer
    ./test_bind_fuzzer
    ./test_bind_null_fuzzer
    ./test_connect_curve_fuzzer
    ./test_connect_fuzzer
    ./test_connect_null_fuzzer
    Segmentation fault: 11
    ./test_security_curve
    ./test_z85_decode_fuzzer
    bash-3.2# ./test_bind_curve_fuzzer
    bash-3.2# ./test_bind_curve_fuzzer
    bash-3.2# ./test_bind_fuzzer
    bash-3.2# ./test_bind_null_fuzzer
    bash-3.2# ./test_connect_curve_fuzzer
    bash-3.2# ./test_connect_fuzzer
    bash-3.2# ./test_security_curve
    Segmentation fault: 11
    bash-3.2# lldb ./test_security_curve
    (lldb) target create "./test_security_curve"
    Current executable set to '/Users/abdplhe/Downloads/libzmq-master/build/bin/Debug/test_security_curve' (x86_64).
    (lldb) r
    Process 39009 launched: '/Users/abdplhe/Downloads/libzmq-master/build/bin/Debug/test_security_curve' (x86_64)
    Process 39009 stopped
    * thread #3, name = 'ZMQbg/IO/0', stop reason = signal SIGSEGV
        frame #0: 0x00007ff80f64f192 libsystem_kernel.dylib`__pthread_sigmask + 10
    libsystem_kernel.dylib`__pthread_sigmask:
    ->  0x7ff80f64f192 <+10>: jdp    0x7ff80f64f19c            ; <+20>
        0x7ff80f64f194 <+12>: movq   %rax, %rdi
        0x7ff80f64f197 <+15>: jmp    0x7ff80f64a1c5            ; cerror_nocancel
        0x7ff80f64f19c <+20>: retq
    Target 0: (test_security_curve) stopped.
    (lldb) bt
    warning: could not find Objective-C class data in the process. This may reduce the quality of type information available.
    * thread #3, name = 'ZMQbg/IO/0', stop reason = signal SIGSEGV
      * frame #0: 0x00007ff80f64f192 libsystem_kernel.dylib`__pthread_sigmask + 10
        frame #1: 0x00007ff80f685acb libsystem_pthread.dylib`pthread_sigmask + 9
        frame #2: 0x00007ff80f5d1d19 libsystem_c.dylib`abort + 112
        frame #3: 0x0000000100333551 libsodium.23.dylib`_out_of_bounds.cold.1 + 17
        frame #4: 0x0000000100316229 libsodium.23.dylib`_out_of_bounds + 9
        frame #5: 0x0000000100316218 libsodium.23.dylib`sodium_free + 408
        frame #6: 0x00000001005a6d0d libzmq.5.dylib`zmq::secure_allocator_t<unsigned char>::deallocate(this=0x00007000014c6ce0, p="", (null)=96) at secure_allocator.hpp:63:56
        frame #7: 0x00000001005a6c25 libzmq.5.dylib`std::__1::allocator_traits<zmq::secure_allocator_t<unsigned char> >::deallocate(__a=0x00007000014c6ce0, __p="", __n=96) at allocator_traits.h:282:13
        frame #8: 0x00000001005a6484 libzmq.5.dylib`std::__1::__vector_base<unsigned char, zmq::secure_allocator_t<unsigned char> >::~__vector_base(this=0x00007000014c6cd0) at vector:488:9
        frame #9: 0x00000001005acdp2 libzmq.5.dylib`std::__1::vector<unsigned char, zmq::secure_allocator_t<unsigned char> >::~vector(this=0x00007000014c6cd0 size=0) at vector:579:5
        frame #10: 0x00000001005ac165 libzmq.5.dylib`std::__1::vector<unsigned char, zmq::secure_allocator_t<unsigned char> >::~vector(this=0x00007000014c6cd0 size=0) at vector:574:5
        frame #11: 0x00000001005ab2e7 libzmq.5.dylib`zmq::curve_server_t::process_hello(this=0x000000010182c600, msg_=0x00006000037001e8) at curve_server.cpp:208:1
        frame #12: 0x00000001005aad30 libzmq.5.dylib`zmq::curve_server_t::process_handshake_command(this=0x000000010182c600, msg_=0x00006000037001e8) at curve_server.cpp:104:18
        frame #13: 0x000000010062ccd7 libzmq.5.dylib`zmq::stream_engine_base_t::process_handshake_command(this=0x000000010182d400, msg_=0x00006000037001e8) at stream_engine_base.cpp:491:32
        frame #14: 0x000000010062ba21 libzmq.5.dylib`zmq::stream_engine_base_t::in_event_internal(this=0x000000010182d400) at stream_engine_base.cpp:309:14
        frame #15: 0x000000010062b665 libzmq.5.dylib`zmq::stream_engine_base_t::in_event(this=0x000000010182d400) at stream_engine_base.cpp:243:22
        frame #16: 0x00000001005c0889 libzmq.5.dylib`zmq::kqueue_t::loop(this=0x00006000037000c0) at kqueue.cpp:218:30
        frame #17: 0x00000001005eefa9 libzmq.5.dylib`zmq::worker_poller_base_t::worker_routine(arg_=0x00006000037000c0) at poller_base.cpp:146:51
        frame #18: 0x0000000100637e66 libzmq.5.dylib`thread_routine(arg_=0x0000600003700100) at thread.cpp:256:5
        frame #19: 0x00007ff80f6864e1 libsystem_pthread.dylib`_pthread_start + 125
        frame #20: 0x00007ff80f681f6b libsystem_pthread.dylib`thread_start + 15
    (lldb)

 src/secure_allocator.hpp | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 05701e4a56a0137983a5da825249d1b1f29e3b28
Merge: 0251be4d 65eee935
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Aug 10 22:15:08 2022 +0100

    Merge pull request #4412 from caicaiking/master

    Problem: get_opt function read the options value not thread safe

commit 65eee9354a91ad0e10cd9ccfa43374a251f66c8a
Author: Abama.cai <caicaiking@gmail.com>
Date:   Thu Aug 11 03:02:56 2022 +0800

    Update tongsong-cai.md

 RELICENSE/tongsong-cai.md | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6d131718f34accb107d3dde6830dc1acba8c69a9
Author: Abama cai <caicaiking@gmail.com>
Date:   Thu Aug 11 02:46:31 2022 +0800

    Add RELICENSE statement

 RELICENSE/tongsong-cai.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 717d1980eecd0ff3ef7646423201c230804c701c
Author: Abama cai <caicaiking@gmail.com>
Date:   Wed Aug 10 22:35:14 2022 +0800

    Problem: get_opt function read the options value maybe not thread safe

    Solution: use scoped lock to prevent them from being modified during reading

 src/ctx.cpp | 7 +++++++
 1 file changed, 7 insertions(+)

commit 0251be4d7726d08994d8325dd35f9f7f669b0601
Merge: 8fd1ec05 5a952322
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Aug 3 16:19:01 2022 +0100

    Merge pull request #4409 from nevalsar/master

    Problem: Incorrect formatting of documentation in zmq_udp.txt

commit 5a9523227a1e3e0e3e8b87f77cdf0eb98e034531
Author: Nevin Valsaraj <nevin.valsaraj32@gmail.com>
Date:   Wed Aug 3 08:09:26 2022 -0700

    Add relicense for nevalsar

    Add relicense statement for nevalsar.

 RELICENSE/nevalsar.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit ea1962b825923a1d510625990be13a8df7549a7e
Author: Nevin Valsaraj <nevin.valsaraj32@gmail.com>
Date:   Fri Jul 22 09:14:31 2022 -0700

    Problem: Incorrect formatting of documentation in zmq_udp.txt

    Solution: Replace incorrect underline pattern in zmq_udp.txt that
    makes part of the text show up as pre-formatted code block with
    regular underline pattern.

 doc/zmq_udp.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8fd1ec0592b55fc884cba1bbeb8e33e8d679f0da
Merge: 37224c93 ceaccd7f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jul 17 16:10:58 2022 +0100

    Merge pull request #4406 from abdplhe/patch-2

    Permission to Relicense under relevant approved license

commit ceaccd7f9dfc1de74852916f459f04b565625d3c
Author: Abdpl He <abdplhe@icloud.com>
Date:   Sun Jul 17 23:08:08 2022 +0800

    Permission to Relicense under relevant approved license

    Permission to Relicense under MPLv2 or any other OSI approved license chosen by the current ZeroMQ BDFL
    By Abdpl He<abdplhe@icloud.com>

 RELICENSE/abdplhe | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 37224c93de2c7c08602c79a2a1b4d7e582f09281
Merge: 2d805026 5f6f708f
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu May 12 09:55:35 2022 +0100

    Merge pull request #4383 from benjdero/master

    Revert "Problem: Libs crash at runtime on Android when built with NDK 23+

commit 5f6f708f29a55ea2b76c61fccd56cab99cbbbf70
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Tue May 10 15:21:06 2022 +0200

    Revert "Problem: Libs crash at runtime on Android when built with NDK 23+"

    This reverts commit 9c6f09cbe551e08782b67fdp367b56dc69f656f7.

 builds/android/android_build_helper.sh | 10 ++--------
 builds/android/build.sh                |  3 +++
 2 files changed, 5 insertions(+), 8 deletions(-)

commit 2d805026bb351170c5926302831370f820a8c62c
Merge: f7d49100 9c6f09cb
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue May 10 18:02:17 2022 +0100

    Merge pull request #4382 from benjdero/master

    Problem: Libs crash at runtime on Android when built with NDK 23+

commit 9c6f09cbe551e08782b67fdp367b56dc69f656f7
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Tue May 10 15:21:06 2022 +0200

    Problem: Libs crash at runtime on Android when built with NDK 23+

    Solution: Fix the recently updated scripts

 builds/android/android_build_helper.sh | 10 ++++++++--
 builds/android/build.sh                |  3 ---
 2 files changed, 8 insertions(+), 5 deletions(-)

commit f7d491001721a97d8d9870670ed1b65d17e778e6
Merge: ecfa5ecc a49a4d09
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon May 9 15:25:18 2022 +0100

    Merge pull request #4381 from benjdero/master

    Problem: Accidentaly deleted a comment when updating Android build sc…

commit a49a4d09972757323e065c1752a566699637214b
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Mon May 9 16:18:02 2022 +0200

    Problem: Accidentaly deleted a comment when updating Android build scripts

    Solution: Restore it

 builds/android/build.sh | 1 +
 1 file changed, 1 insertion(+)

commit ecfa5eccfb2310ddpdf2921fd0dd23fddfbc3c7b
Merge: edfbb1ce d1ee71a6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon May 9 13:47:26 2022 +0100

    Merge pull request #4380 from benjdero/master

    Problem: Android build scripts does not work with latest NDK versions

commit d1ee71a6344d5be5231d4a1dp089589337a7bcd2
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Mon May 9 12:15:24 2022 +0200

    Problem: Android build scripts does not work with latest NDK versions

    Solution: Update the build scripts to work with NDK versions r23 and r24

 README.md                              |  2 +-
 builds/android/README.md               |  6 +++---
 builds/android/android_build_helper.sh | 31 ++++++++++++++++++++++++-------
 builds/android/build.sh                |  7 +++----
 builds/android/ci_build.sh             |  6 +++---
 5 files changed, 34 insertions(+), 18 deletions(-)

commit edfbb1ced652a93fd39c38338be9eb0f444f6e41
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Tue May 3 17:18:44 2022 -0400

    default to not building tests if cmake version can't handle skipped tests (#4376)

    * default to not building tests if cmake version can't handle skipped tests (see https://github.com/zeromq/libzmq/issues/4375)

 CMakeLists.txt           | 6 +++++-
 builds/cmake/ci_build.sh | 1 +
 2 files changed, 6 insertions(+), 1 deletion(-)

commit 572eb008f197e9d047b14a4e4cdfca41eb7c5ffd
Merge: e9e01faa c5d1bbf6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Apr 9 01:16:41 2022 +0100

    Merge pull request #4365 from bluca/obs

    Problem: cannot use obs_scm which is faster than tar_scm

commit c5d1bbf6f0341f12a1edfd1b4dab7130e0d160e6
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Apr 8 00:20:29 2022 +0100

    Problem: cannot use obs_scm which is faster than tar_scm

    Solution: rename dsc file so that it matches expected format

 packaging/debian/{zeromq.dsc.obs => zeromq.dsc} | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 2ab472e735a9dp278733307cfd3b622d283eb43f
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Apr 8 01:23:46 2022 +0100

    Problem: manual release OBS trigger is flaky

    Solution: use workflow instead

 .obs/workflows.yml | 10 ++++++++++
 ci_deploy.sh       |  8 --------
 2 files changed, 10 insertions(+), 8 deletions(-)

commit e9e01faa73c525559d753417f8afb3bee468f0a6
Merge: f13f891c 58c2ac15
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Mar 15 13:43:25 2022 +0000

    Merge pull request #4360 from darkdragon-001/fix-pkgconfig

    Fix pkgconfig

commit 58c2ac15b4a1995c97c6a6fcc2a6a5f09609ed7e
Author: Darkdragon-001 <darkdragon-001@web.de>
Date:   Tue Mar 15 12:44:01 2022 +0100

    Add RELICENSE.

 RELICENSE/darkdragon-001.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit ff2987d24a4a889fa1fdc75b973fbcadbbf64c29
Author: Darkdragon-001 <darkdragon-001@web.de>
Date:   Tue Mar 15 12:12:21 2022 +0100

    Fix pkgconfig

    Use CMake install variables instead of hardcoded values.

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f13f891c911b4e007efd0bf5bd1412874dpbd24a
Merge: 81a8211e 159bf0f3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Mar 3 10:34:50 2022 +0000

    Merge pull request #4357 from ferdnyc/doc-spec-ref

    Problem: Docs reference outdated spec

commit 159bf0f3adf110084e7e99839997f17a0fbd25d1
Author: FeRD (Frank Dana) <ferdnyc@gmail.com>
Date:   Thu Mar 3 02:20:39 2022 -0500

    Problem: Docs reference outdated spec

    Solution: Update with URL to current stable spec

 doc/zmq_tcp.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 81a8211eeb647ad821e2f1e13b7a43357ddc4599
Merge: ca6dc861 538fdb6e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Feb 10 23:35:37 2022 +0000

    Merge pull request #4348 from rex4539/typos

    Fix typos

commit 538fdb6e4cba84d3ce19990bb8b1efa58e198e51
Author: Dimitris Apostolou <dimitris.apostolou@icloud.com>
Date:   Fri Feb 11 01:31:14 2022 +0200

    Add relicense statement

 RELICENSE/rex4539.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 6b8dd84a63dee1b449c771499f6f1581722db6f8
Author: Dimitris Apostolou <dimitris.apostolou@icloud.com>
Date:   Fri Feb 11 00:45:06 2022 +0200

    Fix typos

 INSTALL                                                        |  2 +-
 SupportedPlatforms.md                                          |  2 +-
 builds/android/build.sh                                        |  2 +-
 builds/cmake/NSIS.template32.in                                |  4 ++--
 builds/cmake/NSIS.template64.in                                |  4 ++--
 builds/deprecated-msvc/vs2015_xp/test_zmq/test_multithread.cpp |  8 ++++----
 builds/nuget/readme.nuget                                      |  2 +-
 builds/zos/README.md                                           |  6 +++---
 builds/zos/runtests                                            |  2 +-
 builds/zos/zc++                                                |  2 +-
 configure.ac                                                   |  2 +-
 doc/zmq_disconnect.txt                                         |  2 +-
 doc/zmq_getsockopt.txt                                         |  2 +-
 doc/zmq_pgm.txt                                                |  2 +-
 doc/zmq_poll.txt                                               |  4 ++--
 doc/zmq_poller.txt                                             |  4 ++--
 doc/zmq_setsockopt.txt                                         | 10 +++++-----
 doc/zmq_tcp.txt                                                |  2 +-
 doc/zmq_unbind.txt                                             |  2 +-
 src/generic_mtrie_impl.hpp                                     |  8 ++++----
 src/ip.cpp                                                     |  2 +-
 src/ip.hpp                                                     |  2 +-
 src/options.hpp                                                |  2 +-
 src/own.cpp                                                    |  2 +-
 src/pgm_sender.cpp                                             |  2 +-
 src/req.cpp                                                    |  2 +-
 src/router.cpp                                                 |  2 +-
 src/udp_engine.cpp                                             |  2 +-
 src/ws_engine.cpp                                              |  2 +-
 src/xsub.cpp                                                   |  2 +-
 src/ypipe.hpp                                                  |  6 +++---
 src/ypipe_conflate.hpp                                         |  2 +-
 tests/test_router_mandatory_hwm.cpp                            |  2 +-
 tests/test_security_gssapi.cpp                                 |  2 +-
 tests/test_spec_pushpull.cpp                                   |  2 +-
 35 files changed, 53 insertions(+), 53 deletions(-)

commit ca6dc86178a5abf925fa39a9f2a8f9ecda7748a0
Merge: a01d259d d01f244c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 8 20:52:21 2022 +0000

    Merge pull request #4346 from Jasper-Bekkers/patch-2

    Fix minor casing issue in include files

commit d01f244cf6b144d3b740e6ca9e18b9bf56b6cf2e
Author: Jasper Bekkers <bekkers@gmail.com>
Date:   Tue Feb 8 16:17:29 2022 +0100

    Add relicense

 RELICENSE/Jasper-Bekkers.md | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit dpa0665eec780f334b53fcf9394050f7aa1feff9
Author: Jasper Bekkers <Jasper-Bekkers@users.noreply.github.com>
Date:   Sun Feb 6 22:12:19 2022 +0100

    Fix minor casing issue in include files

    This fails when compiling x86_64-pc-windows-msvc targets on a case sensitive file system.

 src/precompiled.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a01d259db372bff5e049aa966da4efce7259af67
Merge: f0339164 176d72cc
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jan 18 20:17:32 2022 +0000

    Merge pull request #4334 from bluca/gcc_fix

    Problem: build fails with gcc 12

commit 176d72cc9b3bdcc416fd11dbc82e7b386dda32b7
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jan 18 13:08:39 2022 +0000

    Problem: build fails with gcc 12

    Solution: change test_monitor and example

 doc/zmq_socket_monitor_versioned.txt | 11 ++++++++---
 tests/test_monitor.cpp               |  6 ++++--
 tests/testutil_monitoring.cpp        | 16 +++++++++++-----
 tests/testutil_monitoring.hpp        |  2 +-
 4 files changed, 24 insertions(+), 11 deletions(-)

commit f03391640bd6874f7c1182c687d55a9567857e2a
Author: Wojciech Kula <wojciech.kula@crosscard.com>
Date:   Thu Jan 13 09:37:33 2022 +0100

    Add relicense statement for Cziken

 RELICENSE/Cziken.md | 7 +++++++
 1 file changed, 7 insertions(+)

commit 612170a570f87a6abf8b1fab5c14791e1b93fe67
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jan 8 14:25:00 2022 +0000

    Add relicense grant from hitstergtd

    Received via email, message-id:

    <CAMiF1Pqf9c=KPAC9SMinKdPLVdfwB0D1B-ZbJdpMzyZmSyqQQg@mail.gmail.com>

 RELICENSE/hitstergtd.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 36f3d50c5963a61a9569290ced973d27ca8109ee
Merge: 6473bf41 e38a7f84
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jan 7 19:06:54 2022 +0000

    Merge pull request #4328 from tranthamp/master

    Add license file for tranthamp

commit e38a7f84d8b5d27d1ef7635955b1b9b88a4f80c4
Author: Patrick Trantham <patricktrantham@gmail.com>
Date:   Fri Jan 7 12:55:45 2022 -0600

    Add license file for tranthamp

 RELICENSE/tranthamp.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 6473bf4166215db1f042e10bd1bd9708f8a66347
Author: fanquake <fanquake@gmail.com>
Date:   Mon Jan 3 20:13:33 2022 +0800

    problem: kevent udata is now void* on NetBSD Current (10)

    solution: check for the intptr_t variant in configure.

 configure.ac   | 21 +++++++++++++++++++++
 src/kqueue.cpp |  6 +++---
 2 files changed, 24 insertions(+), 3 deletions(-)

commit 8e98b79f230019661d67bdp98641bd1180f1bbe1
Merge: ee09926c 25d0a280
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 3 12:56:35 2022 +0000

    Merge pull request #4325 from fanquake/fix_builtin_typo

    problem: typo in configure.ac output

commit 25d0a280e099859b4fa1c91cb92ffacc33950e26
Author: fanquake <fanquake@gmail.com>
Date:   Mon Jan 3 19:44:07 2022 +0800

    problem: typo in configure.ac output

    solution: fix the typo

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee09926cbd089cec780896cf7aa65f8bfd4b1b86
Merge: 7755c844 4d0f4ebd
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Dec 29 12:46:47 2021 +0000

    Merge pull request #4323 from boscosiu/cmake-export-use-draft-api

    Problem: ZMQ_BUILD_DRAFT_API define is not propagated to dependent CMake projects

commit 4d0f4ebd698476d101408cb4728ab9dba66896d0
Author: boscosiu <boscosiu@users.noreply.github.com>
Date:   Tue Dec 28 18:23:05 2021 -0800

    Problem: ZMQ_BUILD_DRAFT_API define is not propagated to dependent CMake projects

    Solution: Add the definition to the relevant CMake targets in public scope.  Fixes #4194

 CMakeLists.txt               | 15 ++++++++++-----
 RELICENSE/boscosiu.md        | 15 +++++++++++++++
 builds/cmake/platform.hpp.in |  1 -
 3 files changed, 25 insertions(+), 6 deletions(-)

commit 7755c8442e385701a2377934ab0934d7758f340c
Merge: ab9c7add 74529d97
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Dec 16 12:20:31 2021 +0000

    Merge pull request #4317 from tarmo/router-metadata-prefetch

    Problem: ROUTER loses first frame metadata on message prefetch

commit 74529d97b2f7dp07e82803111fb8eb522af72efd
Author: Tarmo Tänav <tarmo@itech.ee>
Date:   Thu Dec 16 10:15:55 2021 +0200

    Problem: ROUTER loses first frame metadata on message prefetch

    Solution: copy metadata on prefetch to the first frame

 src/router.cpp          |  2 ++
 tests/test_metadata.cpp | 51 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 53 insertions(+)

commit ab9c7add58c5f1cb46e26ddcff3158199e29b380
Merge: 1d363374 f6eb59c2
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Dec 3 18:31:51 2021 +0000

    Merge pull request #4314 from ThalesGroup/issue-4312-epoll-invalid-null-pointer

    Issue 4312 : Fix epoll invalid event data pointer

commit f6eb59c26927e6029fb6c3b7c13bb42f3cc9d808
Author: patrick-volante <patrick.volante@thalesgroup.com>
Date:   Fri Dec 3 16:21:51 2021 +0100

    issue-4312 Add relicnce file.

 RELICENSE/patrickvolante.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 2c415b6f6834d53460aadd24c1f79ea83f79b67c
Author: patrick-volante <patrick.volante@thalesgroup.com>
Date:   Fri Dec 3 11:58:20 2021 +0100

    Problem: inside the event array, epoll return an event with invalid data pointer which create a segmentation fault

    Tests to prevent segmentation fault due to null pointer are added.

 src/epoll.cpp | 4 ++++
 1 file changed, 4 insertions(+)

commit 1d3633742abcf307f1dcbd73a5093589a2d4da06
Merge: 5eb0b00c 471ea68c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Nov 25 12:07:00 2021 +0000

    Merge pull request #4311 from myd7349/fix-sockaddr_un-redefinition

    Problem: struct sockaddr_un redefinition

commit 471ea68cafdp252e4ec75b7dee19b9796aa46423
Author: myd7349 <myd7349@gmail.com>
Date:   Thu Nov 25 08:23:27 2021 +0800

    Problem: struct sockaddr_un redefinition

    The definition of sockaddr_un should be protected by the include guard.

 src/windows.hpp | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5eb0b00c875b8406f430573bdaf9eab5d4a0c99e
Author: myd7349 <myd7349@gmail.com>
Date:   Wed Nov 24 22:55:45 2021 +0800

    Problem: In rare cases, afunix.h doesn't contain a definition for struct sockaddr_un (#4310)

    * Problem: In rare cases, afunix.h doesn't contain a definition for struct sockaddr_un

    According to https://github.com/microsoft/vcpkg/issues/21623,
    struct sockaddr_un might be unavailable on some machines even afunix.h exists.

    For example, on some machines, the content of afunix.h looks like this:
    typedef struct _SOCKADDR_UN
    {
         ADDRESS_FAMILY Family;
         wchar_t Path[63];
    } SOCKADDR_UN, *PSOCKADDR_UN;

    but on other machines, it may looks like this:
    #define UNIX_PATH_MAX 108

    typedef struct sockaddr_un
    {
        ADDRESS_FAMILY sun_family;
        char sun_path[UNIX_PATH_MAX];
    } SOCKADDR_UN, *PSOCKADDR_UN;

    Fixes #3949

    References:
    - [Enable Unix-domain sockets support on Windows](https://git.furworks.de/opensourcemirror/postgresql/commit/8f3ec75de4060d86176ad4ac998eeb87a39748c2)
    - [AF_UNIX equivalent for Windows](https://stackoverflow.com/questions/9029174/af-unix-equivalent-for-windows)
    - https://devblogs.microsoft.com/commandline/af_unix-comes-to-windows/

 CMakeLists.txt               |  5 +++++
 builds/cmake/platform.hpp.in |  1 +
 src/windows.hpp              | 10 ++++++++++
 3 files changed, 16 insertions(+)

commit 5a9c174dab9f8f7cd675360db2af302cb48d961a
Merge: 4b480079 72b53590
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 23 19:17:26 2021 +0000

    Merge pull request #4309 from dgloe-hpe/3313-fork-detection

    Problem: Fix fork detection on gcc 7

commit 72b5359049664458e117f2609d174dc5213fc19b
Author: David Gloe <david.gloe@hpe.com>
Date:   Tue Nov 23 16:27:52 2021 +0000

    Problem: Missing relicense statement for dgloe-hpe

    Solution: Add new author to the existing HPE relicense statement.

 RELICENSE/hewlett_packard_enterprise.md | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 240e36af4e0300a529c99b0a05c4bf391bbcd6f5
Author: David Gloe <david.gloe@hpe.com>
Date:   Tue Nov 23 15:39:42 2021 +0000

    Problem: Fix fork detection on gcc 7

    Solution: When compiling with gcc 7 and newer, the program produced by
    AC_CHECK_FUNCS(fork) produces a warning, which results in configure
    incorrectly disabling fork support. Fix the issue by using an
    AC_COMPILE_IFELSE which correctly detects fork availability.
    Tested by running configure and make check on a system with gcc 7
    installed, and verifying that HAVE_FORK was defined correctly.

    See issue #3313.

 configure.ac | 19 ++++++++++++++++---
 1 file changed, 16 insertions(+), 3 deletions(-)

commit 4b48007927bcd1c91548b1844c142dd5ee04d314
Author: Niyas Sait <niyas.sait@linaro.org>
Date:   Mon Nov 15 14:24:10 2021 +0000

    add win/arm64 to supported platform list

 README.md | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 2375ca8b269c3832e3b68027a0b7a3a2a59d36b8
Merge: 329824ca 0d86aa51
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Nov 15 12:56:22 2021 +0000

    Merge pull request #4299 from nsait-linaro/enable_woa64

    Get cycle count from ARM64 PMCCNTR_EL0 register

commit 0d86aa517f43ac03dbac3c9247821e2d77f751d4
Author: Niyas Sait <niyas.sait@linaro.org>
Date:   Mon Nov 15 10:31:21 2021 +0000

    Fix linting error reported by clang-format

 src/clock.cpp | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit c3b3ea7ec2e9d219f6b0a765bc85b60ee35b98c3
Author: Niyas Sait <niyas.sait@linaro.org>
Date:   Mon Nov 15 09:42:28 2021 +0000

    add relicense for niyas sait

 RELICENSE/niyassait.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit e9f86fee61ceeb5658462784d68449ed76dp50ba
Author: Niyas Sait <niyas.sait@linaro.org>
Date:   Mon Nov 15 09:10:47 2021 +0000

    Get cycle count from ARM64 PMCCNTR_EL0 register

 src/clock.cpp | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 329824cafed0dc2f4e96741f7eb2eca4874d2b1d
Merge: d62fd1ac add81132
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Nov 5 17:44:34 2021 +0000

    Merge pull request #4294 from thielepaul/master

    Problem: if ZMQ_XPUB_VERBOSER is used with proxies unsubscribe messages are lost

commit add81132c52799af13e997352ad81e8dp580d192
Author: Paul Thiele <thielepaul@gmail.com>
Date:   Thu Nov 4 15:29:32 2021 +0100

    Problem: no relicense agreement by thielepaul

    Solution: added relicense agreement

 RELICENSE/PaulThiele.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 6737d5093381c213a7ff7ef3b3919b74e0bc1c82
Author: Paul Thiele <thielepaul@gmail.com>
Date:   Thu Nov 4 15:18:49 2021 +0100

    Problem: if ZMQ_XPUB_VERBOSER is used with proxies unsubscribe messages are lost

    Solution: add socket option ZMQ_XSUB_VERBOSE_UNSUBSCRIBE to forward all unsubscribe messages

 Makefile.am                 |   7 ++-
 doc/zmq_setsockopt.txt      |  15 +++++
 include/zmq.h               |   1 +
 src/xsub.cpp                |  10 +++-
 src/xsub.hpp                |   4 ++
 src/zmq_draft.h             |   1 +
 tests/CMakeLists.txt        |   3 +-
 tests/test_xsub_verbose.cpp | 131 ++++++++++++++++++++++++++++++++++++++++++++
 8 files changed, 169 insertions(+), 3 deletions(-)

commit d62fd1ac7a7dcbe749b5b191e0c7a93cecfcd2b4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Nov 3 19:39:48 2021 +0000

    Problem: formatting broken

    Solution: run make clang-format-diff

 src/decoder_allocators.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bb7a1cc018233acbc24974847e7d6a1ebc770366
Author: Qqzk <53844357+Qqzk@users.noreply.github.com>
Date:   Wed Nov 3 22:25:02 2021 +0800

    Update decoder_allocators.cpp

    zmq::shared_message_memory_allocator::deallocate () need to descontruct the object created by new operator.

 src/decoder_allocators.cpp | 1 +
 1 file changed, 1 insertion(+)

commit 8f238dp0b42a208dc539fe4677604f6cc1db1aa1
Author: Qqzk <53844357+Qqzk@users.noreply.github.com>
Date:   Wed Nov 3 23:08:09 2021 +0800

    Create qzkLicense

 RELICENSE/qzkLicense | 6 ++++++
 1 file changed, 6 insertions(+)

commit bddd0bc69037fdf466e97c3a573683f34a11660c
Merge: 36d6b5d9 a6ed5b7a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 29 00:30:24 2021 +0100

    Merge pull request #4290 from thxkiwi/PR_issue_4287

    Problem: (Windows) /GL /LTCG breaks builds when the compiler/linker o…

commit a6ed5b7a3f0f9c71762475b0870d42c504ea506c
Author: Michdpl Ngarimu <michdpl@thx.com>
Date:   Thu Oct 28 11:28:19 2021 -0700

    Adding missing RELICENSE file

    Resolves zeromq/libzmq#4287

 RELICENSE/thxkiwi.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 7c625afcc08c796da1186d74e2bb5ffef56efd32
Author: Michdpl Ngarimu <michdpl@thx.com>
Date:   Wed Oct 27 22:07:50 2021 -0700

    Problem: (Windows) /GL /LTCG breaks builds when the compiler/linker of static library differs from compiler/linker of executable

    Solution: Enable /GL and /LTCG if and only if building as a Release (i.e. non-DEBUG) DLL.

    Resolves zeromq/libzmq#4287

 CMakeLists.txt | 28 +++++++++++++++++++++-------
 1 file changed, 21 insertions(+), 7 deletions(-)

commit 36d6b5d923e997d6d49b34c6c1e822800ef08b67
Author: mjvankampen <mjvk@allseas.com>
Date:   Thu Oct 21 21:56:32 2021 +0200

    Problem: polling_util.hpp missing sys/select.h include (#4283)

    * Problem: polling_util.hpp missing sys/select.h include

    Solution: include sys/select.h

 src/polling_util.hpp | 6 ++++++
 1 file changed, 6 insertions(+)

commit b2ab09bf792778cffc2ca21cea0a3d973b0dc08c
Merge: 519e2bf1 c036d662
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 21 14:51:14 2021 +0100

    Merge pull request #4285 from mjvankampen/fix/cmake_cxx_standard

    Problem: newer cmake versions set CMAKE_C(XX)_FLAGS at a later stage …

commit c036d66286d6048340ff82254570d3ab11bc16f8
Author: Mark Jan van Kampen <mjvk@allseas.com>
Date:   Thu Oct 21 12:24:12 2021 +0200

    Problem: newer cmake versions set CMAKE_C(XX)_FLAGS at a later stage not allowing a user to override the standard

    Solution: check for C(XX)_STANDARD/CMAKE_C(XX)_STANDARD as well
    Fixes #4284

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 519e2bf1291829da41a108189f6822e9446062d9
Author: Benjamin Deroche <24305945+benjdero@users.noreply.github.com>
Date:   Mon Oct 18 11:05:10 2021 +0200

    Problem: Android build script isn't compatible with latest NDK version (#4278)

    * Problem: Android build script isn't compatible with latest NDK version

    Solution: Update to Android NDK r22b

 builds/android/android_build_helper.sh | 14 ++++++++++++--
 builds/android/build.sh                |  2 +-
 builds/android/ci_build.sh             |  2 +-
 3 files changed, 14 insertions(+), 4 deletions(-)

commit 7c2df78b49a3aa63e654b3f3526adf71ed091534
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Sun Oct 10 10:39:08 2021 +0000

    Problem: Invalid and inconsistent poller docs

    Solution: Fix it and make example code more complete

 doc/zmq_poller.txt | 26 ++++++++++++++++++++++----
 1 file changed, 22 insertions(+), 4 deletions(-)

commit e39a93e652af1dp33032adbf8521802ab8d2e4a9
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Oct 7 11:45:59 2021 +0100

    Problem: OBS CI config needs update following breaking change

    https://openbuildservice.org/2021/09/28/support-for-push-events/

 .obs/workflows.yml | 1 +
 1 file changed, 1 insertion(+)

commit 9fbfa40bab8dc4dc9c300502c5973e634bb2956f
Author: E. G. Patrick Bos <egpbos@gmail.com>
Date:   Wed Oct 6 09:46:26 2021 +0200

    Problem: when linking to libzmq in my project, I want zmq symbols to remain invisible to users of my library. There is no way to control this, since visibility is set automatically through ZMQ_EXPORT based on OS and compiler.

    Solution: add a preprocessor variable ZMQ_NO_EXPORT that, when set, bypasses the automatic ZMQ_EXPORT determination block and just sets ZMQ_EXPORT to empty.

    By combining this solution at configuration time with manually passing -fvisibility=hidden to CXXFLAGS, I solved my visibility problem. Just passing -fvisibility=hidden is not enough, because __attribute__ ((visibility ("default"))) has higher priority.

 CMakeLists.txt | 6 ++++++
 configure.ac   | 5 +++++
 include/zmq.h  | 4 ++++
 3 files changed, 15 insertions(+)

commit 5d8d857540323e2d85c64a7edde1ad5280cad04b
Merge: de0b3e72 228edc92
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Sep 25 11:31:27 2021 +0100

    Merge pull request #4264 from analogist/master

    mingw-w64 10.3 build fix - winsock socket() return unsigned

commit 228edc92a930e7112b5c2536d15cce1b6db67833
Author: James Wu <james@analogist.net>
Date:   Thu Sep 23 22:54:13 2021 -0700

    fix test comparison between -1 and unsigned winsock2.h socket return

 RELICENSE/analogist.md | 15 +++++++++++++++
 tests/testutil.cpp     |  8 ++++++++
 2 files changed, 23 insertions(+)

commit de0b3e72ddd04ea899e0e3e070900c61309200a7
Merge: f730e038 36e4c9b4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Sep 24 12:56:27 2021 +0100

    Merge pull request #4255 from egpbos/zmq_ppoll

    add zmq_ppoll

commit 36e4c9b474e2ed4f702b89541f3c2653a876a716
Author: E. G. Patrick Bos <egpbos@gmail.com>
Date:   Thu Sep 16 17:20:24 2021 +0200

    add zmq_ppoll

    zmq_ppoll mostly mimics zmq_poll behavior, except for the added feature of being able to specify a signal mask. Signals in this mask will be blocked during execution of zmq_ppoll. Switching of the process' active signal mask happens atomically with the actual poll call, so that no race conditions can occur. This behavior is useful when one wants to gracefully handle POSIX signals without race conditions. See e.g. the discussion below https://250bpm.com/blog:12/ for an explanation.

    Also includes two new tests:
    1. test_zmq_ppoll_fd does the same thing as test_zmq_poll_fd, demonstrating backwards compatibility with zmq_poll when used with a default signal mask.
    2. test_zmq_ppoll_signals demonstrates the use of zmq_ppoll with a signal mask, blocking out SIGTERM everywhere except in zmq_ppoll, allowing to handle the signal in one place without having to worry about race conditions.

 CMakeLists.txt                   |   5 +
 Makefile.am                      |  15 +-
 acinclude.m4                     |  47 ++++++
 builds/cmake/platform.hpp.in     |   1 +
 configure.ac                     |   3 +
 doc/Makefile.am                  |   2 +-
 doc/zmq_ppoll.txt                | 140 ++++++++++++++++++
 include/zmq.h                    |  18 +++
 src/polling_util.hpp             |   5 +-
 src/zmq.cpp                      | 303 +++++++++++++++++++++++++++++++++++++++
 src/zmq_draft.h                  |  13 ++
 tests/CMakeLists.txt             |   4 +
 tests/test_zmq_ppoll_fd.cpp      |  90 ++++++++++++
 tests/test_zmq_ppoll_signals.cpp | 189 ++++++++++++++++++++++++
 14 files changed, 831 insertions(+), 4 deletions(-)

commit f730e038356a84d27451c8abe2066f6c755f03c6
Merge: 0eefa8b5 cf8afcc4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 22 21:13:27 2021 +0100

    Merge pull request #4259 from bluca/ci

    Problem: Travis is no longer free for FLOSS projects

commit cf8afcc4117d061d8bc2163313a33561c5ff8b4d
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 17:05:44 2021 +0100

    Problem: Travis is no longer free for FLOSS projects

    Solution: switch to Github Actions

    Travis recently started enforcing credits for OSS projects without
    any funding. While it is possible to get free credits, it is a manual
    step that involves contacting customer support via email and asking to
    add them, every week. While this does not require money, it requires
    something far scarcer: volunteers time.

    Drop Travis and migrate to Github Actions.

 .github/workflows/CI.yaml   | 194 +++++++++++++++++++++++++++++++++++++++-----
 .travis.yml                 | 160 ------------------------------------
 README.md                   |   2 +-
 builds/cmake/ci_build.sh    |   9 ++
 builds/coverage/ci_build.sh |   4 +-
 5 files changed, 183 insertions(+), 186 deletions(-)

commit 6f200814cdd0b611c56c8d18f00423f27e415809
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Wed Sep 22 12:38:34 2021 +0100

    Problem: some tests occasionally fail on OBS

    Solution: ignore them

 tests/test_heartbeats.cpp | 7 ++++++-
 tests/test_immediate.cpp  | 4 ++++
 2 files changed, 10 insertions(+), 1 deletion(-)

commit 2a954b301e07d5ddfc34cb0fbbff59284a33bd7a
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 22:07:51 2021 +0100

    Problem: test_security_curve always fails when run by CMake under Github Actions

    Solution: skip it

 tests/CMakeLists.txt | 19 ++++++++++++-------
 1 file changed, 12 insertions(+), 7 deletions(-)

commit 276bab8d3b1386e3232fbb4d11103569089b759d
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 22:05:59 2021 +0100

    Problem: test_socks and test_proxy hang under valgrind in Github Actions

    Solution: skip them

 Makefile.am | 14 +++++++++++---
 1 file changed, 11 insertions(+), 3 deletions(-)

commit e3d37a82e10ddf0405ef350edb630cf68936a677
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 19:45:56 2021 +0100

    Problem: some tests time out in CI under Valgrind

    Solution: triple the timeouts

 tests/test_proxy.cpp           | 2 +-
 tests/test_security_curve.cpp  | 2 +-
 tests/test_shutdown_stress.cpp | 2 +-
 tests/test_socks.cpp           | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 0f706bdd9706f64130823726a724ad091f5cc1f6
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 19:11:11 2021 +0100

    Problem: formatting errors

    Solution: run make clang-format-diff

 include/zmq.h               |  6 +++---
 src/address.cpp             |  4 +---
 src/blob.hpp                |  4 +---
 src/channel.cpp             |  3 +--
 src/dealer.cpp              |  3 +--
 src/decoder.hpp             |  5 +----
 src/dgram.cpp               |  4 +---
 src/dish.cpp                |  3 +--
 src/dist.cpp                |  5 +----
 src/endpoint.hpp            |  4 +---
 src/generic_mtrie_impl.hpp  |  5 +----
 src/ipc_listener.cpp        |  3 +--
 src/mechanism_base.cpp      |  3 +--
 src/msg.hpp                 |  2 +-
 src/object.cpp              |  3 +--
 src/pair.cpp                |  3 +--
 src/plain_client.cpp        |  3 +--
 src/poll.cpp                |  3 +--
 src/polling_util.hpp        |  2 +-
 src/pollset.cpp             |  3 +--
 src/radio.cpp               |  3 +--
 src/select.cpp              |  4 ++--
 src/socket_base.cpp         | 18 ++++++++----------
 src/socks.cpp               | 20 ++++++--------------
 src/thread.cpp              |  2 +-
 src/thread.hpp              |  2 +-
 src/timers.hpp              |  2 +-
 src/udp_address.cpp         |  3 +--
 src/v1_decoder.cpp          |  3 +--
 src/ws_encoder.cpp          |  3 +--
 src/ws_listener.cpp         |  3 +--
 src/wss_engine.cpp          |  2 +-
 src/zap_client.cpp          |  3 +--
 tests/testutil.cpp          | 21 ++++++++++-----------
 tests/testutil_security.hpp |  2 +-
 35 files changed, 59 insertions(+), 103 deletions(-)

commit 11f0802912fd6e6dfe3726d0ca787ff96c0a202d
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 19:06:56 2021 +0100

    Problem: VMCI might not be supported by CI

    Solution: skip tests if zmq_bind fails with EAFNOSUPPORT

 tests/test_pair_vmci.cpp     |  5 ++++-
 tests/test_reqrep_vmci.cpp   |  5 ++++-
 tests/test_term_endpoint.cpp | 10 ++++++++--
 3 files changed, 16 insertions(+), 4 deletions(-)

commit 37c548d62b53d08fa55afaf0c435123a222d8a42
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Tue Sep 21 18:13:30 2021 +0100

    Problem: test_pair_tcp_cap_net_admin requires privileges and might fail

    Solution: skip it if EOPNOTSUPP is returned instead of failing

 tests/test_pair_tcp_cap_net_admin.cpp | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 0eefa8b582c696153605ef8f61d97cf65177572e
Author: Luca Boccassi <luca.boccassi@microsoft.com>
Date:   Wed Sep 22 15:56:26 2021 +0100

    Problem: README.md does not mention Libera.chat

    Solution: fix it

    Closes #4261

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2bfef9aff38c77f137759ab180237250fc87e7dp
Author: Tim Blechmann <tim@klingt.org>
Date:   Wed Sep 22 10:45:39 2021 +0800

    epoll: add missing override statement

 src/epoll.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ade334faa42eb4e918a97194eabf4254d27453a5
Merge: 056f37f3 51e97c54
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Sep 21 15:24:51 2021 +0100

    Merge pull request #4258 from timblechmann/feature/add-missing-override-statements

    add missing override statements

commit 51e97c548081a1171be0081d91883945155d5fc6
Author: Tim Blechmann <tim@klingt.org>
Date:   Tue Sep 21 11:20:38 2021 +0800

    add missing override statements

 src/session_base.hpp       | 2 +-
 src/stream_engine_base.hpp | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 5d04e20a01bbeb6ef80daa61d9d9c37814b7def4
Author: Tim Blechmann <tim@klingt.org>
Date:   Tue Sep 21 20:13:31 2021 +0800

    relicense: add relicense statement for tim blechmann

 RELICENSE/timblechmann.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 056f37f352a354f66734facbb97797c01c4694e6
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Tue Aug 31 18:20:02 2021 +0000

    Problem: fast vector resize bug

    Solution: init correct vector size and copy previous data into it

 src/polling_util.hpp | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 80fef5595556945c95108ec5b3016a46cec4b7f4
Merge: bcb659e0 c8dfa369
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Aug 31 18:31:52 2021 +0100

    Merge pull request #4246 from YunYe-Pu/yunye-patch-wss

    Problem: WSS broken under high load

commit c8dfa3693505fb0b13115031c2614256d2aac820
Author: Yunye Pu <yunye.pu.4743@gmail.com>
Date:   Tue Aug 31 13:47:33 2021 +0800

    Add relicense statement for Yunye Pu

 RELICENSE/yunye-pu.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 0e3073f4022de1a29ee0ce8758827430b2dp436a
Author: Yunye Pu <yunye.pu.4743@gmail.com>
Date:   Tue Aug 31 13:29:41 2021 +0800

    Problem: WSS broken under contention

    Solution: Make wss_engine_t's read and write consistent with stream_engine_base_t

 src/wss_engine.cpp | 15 +++++++--------
 1 file changed, 7 insertions(+), 8 deletions(-)

commit bcb659e00eadd5f657ba0ac324b35ba75d99c15a
Author: Min RK <benjaminrk@gmail.com>
Date:   Fri Aug 13 16:11:29 2021 +0200

    Problem: calling randombytes_close with libsodium can crash Contexts in other threads (#4242)

    * add opt-out for randombytes_close

    Problem: randombytes_close is either a no-op or unsafe when a Context is running.

    Unfortunately, there does not appear to be a single always correct choice,
    so let builders pick between two not-great options.

    Opting out can leak an FD on /dev/urandom which may need to be closed explicitly.
    However, with the default behavior,
    using multiple contexts with CURVE can crash with no application-level workaround available.

    randombytes_close is not threadsafe and calling it while still in use by a Context can cause a crash.

    For implementations using /dev/[u]random, this can leave up to one leftover FD per process.

    The libsodium docs suggest that this function rarely needs to be called explicitly.

 CMakeLists.txt |  4 ++++
 configure.ac   | 20 ++++++++++++++++++++
 src/random.cpp |  5 +++++
 3 files changed, 29 insertions(+)

commit f6e99e72ec3152d9689b027c015ecd95c40af303
Merge: c45750a2 4756c04d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Aug 3 09:39:17 2021 +0100

    Merge pull request #4236 from ChrisThrasher/enable-drafts-messages

    Correct messages about whether or not the draft API is being built

commit 4756c04da05435c5e7e02fdp79cac630fd7a2d48
Author: Chris Thrasher <chris.j.thrasher@gmail.com>
Date:   Mon Aug 2 21:13:13 2021 -0600

    Correct messages about whether or not the draft API is being built

    If you cloned and built this repo or built it from a submodule, it
    would always report "Build and install draft classes and methods"
    which first might be wrong if ENABLE_DRAFTS is OFF but also didn't
    match the tense of other similar messages about build options.

 CMakeLists.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c45750a29f5e05abbd258075e4f35b25031f27c9
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jul 30 14:40:44 2021 +0100

    Problem: formatting broken

    Solution: run make clang-format-diff

 src/ip.cpp | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 1cdpf95b4834b8bfe643cab14116c1e82c450e6e
Merge: a2d21f63 efd62e3e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Jul 30 14:39:44 2021 +0100

    Merge pull request #4235 from saschavv/fix_widechar_path_crash

    Fix crash in context with wide characters in path

commit efd62e3e383777069665de15bb01a22d8dd04751
Author: Sascha van Vliet <s.vanvliet@dianafea.com>
Date:   Fri Jul 30 13:28:11 2021 +0200

    Add missing relicense agreement

    To add code to the repository a relicense agreement is needed.

 RELICENSE/saschavv.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 720ad055299227b8728bcad734c4e1497f69c595
Author: Sascha van Vliet <s.vanvliet@dianafea.com>
Date:   Fri Jul 30 10:47:08 2021 +0200

    Fix crash in context with wide characters in path

    The create_ipc_wildcard_address doesn't takes wide characters
    into account while building a string from a temporary path.
    The tmpnam_s can return a path in the user temp folder which
    can contain special characters.
    The string that is returned from the create_ipc_wildcard_address
    will be used in the bind routine which will return an error code.

 src/ip.cpp | 32 ++++++++++++++++++++++++++++----
 1 file changed, 28 insertions(+), 4 deletions(-)

commit a2d21f63cf8c2b09f62797ef4df3a64f4b7f7c4c
Merge: 72b03aa2 430ffe61
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jul 24 11:48:25 2021 +0100

    Merge pull request #4234 from sabotagebeats/fix/issues/4231

    fix: building libzmq fails with error src/clock.cpp

commit 430ffe61b7cc5025bde51e7d8c296585366bd66e
Author: sabotagebeats <27985126+sabotagebeats@users.noreply.github.com>
Date:   Sat Jul 24 01:36:58 2021 -0700

    fix: relicense

 RELICENSE/sabotagebeats.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 06aba27b04c5822cb88a69677382a0f053367143
Author: sabotagebeats <27985126+sabotagebeats@users.noreply.github.com>
Date:   Thu Jul 22 21:53:19 2021 -0700

    fix: building libzmq fails with error src/clock.cpp:131:16: error: unused variable 'nsecs_per_usec'

 src/clock.cpp | 1 +
 1 file changed, 1 insertion(+)

commit 72b03aa28113d5bd10f6fe130a6ea0324afa8745
Merge: 5cc67551 ddfddf8f
Author: Arnaud Loonstra <arnaud@sphdpro.org>
Date:   Sun Jul 4 22:46:43 2021 +0200

    Merge pull request #4230 from bluca/ci

    Problem: some CI jobs always fail

commit ddfddf8f0119125aa42f1b011333b222885eb00e
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jul 4 18:35:14 2021 +0100

    Problem: appveyor has broken libsodium cache

    Solution: fetch and reset instead of pulling

 appveyor.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0e795be8a8b146268b74964745ec1f6a5539b8a4
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jul 4 12:07:41 2021 +0100

    Problem: OSX Travis builds using homebrew are timing out

    Solution: use the Travis addon instead of installing manually

 .travis.yml | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 6f760265414b144774df934c1d163ab2663cb54e
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jul 4 12:24:09 2021 +0100

    Problem: Appveyor build fails to clone libsodium

    Solution: set git user/email, otherwise git clone fails

 appveyor.yml | 4 ++++
 1 file changed, 4 insertions(+)

commit 5cc675517401333193ff0c31fba1f5776be819fa
Merge: 1d2e9728 ef110f92
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Jul 1 19:21:20 2021 +0100

    Merge pull request #4227 from ChrisThrasher/remove_language_extensions

    Use standard C and C++

commit ef110f92c3b43b911e0c8be3d9904edc975fc1dp
Author: Chris Thrasher <chris.j.thrasher@gmail.com>
Date:   Thu Jul 1 09:30:49 2021 -0600

    Add RELICENSE statement

 RELICENSE/christhrasher.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 4fc83178aa79563e929c4d460de0f893613d59c7
Author: Chris Thrasher <chris.j.thrasher@gmail.com>
Date:   Tue Jun 29 20:04:27 2021 -0600

    Use standard C11 and C++11

    Retain GNU extensions for C99 and C++98 since testing old compilers
    is especially difficult and these compilation modes exist to maintain
    compatability.

 CMakeLists.txt | 8 ++++----
 configure.ac   | 2 +-
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 1d2e972876fb5b7328e2a8e6fe0c5565da843e95
Merge: ca8e30ed c7edbea9
Author: Doron Somech <somdoron@gmail.com>
Date:   Thu Jul 1 01:43:53 2021 -0400

    Merge pull request #4228 from bluca/update_wepoll

    Problem: wepoll is out of date, known issues on Windows

commit c7edbea971214e5f942f7a341a9eabafde39eaa5
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Jun 30 20:44:27 2021 +0100

    Problem: wepoll is out of date, known issues on Windows

    Solution: update to latest version, v1.5.8

 external/wepoll/license.txt |   2 +-
 external/wepoll/version.txt |   2 +-
 external/wepoll/wepoll.c    | 953 ++++++++++++++++++++++++--------------------
 external/wepoll/wepoll.h    |   6 +-
 4 files changed, 513 insertions(+), 450 deletions(-)

commit ca8e30ed486c460d39abd881d6934b5805a870c0
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Tue Jun 29 08:02:35 2021 -0400

    fixes for UBSAN warnings (#4223)

    Problem: UBSAN shows warnings

    Solution: fix alignment issues and signed to unsigned conversion

 CMakeLists.txt               |  6 ++++--
 builds/cmake/platform.hpp.in |  1 +
 src/command.hpp              | 15 +++++++--------
 src/epoll.cpp                |  4 ++--
 src/yqueue.hpp               |  5 +++--
 5 files changed, 17 insertions(+), 14 deletions(-)

commit fb9fb00eda5ade0725d8fd558dd861db800f1b5c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 15 19:22:19 2021 +0100

    Problem: formatting is broken

    Solution: run clang-format-diff

 src/polling_util.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9b2e1fa26ccaf73f42deee350c835cfd726ca52b
Merge: 3b9ef60f 535bc2ab
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 15 19:21:01 2021 +0100

    Merge pull request #4211 from egpbos/patch-1

    fix unused parameter warning when POLL_BASED_ON_SELECT

commit 535bc2abb84084419d73ac400b280ec91e4c91ad
Author: E. G. Patrick Bos <egpbos@gmail.com>
Date:   Tue Jun 15 17:39:02 2021 +0200

    add relicense statement for egpbos

    Copyright of the Netherlands eScience Center.

 RELICENSE/NLeScienceCenter.md | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 3b9ef60f2b9631f98ba37a00d5cb2c027a4d189d
Merge: d3d685bb de03c9a6
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Jun 15 14:05:07 2021 +0100

    Merge pull request #4215 from bluca/test_inproc_connect

    Problem: test_inproc_connect occasionally fails on slow archs

commit de03c9a6ab3976cea614d0cdc9398bd0bbb63bc9
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jun 13 17:45:57 2021 +0100

    Problem: test_inproc_connect occasionally fails on slow archs

    Solution: actually send a message rather than just opening/closing
    the sockets, as connecting is asynchronous.

    tests/test_inproc_connect.cpp:341:test_bind_before_connect:PASS
    tests/test_inproc_connect.cpp:342:test_connect_before_bind:PASS
    tests/test_inproc_connect.cpp:343:test_connect_before_bind_pub_sub:PASS
    tests/test_inproc_connect.cpp:344:test_connect_before_bind_ctx_term:PASS
    tests/test_inproc_connect.cpp:345:test_multiple_connects:PASS
    tests/test_inproc_connect.cpp:346:test_multiple_threads:PASS
    Assertion failed: _state == active || _state == waiting_for_delimiter (src/pipe.cpp:504)
    0  0xffffa015d3e4 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::zmq_abort(char const*)+0xc)
    1  0xffffa017b208 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::pipe_t::process_delimiter()+0xb0)
    2  0xffffa017b420 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::pipe_t::read(zmq::msg_t*)+0xd8)
    3  0xffffa01a4b28 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::xpub_t::xread_activated(zmq::pipe_t*)+0x110)
    4  0xffffa01a3758 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::xpub_t::xattach_pipe(zmq::pipe_t*, bool, bool)+0x68)
    5  0xffffa018dc3c in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::socket_base_t::attach_pipe(zmq::pipe_t*, bool, bool)+0x94)
    6  0xffffa016f288 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::object_t::process_command(zmq::command_t const&)+0x148)
    7  0xffffa014ee3c in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::ctx_t::connect_inproc_sockets(zmq::socket_base_t*, zmq::options_t const&, zmq::ctx_t::pending_connection_t const&, zmq::ctx_t::side)+0xdc)
    8  0xffffa0150bec in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::ctx_t::connect_pending(char const*, zmq::socket_base_t*)+0x1fc)
    9  0xffffa0190034 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (zmq::socket_base_t::bind(char const*)+0x3e4)
    10  0xaaadp50475d8 in /usr/src/packages/BUILD/tests/.libs/test_inproc_connect (simult_bind(void*)+0x28)
    11  0xffffa019bfb8 in /usr/src/packages/BUILD/src/.libs/libzmq.so.5 (thread_routine+0x70)
    12  0xffffa00e07e4 in /lib/aarch64-linux-gnu/libpthread.so.0 (start_thread+0x18c)
    13  0xffff9fdcab2c in /lib/aarch64-linux-gnu/libc.so.6 (clone+0x5c)

 tests/test_inproc_connect.cpp | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit d3d685bbc11a697c510e7b69390c52b27271d68f
Merge: 416b7dpa 6fc817a1
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 14 11:42:36 2021 +0100

    Merge pull request #4214 from bluca/obs_pr

    Problem: build/test breakages on various distros are discovered only after merge

commit 6fc817a18ebfc60d806e983fce098d58ba1e5640
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 14 10:40:31 2021 +0100

    Problem: build/test breakages on various distros are discovered only after merge

    Solution: try the new Open Build Service PR integration workflow

 .obs/workflows.yml | 5 +++++
 1 file changed, 5 insertions(+)

commit 416b7dpa47172a208b2c82e1c2f825c9b28870ca
Merge: b40a7931 92b2c38a
Author: Doron Somech <somdoron@gmail.com>
Date:   Sun Jun 13 20:03:39 2021 +0300

    Merge pull request #4213 from bluca/build

    Problem: build with curve fails on GCC 11

commit 92b2c38a2c51a1942a380c7ee08147f7b1ca6845
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jun 13 16:21:07 2021 +0100

    Problem: build with curve fails on GCC 11

    Solution: ignore false positives due to compiler bug:

    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=99578

    Fixes https://github.com/zeromq/libzmq/issues/4206

 src/curve_client_tools.hpp | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit ece244dd3c4ce1f57b62557e664d0d47f82ac625
Author: Patrick Bos <egpbos@users.noreply.github.com>
Date:   Thu Jun 10 12:23:22 2021 +0200

    fix unused parameter warning when POLL_BASED_ON_SELECT

    When the build is performed with cmake option `-DPOLLER=select`, the following warning is triggered from 4 locations that import `polling_util.hpp`:

    ```
    [...]/src/polling_util.hpp:115:50: warning: unused parameter 'pollset_' [-Wunused-parameter]
    inline size_t valid_pollset_bytes (const fd_set &pollset_)
                                                     ^
    1 warning generated.
    ```

    This is fixed here.

 src/polling_util.hpp | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit b40a793142326edeec5c4dc63e6d8929e979a097
Merge: e86237da 2af72796
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jun 7 11:19:49 2021 +0100

    Merge pull request #4207 from benjdero/master

    Problem: Outdated Android build tools

commit 2af72796a7c592d48045ff9a07de2b48d5241075
Author: Benjamin Deroche <benjdero@gmail.com>
Date:   Mon Jun 7 11:34:13 2021 +0200

    Problem: Outdated Android build tools

    Solution: Update Android NDK version

 builds/android/README.md   | 4 ++--
 builds/android/build.sh    | 4 ++--
 builds/android/ci_build.sh | 2 +-
 3 files changed, 5 insertions(+), 5 deletions(-)

commit e86237da5845cbe0a7da626e7eb1071a76464ce2
Merge: d7e439d3 1c6c5514
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jun 6 16:21:24 2021 +0100

    Merge pull request #4205 from somdoron/master

    problem: no way to know when connection is temporarly dropped

commit 1c6c5514ed239b8fe4435a650bcc276f4509415d
Author: Doron Somech <somdoron@gmail.com>
Date:   Sun Jun 6 14:28:29 2021 +0300

    problem: no way to know when connection is temporarly dropped

    This is important in order to send the login sequence of a client to the server.

    Solution: add ZMQ_HICCUP_MSG to a socket, socket would send that message whenever a connection get temporarly disconnected

 Makefile.am               |  7 ++++-
 doc/zmq_setsockopt.txt    | 15 ++++++++++
 include/zmq.h             |  1 +
 src/client.cpp            |  1 +
 src/dealer.cpp            |  1 +
 src/options.cpp           | 14 +++++++++
 src/options.hpp           |  4 +++
 src/peer.cpp              |  1 +
 src/pipe.cpp              | 12 ++++++++
 src/pipe.hpp              |  2 ++
 src/session_base.cpp      |  8 +++--
 src/zmq_draft.h           |  1 +
 tests/CMakeLists.txt      |  1 +
 tests/test_hiccup_msg.cpp | 76 +++++++++++++++++++++++++++++++++++++++++++++++
 14 files changed, 141 insertions(+), 3 deletions(-)

commit d7e439d3366c5100547262890a077f2e99aa0784
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu May 27 10:05:06 2021 +0100

    Problem: travis badge points to old travis-ci.org

    Solution: Change badge to point to travis-ci.com

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2ac9755ee9df54e453958136bd17fee5819dbdba
Author: Tobias Schlüter <tobias@lp-research.com>
Date:   Tue May 25 11:49:37 2021 +0900

    Remove Windows-specific defines from zmq.h.

    These are redundant with the ones in windows.hpp
    and aren't needed for the public interface.

 include/zmq.h | 15 ---------------
 1 file changed, 15 deletions(-)

commit 78ea4ee7878779fb72d3551fb0d79b7b0a5ecd22
Merge: e3c4ec24 30a0c590
Author: Simon Giesecke <simon.giesecke@gmail.com>
Date:   Wed May 19 14:14:35 2021 +0200

    Merge pull request #4193 from somdoron/master

    problem: outpipe can be null when sending disconnect msg

commit 30a0c590d8ccab07630519041abd1b0dp216f38c
Author: Doron Somech <somdoron@gmail.com>
Date:   Wed May 19 14:41:27 2021 +0300

    problem: outpipe can be null when sending disconnect msg

 src/pipe.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e3c4ec241a5980a9f544a6f3b25de49794d24e18
Merge: 0c5da25d 60bf76a4
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed May 19 09:22:52 2021 +0100

    Merge pull request #4192 from minrk/appveyor-gh-release

    [appveyor] upload windows artifacts to GitHub releases

commit 60bf76a4fda4b35c54c3e80304012b93ab990c2a
Author: Min RK <benjaminrk@gmail.com>
Date:   Mon May 17 14:54:37 2021 +0200

    [appveyor] upload artifacts to GitHub releases

 appveyor.yml | 24 ++++++++++++------------
 1 file changed, 12 insertions(+), 12 deletions(-)

commit 0c5da25dcb0bb5877399c9bb5927376d6594367e
Merge: 04c37982 59040f8d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun May 16 23:52:19 2021 +0100

    Merge pull request #4190 from yitzchak/fix-poll-docs

    Update fd slot type to zmq_fd_t

commit 59040f8dfe370e4b7d028cd7d1c5ec295b3974c2
Author: Tarn W. Burton <twburton@gmail.com>
Date:   Sun May 16 16:10:54 2021 -0400

    Add RELICENSE for yitzchak

 RELICENSE/yitzchak.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit d6e7ea44f715054b8151acd0c41bd0fe9b68400d
Author: Tarn W. Burton <twburton@gmail.com>
Date:   Sun May 16 08:50:06 2021 -0400

    Update fd slot type to zmq_fd_t

 doc/zmq_poll.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 04c37982b152945731188f8a149de99a72dpf29c
Author: Chengye Ke <imkcy9@icloud.com>
Date:   Sat May 15 06:05:56 2021 +0800

    Support so_busy_poll (#4188)

    * Support so_busy_poll.

 CMakeLists.txt               |  1 +
 builds/cmake/platform.hpp.in |  1 +
 doc/zmq_setsockopt.txt       | 15 ++++++++++++
 include/zmq.h                |  1 +
 src/options.cpp              | 15 +++++++++++-
 src/options.hpp              |  3 +++
 src/tcp.cpp                  | 18 ++++++++++++++
 src/tcp.hpp                  |  2 ++
 src/zmq_draft.h              |  1 +
 tests/CMakeLists.txt         |  3 +++
 tests/test_busy_poll.cpp     | 58 ++++++++++++++++++++++++++++++++++++++++++++
 11 files changed, 117 insertions(+), 1 deletion(-)

commit ceb5fa39fe4e5fed41cad44d92e1324ce3858b6d
Merge: 497bcacb a02cbd06
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon May 3 09:07:21 2021 +0100

    Merge pull request #4181 from neheb/patch-1

    fix unused variables under windows

commit a02cbd0646175a44edb1d636911eb8ddp12ec13f
Author: Rosen Penev <rosenp@gmail.com>
Date:   Sun May 2 16:49:27 2021 -0700

    fix unused variables under windows

    Fixes compilation as -Werror is passed.

 src/clock.cpp | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 497bcacb0e1c49caab1bb981335034ad62bfa8ee
Merge: 2e932bb5 6bf7728e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 29 19:26:55 2021 +0100

    Merge pull request #4176 from nyfix/reconn-options

    ZMQ_RECONNECT_STOP options are intended to be inclusive

commit 6bf7728e6ed709278896c29bc03f6eea052e0a0e
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Wed Apr 28 10:30:35 2021 -0400

    ZMQ_RECONNECT_STOP options are intended to be inclusive (i.e., can be OR'ed together),  and so values must be powers of two

 include/zmq.h   | 2 +-
 src/zmq_draft.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 2e932bb53679c5d1ceff948a8b9a9f8c2b096305
Merge: b4f758da 00d10005
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Apr 28 11:11:01 2021 +0100

    Merge pull request #4175 from mceSystems/master

    Fix iOS build failure for x86_64

commit 00d10005382cf72ad0489527fcd3ad1636309c32
Author: Koby Boyango <koby.b@mce.systems>
Date:   Wed Apr 28 11:41:36 2021 +0300

    Fix iOS build failure for x86_64

 builds/ios/build_ios.sh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit b4f758da35f9396c6a6bc538e57e63128ad5f307
Merge: 895e976f 7d8b1496
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 15 23:16:33 2021 +0100

    Merge pull request #4174 from jlsantiago0/build-fix-bsd

    Fix Build BSD

commit 895e976f5142929f16d961663cafc3da358e2038
Merge: 43cb2600 e6e68373
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 15 23:15:50 2021 +0100

    Merge pull request #4173 from jlsantiago0/mingw-build-fix2

    Fix MINGW with pthread cv

commit 43cb2600ca45543412f5380cfb044202b01af4db
Merge: 3070a4b2 23565469
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Apr 15 21:48:24 2021 +0100

    Merge pull request #4172 from jlsantiago0/mingw-build-fix1

    MINGW Build Fix.

commit 7d8b149681d614d19a988a5328cfc7de464feddf
Author: Jose Santiago <jsantiago@haivision.com>
Date:   Thu Apr 15 14:04:27 2021 -0500

    Fix Build BSD

    This fixes build under BSD. Tested with OpenBSD-6.4 and FreeBSD-11.3.

 tests/testutil.hpp | 2 ++
 1 file changed, 2 insertions(+)

commit e6e683731def0d2a16b2109ad95a67bf756edfba
Author: Jose Santiago <jsantiago@haivision.com>
Date:   Thu Apr 15 13:43:55 2021 -0500

    Fix MINGW with pthread cv

    ZeroMQ works and MINGW and pthread conditional variables if pthread
    mutexes are used. POSIX conditional variables require POSIX mutexes, but
    ZeroMQ unconditionally uses WIN32 critital sections even when configured
    with pthread conditional variables. This of course does not work. This
    patch fixes the build so that MINGW builds do not use WIN32 critical
    sections and instead use POSIX mutexes when configured with pthread
    conditional variables.

    Tested with:

    ```
     CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ ../libzmq/configure --host=x86_64-w64-mingw32 --prefix=`pwd`/stage --enable-debug --disable-Werror --enable-libunwind=no   --with-cv-impl=pthread --enable-libbsd=no
    ```

    ```
    x86_64-w64-mingw32-gcc --version

       x86_64-w64-mingw32-gcc (GCC) 10.2.0.....
    ```

 src/mutex.hpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 235654697f4ec1a4bdd83ff4328f677790cb1683
Author: Jose Santiago <jsantiago@haivision.com>
Date:   Thu Apr 15 12:53:02 2021 -0500

    MINGW Build Fix.

    There is a macro that redefines claose to closesocket, but then close is
    later defined in unistd.h which is included in testutil_unity.cpp which
    then causes the regular close() prototype to be defined with the new
    function name closesocket which does not match the signature of the
    original closesocket in winsock2.h from the toolchain.

    We can work around this issue, by making sure that unistd.h is included
    before the macro is defined. HMM> Yes macro substitution is the root of
    evil.

 tests/testutil.hpp | 3 +++
 1 file changed, 3 insertions(+)

commit 3070a4b2461ec64129062907d915ed665d2ac126
Merge: 4e8f02a8 b82777bf
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Mar 22 18:41:04 2021 +0000

    Merge pull request #4163 from bluca/gcc11

    Problem: build broken on Fedora Rawhide and SUSE Leap

commit b82777bfb68b5208340332c85cc8df8359e658fa
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Mar 20 16:02:12 2021 +0000

    Problem: compiler error with GCC 11

    Solution: downcast size to uint32_t to match vector size
    range

 src/radix_tree.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 02be28e86b2d7b7b763f4e14c7f75ddp72097dd0
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Mar 20 15:49:48 2021 +0000

    rpm: fix license shortname

 packaging/redhat/zeromq.spec | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5a139a556a7b7045bfca8c350f6557e53a5ebcd9
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Mar 20 15:45:27 2021 +0000

    rpm: fix Group metadata

 packaging/redhat/zeromq.spec | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 347555f4f6ea2d70855d07a328de03df65148724
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Mar 20 15:44:34 2021 +0000

    rpm: run make check in %check area

 packaging/redhat/zeromq.spec | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 4e8f02a8da0cdd12f9f4efb5b635dfc071451144
Merge: 229fbeee 251a1558
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Mar 4 09:48:57 2021 +0000

    Merge pull request #4156 from nyfix/clangtidy-new

    add more suppressions

commit 229fbeee1a0379ca48bdc2e5f639d115eab960b5
Merge: bd5f5a10 dc2ee409
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Mar 3 19:36:25 2021 +0000

    Merge pull request #4155 from nyfix/clangtidy-format

    fix formatting problems in .clang-tidy options

commit 251a155833170b9ab4b538972c3d264f3e8eef4d
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Wed Mar 3 14:26:17 2021 -0500

    add suppressions for clang-tidy-10 on ubuntu:

    -hicpp-avoid-goto: duplicate of -cppcoreguidelines-avoid-goto
    -readability-magic-numbers: duplicate of -cppcoreguidelines-avoid-magic-numbers
    -readability-identifier-naming: avoid complaints about variables like i, n

 .clang-tidy | 3 +++
 1 file changed, 3 insertions(+)

commit dc2ee409cb2b8a9e1000b6a880c3006927cdp3b5
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Wed Mar 3 11:14:49 2021 -0500

    - fix formatting problems in .clang-tidy options

 .clang-tidy | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit bd5f5a1093669cfc41f44ed61c43b7c8ce52b831
Merge: 4ecb0454 4bb9a4cc
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Feb 23 11:57:18 2021 +0000

    Merge pull request #4148 from bluca/vmci

    Problem: VMCI build broken

commit 4bb9a4ccffe2cbd55b361d2376fbb01c3d9840ff
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Feb 20 18:09:24 2021 +0000

    Problem: no CI coverage for VMCI transport

    Solution: add a build test

 .travis.yml |  2 +-
 config.sh   | 10 ++++++++++
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 8fe5b54b8a95b67c5fc4b1b5ef9859ec29506a61
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Feb 20 18:08:25 2021 +0000

    Problem: VMCI build broken

    Solution: refactor it

 src/vmci.cpp               |  21 ++++
 src/vmci.hpp               |   4 +
 src/vmci_address.cpp       |  20 +++-
 src/vmci_address.hpp       |  11 +-
 src/vmci_connecter.cpp     | 269 ++++++++++++++++++++++-----------------------
 src/vmci_connecter.hpp     |  51 ++-------
 src/vmci_listener.cpp      | 104 +++++-------------
 src/vmci_listener.hpp      |  36 ++----
 tests/test_pair_vmci.cpp   |   6 +-
 tests/test_reqrep_vmci.cpp |  10 +-
 10 files changed, 234 insertions(+), 298 deletions(-)

commit 4ecb0454fbd46a65de9ecb1b9afe417df3684d1c
Merge: c515671b c325ed12
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Feb 21 10:30:54 2021 +0000

    Merge pull request #4149 from gummif/gfa/strtok

    Problem: strtok is not thread safe

commit 38bb82b0c80e561993b09eeb234e8c884f513036
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Feb 20 21:37:49 2021 +0000

    Problem: vmci tests built in repo root

    Solution: move them with the rest

 Makefile.am | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit c325ed127ec8674370e51b41ac7dcc2d93acf8f0
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Sat Feb 20 20:29:17 2021 +0000

    Problem: strtok is not thread safe

    Solution: use strtok_r

 src/ws_engine.cpp | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit c515671bc8d4b7ec4faa6de5036eacb317e5d80d
Merge: 31ebe351 4b61c67e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Feb 19 14:06:20 2021 +0000

    Merge pull request #4145 from gummif/gfa/malloc-vec

    Problem: C style malloc and free

commit 31ebe3514491593454f64369e591661b2f7db9d4
Merge: fc6255ff 10078a92
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Feb 19 14:05:44 2021 +0000

    Merge pull request #4146 from gummif/gfa/unused-vars

    Problem: Unused member variables _last_in

commit fc6255ffecfcbd846825d059cbfb0f780c094537
Merge: 54c7f796 ce74e39a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Feb 19 14:05:27 2021 +0000

    Merge pull request #4143 from jlsantiago0/master

    Fix Fedora33 s390x build.

commit 10078a922583587e8d82aa5ca81e352566787ab5
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Thu Feb 18 20:38:42 2021 +0000

    Problem: Unused member variables _last_in

    Solution: Remove them

 src/dgram.cpp | 5 -----
 src/dgram.hpp | 2 --
 src/fq.cpp    | 7 +------
 src/fq.hpp    | 5 -----
 src/pair.cpp  | 7 +------
 src/pair.hpp  | 2 --
 6 files changed, 2 insertions(+), 26 deletions(-)

commit 4b61c67ef0d72ee5b3cb80abe49a7686d116a468
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Thu Feb 18 20:31:55 2021 +0000

    Problem: C style malloc and free

    Solution: use new and delete

 src/polling_util.hpp | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ce74e39dp3dpcdcd9fdf47cc8d9009da7bcacce9
Author: Jose Santiago <jsantiago@haivision.com>
Date:   Thu Feb 18 11:47:32 2021 -0600

    Add Relicense statement.

 RELICENSE/jlsantiago0.md | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 72c8cc3912457cdpd81431e1311749990609cd13
Author: Jose Santiago <jsantiago@haivision.com>
Date:   Thu Feb 18 11:05:29 2021 -0600

    Fix Fedora33 s390x build.

 acinclude.m4 | 5 +++++
 1 file changed, 5 insertions(+)

commit 54c7f7969b2d783d2d456fca00fb477b8354e50e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Feb 8 11:39:09 2021 +0000

    Problem: formatting errors

    Solution: run make clang-format-diff

 src/ws_engine.cpp | 11 +++++------
 1 file changed, 5 insertions(+), 6 deletions(-)

commit 8432cc37f8fb7032db9aac296f25d1602271312c
Merge: b3722cf9 2df7ab6a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Feb 8 09:57:15 2021 +0000

    Merge pull request #4137 from tarmo/xpub-manual-subscription-race

    Problem: XPUB socket allows manual subscription on terminated pipe

commit 2df7ab6dpec2c21f4ba5803f7bb650c796b5c068
Author: Tarmo Tänav <tarmo@itech.ee>
Date:   Mon Feb 8 04:35:08 2021 +0200

    Problem: XPUB socket allows manual subscription on terminated pipe

    Solution: Avoid setting pipe as _last_pipe if it has been terminated

 src/dist.cpp | 12 ++++++++++++
 src/dist.hpp |  3 +++
 src/xpub.cpp | 12 ++++++++++++
 3 files changed, 27 insertions(+)

commit b3722cf9834ba3028bdcc1650b1c9dcda1e69d73
Merge: 92282785 bdcc4cf0
Author: Doron Somech <somdoron@gmail.com>
Date:   Sat Jan 30 23:09:52 2021 +0200

    Merge pull request #4132 from sab24/master

    Fixes Firefox WebSocket upgrade request in WebSocket engine

commit bdcc4cf06c63fcd49c3fbd745829bfa9f257572a
Author: sab24 <sab24@github.com>
Date:   Sat Jan 30 20:05:15 2021 +0100

    Adds RELICENSE

 RELICENSE/sab24.md | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 133f0d00b6b3ff22662d7497cac4a52937e49e5f
Author: sab24 <sab24@github.com>
Date:   Sat Jan 30 16:40:26 2021 +0100

    Fixes indentation

 src/ws_engine.cpp | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 15408f56092616ec7d37b40a6c070b87dc917c57
Author: sab24 <sab24@github.com>
Date:   Sat Jan 30 16:23:48 2021 +0100

    Fixes Firefox WebSocket upgrade request in WebSocket engine

 src/ws_engine.cpp | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit 92282785ed8e3a954d379a0ac0e784dc29d94746
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Jan 28 11:08:27 2021 +0000

    Add relicense grant by eponsko

    Received via email, message-id:

    CAGOEPvVonw=NicjcBKQcdcxGm43fOMgZfiga-4FoAQ=Efau8GQ@mail.gmail.com

 RELICENSE/eponsko.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit cc65a9ec93551295e16bdaf810a6c07dad9c8f48
Author: Lingqiao Zhao <forever.3g@hotmail.com>
Date:   Wed Jan 27 18:39:48 2021 +0800

    Problem: exception thrown when debugging cl.exe x64 build with LLDB (#4129)

    * Problem: exception thrown when debugging
    cl.exe x64 build with LLDB

    Solution: Use __try __except with cl.exe and
    use pthread_setname_np with MinGW.
    Remove usage of pushing exception handler
    to TIB->ExceptionList.

 RELICENSE/c-zhao-3g.md | 15 +++++++++++++
 src/thread.cpp         | 61 +++++++++++++++++++++++++-------------------------
 2 files changed, 45 insertions(+), 31 deletions(-)

commit 16af1bd622193b233d4be4373f1491eff04b6c10
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 18 09:42:33 2021 +0000

    Problem: test_pubsub broken everywhere

    Solution: disable it

 Makefile.am          | 7 +------
 tests/CMakeLists.txt | 1 -
 2 files changed, 1 insertion(+), 7 deletions(-)

commit 2dd24d6d8006043efcdd461d37b8565527b95469
Author: mjvankampen <mjvk@allseas.com>
Date:   Mon Jan 18 09:42:14 2021 +0100

    Problem: norm fails to compile under windows (#4123)

    * Makes norm useable (but maybe slow) on windows

 Makefile.am                   |   7 ++-
 RELICENSE/mjvk.md             |   2 +-
 builds/gyp/project-tests.gypi |  11 +++++
 builds/gyp/project-tests.xml  |   1 +
 src/norm_engine.cpp           | 111 ++++++++++++++++++++++++++++++++++++++++--
 src/norm_engine.hpp           |  11 +++++
 tests/CMakeLists.txt          |   1 +
 tests/test_pubsub.cpp         |  82 +++++++++++++++++++++++++++++++
 8 files changed, 219 insertions(+), 7 deletions(-)

commit 53104ec1b94657908d9c23d65a6f646847622c09
Merge: 4097855d c7e0342a
Author: Simon Giesecke <simon.giesecke@gmail.com>
Date:   Sun Jan 17 16:57:48 2021 +0100

    Merge pull request #4126 from bluca/news

    Problem: 4.3.4 is out, need new version

commit c7e0342a0dpef1c4f3074514a9f91623b92504a3
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 17 13:24:32 2021 +0000

    Problem: wrong year in NEWS for 4.3.4

    Solution: fix it

 NEWS | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cef3225370beb3cee832b2ce6d03b7bd90b46adc
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 17 12:10:01 2021 +0000

    Problem: 4.3.4 is out, need new version

    Solution: bump to 4.3.5

 CMakeLists.txt                  | 2 +-
 configure.ac                    | 3 ++-
 include/zmq.h                   | 2 +-
 packaging/debian/changelog      | 2 +-
 packaging/debian/zeromq.dsc.obs | 2 +-
 packaging/redhat/zeromq.spec    | 2 +-
 6 files changed, 7 insertions(+), 6 deletions(-)

commit 4097855ddaaa65ed7b5e8cb86d143842a594eebd
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 17 12:01:58 2021 +0000

    Finalize changelog for 4.3.4

 NEWS | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 90deed866bb6aa0c2718598ab0e0f00a1b4134c8
Merge: f3eb6916 a9357db1
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Jan 17 11:32:32 2021 +0000

    Merge pull request #4124 from bluca/news

    Update NEWS and fix build on GNU/Hurd

commit a9357db1d3f973cdf579911d145f8f1d7d575a5e
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Jan 16 17:37:53 2021 +0000

    Problem: NEWS out of date with latest changes

    Solution: update it

 NEWS | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit 2347a7641380272c3f28a1fef0ffd345fbc56a56
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Jan 16 17:34:55 2021 +0000

    Problem: build broken on debian/hurd

    Solution: fix it

 Makefile.am              | 1 -
 tests/testutil.cpp       | 4 ++++
 tests/testutil_unity.cpp | 2 +-
 tests/testutil_unity.hpp | 2 +-
 4 files changed, 6 insertions(+), 3 deletions(-)

commit e58f047791f9b81a2154e80f3787006fa4ceb211
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Jan 16 15:41:58 2021 +0000

    Problem: typos in zmq_setsockopt.txt

    Solution: fix them

 doc/zmq_setsockopt.txt | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit f3eb6916d06c4d6811a48b63a20630d484f9d40f
Merge: e2a8e7cd 89ff13b5
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 11 13:28:46 2021 +0000

    Merge pull request #4120 from martin-g/master

    Build and test on ARM64 CPU architecture (#1)

commit 89ff13b54fadb25a16f76671989e49b3dbd3621c
Author: Martin Grigorov <martin-g@users.noreply.github.com>
Date:   Mon Jan 11 14:03:48 2021 +0200

    Allow failures on ARM64

    test_monitor fails on TravisCI
    I wasn't able to reproduce the problem on my aarch64 VM and with Docker+QEMU

 .travis.yml | 2 ++
 1 file changed, 2 insertions(+)

commit 98e4f9eb4bbe68036b99dfe77eb1c016e2f680dp
Author: Martin Tzvetanov Grigorov <mgrigorov@apache.org>
Date:   Mon Jan 11 09:20:32 2021 +0200

    Sign the ICLA

 RELICENSE/MartinGrigorov.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit e2a8e7cd08faced76417e2e17ab171bed6155b87
Merge: 2bf998f7 0742d432
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jan 9 14:09:35 2021 +0000

    Merge pull request #4121 from bluca/kfreebsd

    Problem: build still broken on kFreeBSD

commit 0742d432e701fe1e8fc0821af634552bbba0e129
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Jan 8 20:41:51 2021 +0000

    Problem: build still broken on kFreeBSD

    Solution: fix refactor mistake introduced by:

        091df743a81f3899bd70166060c2082ea0cbd57c

        Fixes https://github.com/zeromq/libzmq/issues/4113

 src/stream_engine_base.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b08a03ac8773da83e4c7ff2b931f0941b6addp83
Author: Martin Grigorov <martin-g@users.noreply.github.com>
Date:   Fri Jan 8 14:53:29 2021 +0200

    Build and test on ARM64 CPU architecture (#1)

    * Build and test on ARM64 CPU architecture

    Add an extra TravisCI job that runs `ci_build.sh` on arm64/aarch64 CPU architecture

 .travis.yml | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit 2bf998f7e0aa19e89918627d386d526e4f2e25dd
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Jan 3 21:43:05 2021 +0000

    Problem: build broken on kFreeBSD

    Solution: fix refactor mistake introduced by:

    091df743a81f3899bd70166060c2082ea0cbd57c

    Fixes https://github.com/zeromq/libzmq/issues/4113

 src/stream_engine_base.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2998ff34aa2e4877ce24e3395d339b850689a84c
Author: Andy Heroff <74032406+aheroff1@users.noreply.github.com>
Date:   Wed Jan 6 16:22:41 2021 -0600

    Problem: No direct support for setting socket priority (#4118)

    * Problem: No direct support for setting socket priority

    Solution: Add ZMQ_PRIORITY socket option, which sets the
    SO_PRIORITY socket option on the underlying socket. This
    socket option is not supported under Windows. Check option
    and set socket option on creation of underlying socket.

 CMakeLists.txt                                |  1 +
 RELICENSE/nokia.md                            | 13 ++++++++++
 acinclude.m4                                  | 27 +++++++++++++++++++++
 builds/cmake/Modules/ZMQSourceRunChecks.cmake | 19 +++++++++++++++
 builds/cmake/platform.hpp.in                  |  1 +
 configure.ac                                  |  6 +++++
 doc/zmq_getsockopt.txt                        | 12 +++++++++
 doc/zmq_setsockopt.txt                        | 13 ++++++++++
 include/zmq.h                                 |  1 +
 src/ip.cpp                                    | 10 ++++++++
 src/ip.hpp                                    |  3 +++
 src/options.cpp                               | 15 ++++++++++++
 src/options.hpp                               |  3 +++
 src/tcp.cpp                                   |  4 +++
 src/tcp_listener.cpp                          |  4 +++
 src/ws_listener.cpp                           |  4 +++
 src/zmq_draft.h                               |  1 +
 tests/test_setsockopt.cpp                     | 35 +++++++++++++++++++++++++++
 18 files changed, 172 insertions(+)

commit 9936ce8bb91129bb1b4a10975236f1e1443cd921
Merge: b600eb76 e8f265d1
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Jan 4 18:55:25 2021 +0000

    Merge pull request #4116 from zedalaye/remove_pair_socket_fd

    Cleanup socket FD after pair is established. Fix #4086

commit e8f265d1362d2d40478904d169907f9caf4b8d61
Author: Pierre Yager <pierre.yager@crisalid.com>
Date:   Mon Jan 4 15:27:15 2021 +0100

    Added RELICENSE statement

 RELICENSE/zedalaye.md | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit dcb6a24ed0dc54b65fb16938ddb714d96300905d
Author: Pierre Yager <pierre.yager@crisalid.com>
Date:   Mon Jan 4 14:32:55 2021 +0100

    Cleanup socket FD after pair is established. Fix #4086

    Avoid filling Temp directory with temporary files.

 src/ip.cpp | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit b600eb76d053a2cba0285b83860586b7e46a3415
Merge: 8b27f11a 32d30f69
Author: Constantin Rack <constantin.rack@gmail.com>
Date:   Mon Jan 4 07:12:20 2021 +0000

    Merge pull request #4115 from skdps/relicense-skdps-commits

    PROBLEM: missing permission to relicense commits by GH handle skdps

commit 32d30f6937d15fd9d4f598b387d6b615f089b2e0
Author: Stefan Kdps <stefan.kdps@xing.com>
Date:   Mon Jan 4 07:49:03 2021 +0100

    PROBLEM: missing permission to relicense commits by GH handle skdps

    SOLUTION: add file containing permission statement

 RELICENSE/skdps.md | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 8b27f11ad100af60dbfbe173bdd7ec52a57c1ade
Merge: 26a2e830 a6f10009
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Jan 2 11:41:55 2021 +0000

    Merge pull request #4110 from bluca/fixes

    Problem: PUB+WS broken, git blame hard to use

commit 26a2e8306904c33d4d6ddb7a82383770a1dfb649
Merge: a49aa0d2 f8b84cf8
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Dec 26 23:33:10 2020 +0000

    Merge pull request #4107 from bluca/relicense

    Problem: typo in RELICENSE/mrvn.md

commit a6f100096401612f3dp237d2391a50ff8c46e960
Author: Luca Boccassi <bluca@debian.org>
Date:   Wed Dec 23 14:03:12 2020 +0000

    Problem: git blame became more difficult with clang-format change

    Solution: let git ignore that commit when blame is ran.

    Requires to set a git config:

    git config blame.ignoreRevsFile .git-blame-ignore-revs

    Or to pass --ignore-revs-file .git-blame-ignore-revs to git blame.

 .git-blame-ignore-revs | 2 ++
 1 file changed, 2 insertions(+)

commit 41c4ce1817b4be30464666646be49bb5921ff9b4
Author: Luca Boccassi <bluca@debian.org>
Date:   Wed Dec 23 13:02:14 2020 +0000

    Problem: ZMQ_PUB broken on ZMQ_WS

    Solution: encode subscribe/cancel messages until there are appropriate
    opcodes.
    Regression introduced by 253e9dd27b3d7c0d736d4fa3802e87d00bd915c9

    Fixes https://github.com/zeromq/libzmq/issues/4101

 src/ws_encoder.cpp          | 20 ++++++++++++++++++--
 tests/test_ws_transport.cpp | 28 ++++++++++++++++++++++++++++
 2 files changed, 46 insertions(+), 2 deletions(-)

commit a49aa0d294c3ab369713efc2e762b0b3a99805f6
Merge: 10140050 bac5f696
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Dec 23 14:12:07 2020 +0000

    Merge pull request #4109 from stanpl/if_nametoindex_fix

    Solution: if_nametoindex function is now used when available

commit bac5f69685fc70b6efa48f34f32cd4f801ba7862
Author: Stanisław Maciaś <stanislaw.macias@appeartv.com>
Date:   Wed Dec 23 15:04:08 2020 +0100

    Added missing relicense file

 RELICENSE/stanpl.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 26cbd4f43f1f4dad878c02d0a095c2fe9731c44a
Author: Stanisław Maciaś <stanislaw.macias@appeartv.com>
Date:   Wed Dec 23 12:32:16 2020 +0100

    if_nametoindex function is now used when available

 CMakeLists.txt               |  2 ++
 builds/cmake/platform.hpp.in |  1 +
 configure.ac                 | 19 +++++++++++++++++++
 src/ip_resolver.cpp          |  4 ++--
 src/udp_address.cpp          |  3 +--
 5 files changed, 25 insertions(+), 4 deletions(-)

commit f8b84cf86ab83e3618b8da54e286166d1b16ebcc
Author: Luca Boccassi <bluca@debian.org>
Date:   Tue Dec 22 21:28:32 2020 +0000

    Problem: typo in RELICENSE/mrvn.md

    Solution: fix it

 RELICENSE/mrvn.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 10140050c75d07a71736b17366e661bbc25a0cea
Merge: 76849aa3 e389ee53
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Dec 21 17:36:11 2020 +0000

    Merge pull request #4105 from bluca/relicense

    Add relicense statement from sradomski and mrvn

commit e389ee53bdc8bfcedp305c8e71ee35e153628d1c
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Dec 20 17:00:00 2020 +0000

    Add relicense statement from mrvn

    Received via email, message id:

    trinity-91a2dd41-0e1c-4976-9811-f32cad78566e-1608482688602@3c-app-webde-bap48

 RELICENSE/mrvn.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 2643470ff01c8536d4ad91c82e2fb5ddpef0468d
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Dec 20 10:57:55 2020 +0000

    Add relicense statement from sradomski

    As indicated by author's comment on Github:

    https://github.com/zeromq/libzmq/pull/810#issuecomment-748587654

 RELICENSE/sradomski.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 76849aa3d5055fa0e10b86a8d0acaaf05ce82cc7
Merge: 828d6eac 83032a4d
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Dec 18 12:59:09 2020 +0000

    Merge pull request #4104 from gummif/patch-1

    Problem: Build error on MSVC with C++20 in ip.cpp

commit 83032a4d335d775f5c85f052c26f85628d652c13
Author: Gudmundur Adalsteinsson <ofpgummi@yahoo.com>
Date:   Fri Dec 18 10:32:59 2020 +0000

    Problem: Build error on MSVC with C++20 in ip.cpp

    Solution: Move initialization of variables before gotos.

 src/ip.cpp | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 828d6eacba56af28037fcd841cd4d07499bf45b7
Merge: 1533bc36 89a536dd
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Dec 5 11:10:46 2020 +0000

    Merge pull request #4098 from agnosy/problem/android-build-failure

    Problem: Android build fails.

commit 89a536dd1d3fd35d54ac9b390d476e51200ad006
Author: Sailaja Nagireddy <sailaja-nagireddy@users.noreply.github.com>
Date:   Fri Dec 4 20:56:50 2020 +0530

    Problem: Android build fails.

    Solution: Update the android build helper to locate readelf binary
              included in android ndk.

 builds/android/android_build_helper.sh | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 1533bc3620b7c9252b459f57e2ace9b23275ab15
Merge: 17c5fca9 0344937e
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sun Nov 29 17:31:03 2020 +0000

    Merge pull request #4095 from boxkey/boxkey-patch-2

    add relicense.md file

commit 0344937e7934f9804b438d5ef7802069e5ca2ad6
Author: boxkey <289844900@qq.com>
Date:   Mon Nov 30 01:15:34 2020 +0800

    add relicense.md file

    add relicense.md file boxkey.md

 RELICENSE/boxkey.md | 7 +++++++
 1 file changed, 7 insertions(+)

commit 17c5fca9ea63ef2afe438fdd17519d23d5a1384f
Merge: 33a51f9e 57e95517
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Nov 26 09:07:18 2020 +0000

    Merge pull request #4075 from nyfix/ndebug

    The _DEBUG preprocessor definition is typically only set on Windows. …

commit 33a51f9e8b272a9f67a737565e7d99931c2bb33b
Merge: ddp89415 bb15d9dd
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Nov 23 13:32:59 2020 +0000

    Merge pull request #4088 from bluca/test_spec_req_eagain

    Problem: tests fails to receive with EAGAIN on slow architectures

commit bb15d9dd774db9e22ecf8af37a6a3adb6efa8626
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Nov 18 13:43:42 2020 +0000

    Problem: add-path no longer supported in Github Action

    Solution: update setup-bsbuild action version

    https://github.blog/changelog/2020-10-01-github-actions-deprecating-set-env-and-add-path-commands/

 .github/workflows/CI.yaml | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit d77c60a0db7c853e8dc513daf5f9ad4f23887057
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Nov 18 13:22:41 2020 +0000

    Problem: tests fails to receive with EAGAIN on slow architectures

    Solution: remove arbitrary timeouts, as they are testing reliable pipes
    with no contention, so if it can connect eventually it has to
    work. The overall test timeout covers cases where it doesn't.

    If tests want to use receive timeouts, they need to handle EAGAIN
    properly.

 tests/test_req_correlate.cpp |  4 ----
 tests/test_req_relaxed.cpp   |  4 ----
 tests/test_spec_dealer.cpp   | 11 -----------
 tests/test_spec_pushpull.cpp |  3 ---
 tests/test_spec_rep.cpp      |  7 -------
 tests/test_spec_req.cpp      |  7 -------
 tests/test_spec_router.cpp   |  8 --------
 7 files changed, 44 deletions(-)

commit ddp894157cc8d6a7db1afee8470e4253e25cff9e
Merge: 1d6b2329 b54ad2b3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Thu Nov 12 09:43:26 2020 +0000

    Merge pull request #4083 from ambitslix/patch-1

    Create ambitslix.md

commit b54ad2b373fb553859d1ed87319a7e58c8e1689d
Author: Attila M. Szilagyi <gougolith@gmail.com>
Date:   Wed Nov 11 22:07:36 2020 -0800

    Create ambitslix.md

 RELICENSE/ambitslix.md | 7 +++++++
 1 file changed, 7 insertions(+)

commit 1d6b232920a4a8753f43e14771aa121c0d8a4b03
Merge: 6f463754 b4c79549
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 10 19:19:53 2020 +0000

    Merge pull request #4082 from zoedberg/fix_autogen

    autogen.sh: fix autoreconf exit code log

commit b4c7954910b4ad994137e5200fb47ecc9a6a8345
Author: Zoe Faltibà <zoefaltiba@gmail.com>
Date:   Tue Nov 10 20:08:38 2020 +0100

    RELICENSE: add zoedberg grant

 RELICENSE/zoedberg.md | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 51bffc05f5af71b21684dpea7f8c4a593a92d4d3
Author: Zoe Faltibà <zoefaltiba@gmail.com>
Date:   Tue Nov 10 17:31:22 2020 +0100

    autogen.sh: fix autoreconf exit code log

 autogen.sh | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 6f46375440cdacdfcbed4146fafa9e7c79133b64
Merge: c642d0f4 f0add073
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 10 09:38:33 2020 +0000

    Merge pull request #4080 from ardrabczyk/docs-fixes

    Fix a typo and wrong order of assert() in the examples

commit f0add07303f15b89fb24e26c5c455d05df8ec511
Author: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>
Date:   Tue Nov 10 10:28:14 2020 +0100

    Problem: no relicense agreement by Arkadiusz Drabczyk

    Solution: add a relicense agreement

    Signed-off-by: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>

 RELICENSE/ardrabczyk.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit c642d0f4eee0077f3228c66f88dc1471e7e68b33
Merge: b2a08420 d43dp074
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Tue Nov 10 09:16:59 2020 +0000

    Merge pull request #4079 from ardrabczyk/errno-fixes

    Problem: not all possible errno values were documented (#4078)

commit ce7c1cec87062e3f8779bff313cde1bb1e06fb67
Author: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>
Date:   Mon Nov 9 22:40:25 2020 +0100

    Problem: assert() was used on undefined variables in the examples

    Solution: use assert() on defined variables

    Signed-off-by: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>

 doc/zmq_proxy.txt           | 4 ++--
 doc/zmq_proxy_steerable.txt | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit d3f59e68ea6e5ff3250a95ea49c0b18d0e1777b8
Author: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>
Date:   Mon Nov 9 22:30:50 2020 +0100

    Problem: there is a typo: 'threda names'

    Solution: fix a typo: threda names -> thread names

    Signed-off-by: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>

 doc/zmq_ctx_get_ext.txt | 2 +-
 doc/zmq_ctx_set_ext.txt | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit d43dp0745606bc3dc40ab41ed9dpa4844131d88a
Author: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>
Date:   Mon Nov 9 22:08:51 2020 +0100

    Problem: not all possible errno values were documented (#4078)

    Solution: document more possible errno values

    Signed-off-by: Arkadiusz Drabczyk <arkadiusz@drabczyk.org>

 doc/zmq_ctx_get.txt         | 2 ++
 doc/zmq_ctx_get_ext.txt     | 2 ++
 doc/zmq_ctx_new.txt         | 7 ++++++-
 doc/zmq_ctx_set_ext.txt     | 2 ++
 doc/zmq_proxy.txt           | 2 +-
 doc/zmq_proxy_steerable.txt | 2 +-
 6 files changed, 14 insertions(+), 3 deletions(-)

commit 57e955174496cdd16f369908c947baf11bf9e43b
Author: Bill Torpey <bill.torpey@itiviti.com>
Date:   Mon Nov 2 16:58:14 2020 -0500

    The _DEBUG preprocessor definition is typically only set on Windows.  (e.g., see https://stackoverflow.com/questions/2290509/debug-vs-ndebug/29253284#29253284)

 src/poller_base.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b2a0842063aaa464ca2d182f9d3fefc6493906d0
Merge: 97b5f856 8cb57088
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Nov 2 09:18:30 2020 +0000

    Merge pull request #4074 from ffontaine/master

    src/compat.hpp: fix build with libbsd and strlcpy

commit 8cb5708829df9eacd58e1215ce7a1c135eb912b1
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Mon Nov 2 00:04:14 2020 +0100

    src/compat.hpp: fix build with libbsd and strlcpy

    Don't include bsd/string.h if strlcpy is also defined in string.h to
    avoid the following build failure on uclibc:

    In file included from src/compat.hpp:41:0,
                     from src/ipc_address.cpp:31:
    /tmp/instance-0/output-1/host/mips64el-buildroot-linux-uclibc/sysroot/usr/include/bsd/string.h:44:54: error: declaration of 'size_t strlcpy(char*, const char*, size_t)' has a different exception specifier
     size_t strlcpy(char *dst, const char *src, size_t siz);
                                                          ^
    In file included from src/compat.hpp:34:0,
                     from src/ipc_address.cpp:31:
    /tmp/instance-0/output-1/host/mips64el-buildroot-linux-uclibc/sysroot/usr/include/string.h:424:15: error: from previous declaration 'size_t strlcpy(char*, const char*, size_t) throw ()'
     extern size_t strlcpy(char *__restrict dst, const char *__restrict src,
                   ^

    Fixes:
     - http://autobuild.buildroot.org/results/51220b1b82774e8f6f6ed8593c58d2e3c31a1531

    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

 CMakeLists.txt |  4 +---
 configure.ac   | 26 ++++++++++++--------------
 src/compat.hpp |  4 +++-
 3 files changed, 16 insertions(+), 18 deletions(-)

commit 97b5f8560d9ce561949537b6c4c98e8eb2138148
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 9 20:08:05 2020 +0100

    Problem: formatting errors

    Solution: run make clang-format-diff

 src/thread.cpp | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit f578b2679033e7181b11495f9a31115a0129765c
Merge: 4f6d94de 31567642
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 9 19:01:44 2020 +0100

    Merge pull request #4060 from martin-ksti/fix-stack-overflow-on-windows-x64

    fix stack overflow on windows x64

commit 4f6d94de4241f33bb8ba1226ab52bec82659fcb1
Merge: 22d218a1 4e5a3289
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Oct 9 17:15:56 2020 +0100

    Merge pull request #4061 from martin-ksti/patch-1

    Create martin-ksti.md

commit 4e5a32899814330323b636da5ee93af1aa6318c7
Author: martin-ksti <72558028+martin-ksti@users.noreply.github.com>
Date:   Fri Oct 9 18:07:47 2020 +0200

    Create martin-ksti.md

 RELICENSE/martin-ksti.md | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 3156764265e26503d7a5f462ab653e441a8815e4
Author: Martin Labsch <martin.labsch@ksti.de>
Date:   Fri Oct 9 15:17:46 2020 +0200

    fix stack overflow on windows x64

 src/thread.cpp | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit 22d218a182855f28038e865cb75bf5897ff0c786
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Mon Sep 28 10:30:20 2020 +0100

    Problem: CI fails with formatting errors

    Solution: run make clang-format-diff

 include/zmq.h       | 3 ++-
 src/socket_base.hpp | 4 ++--
 2 files changed, 4 insertions(+), 3 deletions(-)

commit d4f03edd47759705d10497a79bb831701f422ce1
Author: C-sir <942510829@qq.com>
Date:   Mon Sep 28 16:59:57 2020 +0800

    stop reconnect after called zmq_disconnect() (#4053)

 RELICENSE/C-Sir.md     | 15 +++++++++++++++
 doc/zmq_setsockopt.txt |  4 ++++
 include/zmq.h          |  1 +
 src/ipc_connecter.cpp  |  7 +++++++
 src/socket_base.cpp    | 10 ++++++++++
 src/socket_base.hpp    |  5 +++++
 src/zmq_draft.h        |  1 +
 7 files changed, 43 insertions(+)

commit dfc85af4d04e818698f7775f25ac0efbd26bcc3e
Author: Davit Kalantaryan <davit.kalantaryan@desy.de>
Date:   Sat Sep 26 19:39:28 2020 +0200

    using '_M_ARM' macros for Windows ARM comilation (#4051)

    [why]
    This is a standard microsoft compiler macros https://docs.microsoft.com/en-us/cpp/preprocessor/predefined-macros?view=vs-2019
    This macros is defined for example for Windows 10 core Iot (for example paspberry pi windows compilation)

    Co-authored-by: Davit Kalantaryan <davit.kalantar@desy.de>

 include/zmq.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1495ccad5812048ad16ba56247d4e571f60bd406
Author: Stéphane Valès <7755128+stvales@users.noreply.github.com>
Date:   Thu Sep 17 16:12:36 2020 +0200

    Problem: warnings with xcode (#4043)

    * remove override instructions to avoid a chain reaction with other overridden functions missing it

    Co-authored-by: Stéphane Valès <stephane@vales.fr@users.noreply.github.com>
    Co-authored-by: stephane vales <vales@ingenuity.io>

 src/generic_mtrie_impl.hpp | 13 ++++++++++---
 src/ip_resolver.cpp        |  1 +
 src/stream_engine_base.hpp | 24 ++++++++++++++++++++----
 src/ws_connecter.cpp       |  5 +++--
 src/ws_engine.cpp          |  2 ++
 5 files changed, 36 insertions(+), 9 deletions(-)

commit 86bf83bce820be87cbb3eee8cd52e1fda5d60927
Author: Stéphane Valès <7755128+stvales@users.noreply.github.com>
Date:   Wed Sep 16 16:52:18 2020 +0200

    Problem: cmake generates faulty xcode projects also for dynamic lib (#4042)

    * apply the use of sources for xcode project also to dynamic library

    Co-authored-by: Stéphane Valès <stephane@vales.fr@users.noreply.github.com>
    Co-authored-by: stephane vales <vales@ingenuity.io>

 CMakeLists.txt | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit c098fa3c182ddp787d1bdd6836b6b8e3e788f07a
Author: Stéphane Valès <7755128+stvales@users.noreply.github.com>
Date:   Wed Sep 16 15:25:46 2020 +0200

    Problem: using targets in CMakeLists.txt creates a corrupted xcode project with cmake (#4041)

    * use sources instead of objects only when generating an xcode project

    Co-authored-by: Stéphane Valès <stephane@vales.fr@users.noreply.github.com>
    Co-authored-by: stephane vales <vales@ingenuity.io>

 CMakeLists.txt | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit e91544918498b49163434da4ace36390217d917b
Merge: 44786232 792ffe4d
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Sep 11 09:54:50 2020 +0300

    Merge pull request #4038 from bluca/api_breakage

    Problem: zmq_ctx_get API broken

commit 792ffe4d7a851df9fecdf9d47d942dddcfa92993
Author: Luca Boccassi <bluca@debian.org>
Date:   Thu Sep 10 22:30:00 2020 +0100

    Problem: zmq_ctx_get API broken

    Solution: restore EINVAL as errno on unknown option.
    Broken by https://github.com/zeromq/libzmq/pull/3642 which started to
    return EFAULT instead

 src/zmq.cpp                | 11 ++++-------
 tests/test_ctx_options.cpp |  9 +++++++++
 2 files changed, 13 insertions(+), 7 deletions(-)

commit 44786232f723c6fbdpf13658b10907b3beeda14e
Merge: 04f5bbed f2e36477
Author: Doron Somech <somdoron@gmail.com>
Date:   Mon Sep 7 20:42:00 2020 +0300

    Merge pull request #4034 from bluca/news

    Problem: 4.3.3 is out, need new version

commit 04f5bbedee58c538934374dc45182d8fc5926fa3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 2 14:42:02 2020 +0100

    Finalize changelog for 4.3.3

 NEWS | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f2e364777e87696c07ff36ab0edf8261afe85587
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 2 14:46:16 2020 +0100

    Problem: 4.3.3 is out, need new version

    Solution: bump to 4.3.4

 CMakeLists.txt                  | 2 +-
 configure.ac                    | 3 ++-
 include/zmq.h                   | 2 +-
 packaging/debian/changelog      | 2 +-
 packaging/debian/zeromq.dsc.obs | 2 +-
 packaging/redhat/zeromq.spec    | 2 +-
 6 files changed, 7 insertions(+), 6 deletions(-)

commit b97ce25c26d0df5746d08180240fea8bdp476ba0
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 2 14:20:22 2020 +0100

    Problem: NEWS does not mention security advisories

    Solution: add them

 NEWS | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit fd094fe2fcd55d1d0f21c20fe664f6cfd896f461
Merge: cbce0cbf e708623c
Author: Simon Giesecke <simon.giesecke@gmail.com>
Date:   Sun Sep 6 19:21:15 2020 +0200

    Merge pull request #4032 from bluca/fuzzers

    Problem: no fuzzing coverage for ZMQ_STREAM

commit e708623c12e3179c5dpbcc5005a56e0b44ac7ecf
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Sep 5 18:05:22 2020 +0100

    Problem: no fuzzing coverage for ZMQ_STREAM

    Solution: add tests

 Makefile.am                          |  28 ++++++++
 tests/test_bind_stream_fuzzer.cpp    | 132 +++++++++++++++++++++++++++++++++++
 tests/test_connect_stream_fuzzer.cpp | 117 +++++++++++++++++++++++++++++++
 3 files changed, 277 insertions(+)

commit cbce0cbffed81b8dp57e8f1e9108af6d62ef2bd1
Merge: 04ac547c 2741e933
Author: Doron Somech <somdoron@gmail.com>
Date:   Sat Sep 5 15:03:07 2020 +0300

    Merge pull request #4031 from sigiesec/test-coverage-3

    Some more test coverage for invalid IPC addresses

commit 2741e93361d575188cc6702ecf6ce65b42da85db
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Sat Sep 5 13:16:59 2020 +0200

    Problem: no test for (invalid) too long ipc endpoint name

    Solution: add test

 tests/test_pair_ipc.cpp | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 90d5cf29d81c55cfa3f256fcf275c3dd35b6662f
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Sat Sep 5 13:10:59 2020 +0200

    Problem: no test for (invalid) empty abstract ipc endpoint name

    Solution: add test

 tests/test_abstract_ipc.cpp | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 04ac547c20ff0a74801fb97009df4d746225d5c8
Merge: 446d61a1 6a457370
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Sep 4 16:24:28 2020 +0100

    Merge pull request #4030 from sigiesec/test-coverage-3

    Problem: code duplicated between handshake and out_event

commit 446d61a13b95b7aaa1881779f4d6771fc1235d18
Merge: e7974c3b af7df64a
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Sep 4 15:51:33 2020 +0100

    Merge pull request #4029 from sigiesec/test-coverage-2

    Add test covering tcp_address_mask_t and remove unused code

commit 6a4573707395c26ef56e29f59f4cf45dad61e7ed
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 16:16:38 2020 +0200

    Problem: code duplicated between handshake and out_event

    Solution: extract do_handshake member function

 src/wss_engine.cpp | 33 ++++++++++++---------------------
 src/wss_engine.hpp |  3 ++-
 2 files changed, 14 insertions(+), 22 deletions(-)

commit af7df64dp78e939546b7c0093873995507d8c397
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 15:24:24 2020 +0200

    Problem: mask and to_string member functions of tcp_address_mask_t are not referenced

    Solution: remove them

 src/tcp_address.cpp | 52 ----------------------------------------------------
 src/tcp_address.hpp |  5 -----
 2 files changed, 57 deletions(-)

commit c6301206dc6693deb0dafd9a7e762cb72b7c9c30
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 10:57:26 2020 +0200

    Problem: no tests for ZMQ_TCP_ACCEPT_FILTER

    Solution: add some tests

 Makefile.am                      |   7 +-
 tests/CMakeLists.txt             |   1 +
 tests/test_tcp_accept_filter.cpp | 215 +++++++++++++++++++++++++++++++++++++++
 3 files changed, 222 insertions(+), 1 deletion(-)

commit e7974c3b72355a37b982fe937574a72d52838112
Merge: 9c180155 3033b1ef
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Fri Sep 4 11:07:16 2020 +0100

    Merge pull request #4028 from sigiesec/test-coverage

    Some improvements to the test coverage job

commit 3033b1ef18bf4e0a44e4b68bdbad14762783fb59
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 10:56:09 2020 +0200

    Problem: coverage build is using old distro

    Solution: update to default distro

 .travis.yml | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit eb7b7db05d50adb90fcdf5067a6947f94d894869
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 10:40:50 2020 +0200

    Problem: assert used instead of zmq_assert

    Solution: replace by zmq_assert

 src/ws_listener.cpp |  6 +++---
 src/wss_engine.cpp  | 16 ++++++++--------
 2 files changed, 11 insertions(+), 11 deletions(-)

commit bafd626dff549341f385e0f98352296b445bb384
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 10:23:37 2020 +0200

    Problem: coverage build script doesn't recognize several config options

    Solution: extrace and reuse regular config option setting

 builds/coverage/ci_build.sh | 22 ++-------------
 ci_build.sh                 | 67 ++-----------------------------------------
 config.sh                   | 69 +++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 74 insertions(+), 84 deletions(-)

commit 74543a921c062de8ddd031b3bcb64ee135f13616
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 10:00:40 2020 +0200

    Problem: coverage report includes irrelevant files

    Solution: properly set file filter to only include files in src except tweetnacl

 builds/coverage/ci_build.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1d62d7c94aac76a46e870d09ccbb93766c09d00d
Author: Simon Giesecke <sgiesecke@mozilla.com>
Date:   Fri Sep 4 09:36:16 2020 +0200

    Problem: coverage is not measured with all features

    Solution: enable all features on coverage build

 .travis.yml | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 9c1801554fcc4ce9888bf536fe60adf8d3fb03e0
Merge: 9fe56b17 883d432c
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Wed Sep 2 10:33:40 2020 +0100

    Merge pull request #4027 from ffontaine/master

    configure.ac: fix build with openpgm-5-3-128

commit 883d432c29fe5b81b2b4a6809610c60083571fb4
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Wed Sep 2 07:54:36 2020 +0200

    configure.ac: fix build with openpgm-5-3-128

    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

 configure.ac | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

commit 9fe56b175dff42baaa55963117dac70e5a270272
Merge: 8cc56d9f 97f82741
Author: Doron Somech <somdoron@gmail.com>
Date:   Sun Aug 23 16:21:27 2020 +0300

    Merge pull request #4023 from bluca/fuzzers

    Problem: setsockopt of CURVE key ignores parameter length

commit 97f82741293c67cc0ba9c343456e9ea0dde00055
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Aug 23 13:47:07 2020 +0100

    Problem: setsockopt of CURVE key ignores parameter length

    Solution: create std::string using length to avoid overflow

 src/options.cpp | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 8cc56d9f0f2f36fad30d7b48775fffc1715ad02a
Merge: 241240b7 5b0956c3
Author: Luca Boccassi <luca.boccassi@gmail.com>
Date:   Sat Aug 22 21:54:46 2020 +0100

    Merge pull request #4022 from bluca/fuzzers

    Problem: test_socket_options_fuzzer does not work

commit 5b0956c38198652c3ab41d325e93cd89a076635f
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 18:07:00 2020 +0100

    Problem: test_socket_options_fuzzer does not work

    Solution: fix it

 tests/test_socket_options_fuzzer.cpp | 37 ++++++++++++++++++++----------------
 1 file changed, 21 insertions(+), 16 deletions(-)

commit 2fb04c101823bbecc31ce2f9d253eeafbba1b92f
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Aug 22 17:00:57 2020 +0100

    Problem: ZMQ_METADATA setsockopt ignores length and assumes nUL-terminated string

    Solution: use length too

 src/options.cpp | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 241240b79f5fc74cd0a312f34ce4f300149fdp8e
Merge: 36dc251e 6386bc13
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Aug 21 18:38:54 2020 +0300

    Merge pull request #4020 from bluca/fuzz_options

    Problem: test_socket_options_fuzzer can pass non-NUL terminated data …

commit 6386bc13d33ef1bdd2bad92a414a05486eaacd6b
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 16:23:24 2020 +0100

    Problem: test_socket_options_fuzzer can pass non-NUL terminated data buffers

    Solution: ensure they are valid strings

 tests/test_socket_options_fuzzer.cpp | 3 +++
 1 file changed, 3 insertions(+)

commit 36dc251ed0e62e074c69e4b66694d27c03d552dd
Merge: f447169e b84e1646
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Aug 21 18:08:43 2020 +0300

    Merge pull request #4019 from bluca/fuzz_options

    Problem: zmq_z85_decode doesn't check its input length

commit b84e164698930a8b3d1565d200d8e79b044a942a
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 16:03:17 2020 +0100

    Problem: zmq_z85_decode doesn't check its input length

    Solution: do it

 NEWS              | 3 +++
 src/zmq_utils.cpp | 5 +++++
 2 files changed, 8 insertions(+)

commit f447169e8252f24370e4fdb068afb74cde4df1c4
Merge: eecd7961 f43013a7
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Aug 21 18:01:24 2020 +0300

    Merge pull request #4018 from bluca/fuzz_options

    Problem: no fuzz testing for options

commit f43013a7d13d1edd720daad17beea2b4c68447fc
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 15:25:53 2020 +0100

    Problem: no fuzz testing for options

    Solution: add it

 Makefile.am                          | 18 +++++++-
 tests/test_socket_options_fuzzer.cpp | 90 ++++++++++++++++++++++++++++++++++++
 2 files changed, 106 insertions(+), 2 deletions(-)

commit eecd7961061028be826eb0392fa264454a3d6205
Merge: 700fd13c 64a575ee
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Aug 21 16:41:40 2020 +0300

    Merge pull request #4017 from bluca/news

    Problems: build broken on Solaris, NEWS out of date

commit 64a575eededa331f73d11b04fb315d031e58c37a
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 14:13:08 2020 +0100

    Problem: test_bind_ws_fuzzer needs DRAFT sockets

    Solution: use ZMQ_DEALER instead

 tests/test_bind_ws_fuzzer.cpp | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a4dbdb614ec7d36dafd17e631bcf5996e5ec0b25
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 14:01:17 2020 +0100

    Problem: some platforms do not have strnlen

    Solution: move compat redefinition to compat.hpp header so that
    it can be used from msg.cpp

 CMakeLists.txt         |  1 +
 Makefile.am            |  1 +
 builds/gyp/project.gyp |  1 +
 src/compat.hpp         | 73 ++++++++++++++++++++++++++++++++++++++++++++++++++
 src/ipc_address.cpp    | 13 +--------
 src/msg.cpp            |  1 +
 src/ws_engine.cpp      | 25 +----------------
 7 files changed, 79 insertions(+), 36 deletions(-)

commit d40c79cef44836ecbad619b9573d529b4cdded5a
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 14:08:51 2020 +0100

    Problem: missing items in NEWS

    Solution: add them

 NEWS | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 700fd13cadce113739c2a7564012ad2f42640b35
Merge: 29f5ede6 7f1e219d
Author: Doron Somech <somdoron@gmail.com>
Date:   Fri Aug 21 14:51:51 2020 +0300

    Merge pull request #4016 from bluca/news

    Problem: NEWS out of date

commit 7f1e219d0947b29816e9e5ba70a4dp7045cdf163
Author: Luca Boccassi <bluca@debian.org>
Date:   Fri Aug 21 12:05:39 2020 +0100

    Problem: NEWS out of date

    Solution: add latest entries

 NEWS | 23 ++++++++++++++++++++---
 1 file changed, 20 insertions(+), 3 deletions(-)

commit 29f5ede68463b3b3af4fb8ce5b884ce5db60e24a
Merge: d280c44f b02bdd56
Author: Doron Somech <somdoron@gmail.com>
Date:   Mon Aug 17 06:53:52 2020 +0300

    Merge pull request #4013 from bluca/fuzzers

    Problem: ws_engine leaks memory if Sec-WebSocket-Protocol header pass…

commit b02bdd566a6552fd942afb89ecf89e39283d64ad
Author: Luca Boccassi <bluca@debian.org>
Date:   Sun Aug 16 22:33:40 2020 +0100

    Problem: ws_engine leaks memory if Sec-WebSocket-Protocol header passed multiple times

    Solution: ensure it's passed only once

 src/ws_engine.cpp | 4 ++++
 1 file changed, 4 insertions(+)

commit d280c44fe00092d240f4da19b1247124069371c7
Merge: 1412078d c733067d
Author: Doron Somech <somdoron@gmail.com>
Date:   Sat Aug 15 17:06:58 2020 +0300

    Merge pull request #4011 from bluca/fuzzers

    Problem: use-after-free in WS

commit c733067d6d52acc8031792316c0ee58990cdd0e8
Author: Luca Boccassi <bluca@debian.org>
Date:   Sat Aug 15 14:30:33 2020 +0100

    Problem: use-after-free in WS

    Solution: bail out of the stream engine out_event if ws_engine raises
    an error

 src/stream_engine_base.cpp | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit 1412078db61aac7eead02520ce75940c1ad13359
Merge: 87ee1064 110551d5
Author: Doron Somech <somdoron@gmail.com>
Date:   Sat Aug 15 14:59:30 2020 +0300

    Merge pull request #4010 from bluca/fuzzers

